<?php

define("SHIPPINGZABANTECART_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// { $Revision$ }
// { $File$ }

// Function for checking Include Files
function Check_Include_File($filename, $mage_check=0)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		if($mage_check)
		{
			echo "\"$filename\" is not accessible.<br><br>";
			echo "Please, place all ShippingZ PHP files which are listed below at root folder of your Joomla website.<br>";
			echo "-ShippingZAbantecart.php<br>";
			echo "-ShippingZSettings.php<br>";
			echo "-ShippingZClasses.php<br>";
			echo "-ShippingZMessages.php<br>";
		}
		else
		{
			echo "\"$filename\" is not accessible.";
		}
		exit;
	}

}
// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");

// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZABANTECART_VERSION && SHIPPINGZABANTECART_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZAbantecart.php [".SHIPPINGZABANTECART_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}
################################################ Function convert_dim_unit #######################
//converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	if($from_unit=="inches")
	$from_unit="in";
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_unit=strtoupper($from_unit);
	}
	else 
	{
	
		$converted_unit="Unknown";
	}
	
	return $converted_unit;
}
################################################# Include required abantecart file ##########################################
$root_path = dirname(__FILE__);
// Windows IIS Compatibility  
if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
	define('IS_WINDOWS', true);
	$root_path = str_replace('\\', '/', $root_path);
}

define('DIR_ROOT', $root_path);
define('DIR_CORE', DIR_ROOT . '/core/');
if(Check_Include_File(DIR_ROOT . '/system/config.php'))
require (DIR_ROOT . '/system/config.php');

$db_pdo=new PDO("mysql:host=".DB_HOSTNAME.";dbname=".DB_DATABASE, DB_USERNAME, DB_PASSWORD);

############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");
############################################## Class ShippingZAbantecart ##########################################
class ShippingZAbantecart extends ShippingZGenericShoppingCart
{
	
	// Cart specific functions goes here
	############################################## Function Check_DB_Access #################################
	// Check Database access
	#######################################################################################################
	function Check_DB_Access()
	{
		
		global $db_pdo;
		
		$query="Show columns FROM ".DB_PREFIX."orders ";
		$order_status = $db_pdo->prepare($query);										
		$order_status->execute();
			
		if ($order_status->rowCount()) 
		{
			$this->display_msg=DB_SUCCESS_MSG;
			
		}
		else
		{
			$this->display_msg=$this->display_msg='Error occurred:'.implode(":",$order_status->errorInfo());
		}		
			
	}
	
	
	############################################## Function GetOrderCountByDate #################################
	// Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		global $db_pdo;
		
		$order_status_filter=$this->PrepareAbantecartOrderStatusFilter();
			
		$datefrom_timestamp=$this->GetServerTimeLocal(true,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(true,$dateto);
		
		$sql = "SELECT order_id FROM ".DB_PREFIX."orders ";
		$sql .= " WHERE " . $order_status_filter . "";
		$sql .= " ((date_modified between ".$db_pdo->quote($datefrom_timestamp )." and ".$db_pdo->quote($dateto_timestamp).") OR  (date_added between ".$db_pdo->quote($datefrom_timestamp )." and ".$db_pdo->quote($dateto_timestamp)." ))";
		
		$result=$db_pdo->prepare($sql);										
		$result->execute();
		$num_rows = $result->rowCount();
			
		return $num_rows;
	
	}
	############################################## Function UpdateShippingInfo #################################
	// Update order status
	############################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $db_pdo;
		
		
		$sql = "SELECT order_status_id FROM ".DB_PREFIX."orders WHERE order_id=".$db_pdo->quote($OrderNumber);
		$result=$db_pdo->prepare($sql);
		$result->execute();
		$num_rows = $result->rowCount();
		
		// Check if order number is valid
		if($num_rows>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			$tracking_url="";	
			if($Carrier!="")
			{
				if(defined(strtoupper($Carrier)."_URL"))
				{
					$temp_url=constant(strtoupper($Carrier)."_URL");
					$tracking_url=" <a href=\"".$temp_url."\" target=\"_blank\"> $TrackingNumber</a>";
					$tracking_url=str_replace("[TRACKING_NUMBER]",$TrackingNumber,$tracking_url);
				}
				$Carrier=" via ".$Carrier;
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			if($TrackingNumber!="")
			{
				if($tracking_url!="")
				{
					$TrackingNumberString=", Tracking number $tracking_url";
				}
				else
				{
					$TrackingNumberString=", Tracking number $TrackingNumber";
				}
			}
					
			foreach ($result as $order_row)
			{
				$current_order_status=$this->Check_Field($order_row,'order_status_id');
			}
			
			
								
			// Prepare $comments & save it
			$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
			
			if(ABANTECART_SHIPPED_STATUS_SET_TO_STATUS_4_COMPLETEd==1)
			{
				
				 $upate_order_history_sql="insert into ".DB_PREFIX."order_history (order_id, order_status_id,date_added,date_modified, notify,  comment)  values (".$db_pdo->quote($OrderNumber).", '5',".$db_pdo->quote(date("Y-m-d H:i:s")).",".$db_pdo->quote(date("Y-m-d H:i:s")).",'0', ".$db_pdo->quote($comments).")";
				 $history_result=$db_pdo->prepare($upate_order_history_sql);
				 $history_result->execute();
				
						  
				// Update order status
				$sql_upd = "Update ".DB_PREFIX."orders set order_status_id='5' where  order_id=".$db_pdo->quote($OrderNumber);			
				$orders_upd_result = $db_pdo->prepare($sql_upd);			
				$orders_upd_result->execute();	  
			 } 
			 else
			 {
			 	
				if($current_order_status=="0")
					$change_order_status="1";
				else if($current_order_status=="1")
					$change_order_status="2";
				else if($current_order_status=="2")
					$change_order_status="3";
				else if($current_order_status=="3")
					$change_order_status="5";
				else
					$change_order_status=$current_order_status;
				
				 $upate_order_history_sql="insert into ".DB_PREFIX."order_history (order_id, order_status_id,date_added,date_modified, notify,  comment)  values (".$db_pdo->quote($OrderNumber).", '5',".$db_pdo->quote(date("Y-m-d H:i:s")).",".$db_pdo->quote(date("Y-m-d H:i:s")).",'0', ".$db_pdo->quote($comments).")";
				 $history_result=$db_pdo->prepare($upate_order_history_sql);
				 $history_result->execute();
				
						  
				if($change_order_status!=$current_order_status)
				{
					// Update order status
					$sql_upd = "Update ".DB_PREFIX."orders set order_status_id='".$change_order_status."' where  order_id=".$db_pdo->quote($OrderNumber);			
					$orders_upd_result = $db_pdo->prepare($sql_upd);			
					$orders_upd_result->execute();	  
				 }
			 
			 }
			
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			// Display error message
			$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		}	
	}
	############################################## Function Fetch_DB_Orders #################################
	// Fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $db_pdo;
		
		$order_status_filter=$this->PrepareAbantecartOrderStatusFilter();
		
		$datefrom=$this->GetServerTimeLocal(true,$datefrom);
		$dateto=$this->GetServerTimeLocal(true,$dateto);		
		
		$sql = "SELECT * FROM ".DB_PREFIX."orders ";
		$sql .= " WHERE " . $order_status_filter . "";
		$sql .= " ((date_modified between ".$db_pdo->quote($datefrom )." and ".$db_pdo->quote($dateto).") OR  (date_added between ".$db_pdo->quote($datefrom )." and ".$db_pdo->quote($dateto)." ))";
		
		$order_data=$db_pdo->prepare($sql);										
			
		$order_data->execute();
					
		$this->abantecart_orders=array();
		$counter=0;
		
		  foreach ($order_data as $abantecart_orders_row)
		  {
			
			$dim_unit="";
		
		   // Prepare order array
			$this->abantecart_orders[$counter]=new stdClass();
			$this->abantecart_orders[$counter]->orderid=$this->Check_Field($abantecart_orders_row,'order_id');
		    
			// Shipping details		
			$this->abantecart_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field($abantecart_orders_row,'shipping_firstname');
			$this->abantecart_orders[$counter]->order_shipping["LastName"]=$this->Check_Field($abantecart_orders_row,'shipping_lastname');
			$this->abantecart_orders[$counter]->order_shipping["Company"]=$this->Check_Field($abantecart_orders_row,'shipping_company');
			$this->abantecart_orders[$counter]->order_shipping["Address1"]=$this->Check_Field($abantecart_orders_row,'shipping_address_1');			
			$this->abantecart_orders[$counter]->order_shipping["Address2"]=$this->Check_Field($abantecart_orders_row,'shipping_address_2');
			$this->abantecart_orders[$counter]->order_shipping["City"]=$this->Check_Field($abantecart_orders_row,'shipping_city');	
			$this->abantecart_orders[$counter]->order_shipping["State"]=$this->Check_Field($abantecart_orders_row,'shipping_zone');	
			$this->abantecart_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field($abantecart_orders_row,'shipping_postcode');	
			$this->abantecart_orders[$counter]->order_shipping["Country"]=$this->Check_Field($abantecart_orders_row,'shipping_country');		
			$this->abantecart_orders[$counter]->order_shipping["Phone"]=$this->Check_Field($abantecart_orders_row,'telephone');
			$this->abantecart_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($abantecart_orders_row,'email');
			
			
			// Billing details
			$this->abantecart_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($abantecart_orders_row,'payment_firstname');
			$this->abantecart_orders[$counter]->order_billing["LastName"]=$this->Check_Field($abantecart_orders_row,'payment_lastname');
			$this->abantecart_orders[$counter]->order_billing["Company"]=$this->Check_Field($abantecart_orders_row,'payment_company');
			$this->abantecart_orders[$counter]->order_billing["Address1"]=$this->Check_Field($abantecart_orders_row,'payment_address_1');			
			$this->abantecart_orders[$counter]->order_billing["Address2"]=$this->Check_Field($abantecart_orders_row,'payment_address_2');
			$this->abantecart_orders[$counter]->order_billing["City"]=$this->Check_Field($abantecart_orders_row,'payment_city');	
			$this->abantecart_orders[$counter]->order_billing["State"]=$this->Check_Field($abantecart_orders_row,'payment_zone');	
			$this->abantecart_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($abantecart_orders_row,'payment_postcode');	
			$this->abantecart_orders[$counter]->order_billing["Country"]=$this->Check_Field($abantecart_orders_row,'payment_country');		
			$this->abantecart_orders[$counter]->order_billing["Phone"]=$this->Check_Field($abantecart_orders_row,'telephone');
			$this->abantecart_orders[$counter]->order_billing["EMail"]=$this->Check_Field($abantecart_orders_row,'email');			
					
			// Order info
			$order_date_actual = new DateTime($this->Check_Field($abantecart_orders_row,'date_added'));
			$this->abantecart_orders[$counter]->order_info["OrderDate"]=$order_date_actual->format('Y-m-d\TH:i:00\Z');
			$this->abantecart_orders[$counter]->order_info["OrderNumber"]=$this->Check_Field($abantecart_orders_row,'order_id');	;		
			$this->abantecart_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->Check_Field($abantecart_orders_row,'payment_method'));
			
					
			// Get shipping charges
			$this->abantecart_orders[$counter]->order_info["ShipMethod"]=$this->Check_Field($abantecart_orders_row,'shipping_method');
			$sql_order_shipping = "SELECT ".DB_PREFIX."order_totals.* FROM ".DB_PREFIX."order_totals where type='shipping' and order_id=:order_id";			
			$order_shipping_result = $db_pdo->prepare($sql_order_shipping);			
			$data_shipping=array(':order_id' => $this->Check_Field($abantecart_orders_row,'order_id'));			
			$order_shipping_result->execute($data_shipping);
			$product_weight_unit="";
			foreach ($order_shipping_result as $order_shipping_row) 
			{
				$this->abantecart_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($this->Check_Field($order_shipping_row,'value'),2,'.','');
			}
			
			
			// Extract tax amount
			$tax_amount=0;
			$sql_order_tax = "SELECT ".DB_PREFIX."order_totals.* FROM ".DB_PREFIX."order_totals where type='tax' and order_id=:order_id";			
			$order_tax_result = $db_pdo->prepare($sql_order_tax);			
			$data_tax=array(':order_id' => $this->Check_Field($abantecart_orders_row,'order_id'));			
			$order_tax_result->execute($data_tax);
			$product_weight_unit="";
			foreach ($order_tax_result as $order_tax_row) 
			{
				$tax_amount=$this->Check_Field($order_tax_row,'value');	
			}
			$this->abantecart_orders[$counter]->order_info["ItemsTax"]=$tax_amount;
							
			// Payment Status		
			if($this->Check_Field($abantecart_orders_row,'order_status_id')!="0" && $this->Check_Field($abantecart_orders_row,'order_status_id')!="1")
				$this->abantecart_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->abantecart_orders[$counter]->order_info["PaymentStatus"]=0;
			
			// Order status	
			if($this->Check_Field($abantecart_orders_row,'order_status_id')!="3" && $this->Check_Field($abantecart_orders_row,'order_status_id')!="5")
				$this->abantecart_orders[$counter]->order_info["IsShipped"]=0;
			else
				$this->abantecart_orders[$counter]->order_info["IsShipped"]=1;
				
			if($this->Check_Field($abantecart_orders_row,'order_status_id')=="7")
				$this->abantecart_orders[$counter]->order_info["IsCancelled"]=1;
			else
				$this->abantecart_orders[$counter]->order_info["IsCancelled"]=0;
			
			//Get Customer Comments
			$this->abantecart_orders[$counter]->order_info["Comments"]=$this->Check_Field($abantecart_orders_row,'comment');
			
			//Get order products
			$items_cost=0;		
			
			$sql_product='SELECT op.order_product_id,op.name,op.model,op.price as item_price,op.quantity as purchased_qty,op.sku,op.tax, p.*  from '.DB_PREFIX.'order_products op, '.DB_PREFIX.'products  p where op.order_id='.$this->abantecart_orders[$counter]->orderid.' and op.product_id=p.product_id';
						
			$i=0;
			$product_result_arr=$db_pdo->prepare($sql_product);			
		    $product_result_arr->execute();
			
			$uom_weight="";
			$product_weight=0;
			
			foreach ($product_result_arr as $product_row) 
			{	
				
				$unit_price=$this->Check_Field($product_row,'item_price');
				$this->abantecart_orders[$counter]->order_product[$i]["Price"]=$this->FormatNumber($unit_price);
				$this->abantecart_orders[$counter]->order_product[$i]["ExternalID"]=$this->Check_Field($product_row,'sku');
				$this->abantecart_orders[$counter]->order_product[$i]["Quantity"]=$this->Check_Field($product_row,'purchased_qty');		
						
				$this->abantecart_orders[$counter]->order_product[$i]["Total"]=$this->FormatNumber($unit_price*$this->Check_Field($product_row,'purchased_qty'));				
				$items_cost=$items_cost+$this->abantecart_orders[$counter]->order_product[$i]["Total"];
								
				if($this->Check_Field($product_row,'weight')>0)
				{
					$sql = "SELECT ".DB_PREFIX."weight_class_descriptions.* FROM ".DB_PREFIX."weight_class_descriptions where weight_class_id=:weight_class_id";			
					$weight_class_result = $db_pdo->prepare($sql);			
					$data=array(':weight_class_id' => $this->Check_Field($product_row,'weight_class_id'));			
					$weight_class_result->execute($data);
					$product_weight_unit="";
					foreach ($weight_class_result as $weight_class_row) 
					{
						$product_weight_unit=$this->Check_Field($weight_class_row,'unit');	
					}
					$total_weight_with_unit=$this->ConvertToAcceptedUnitWeight($this->Check_Field($product_row,'weight')*$this->Check_Field($product_row,'purchased_qty'),$product_weight_unit);
					
					$this->abantecart_orders[$counter]->order_product[$i]["IndividualProductWeight"]=number_format($this->Check_Field($product_row,'weight')*$this->Check_Field($product_row,'purchased_qty'),2,'.','');
							
					$total_weight_with_unit=explode("~",$total_weight_with_unit);
					if(is_numeric($total_weight_with_unit[0]))
					{
						$uom_weight=$total_weight_with_unit[1];
						$this->abantecart_orders[$counter]->order_product[$i]["Total_Product_Weight"]=number_format($total_weight_with_unit[0],2,'.','');	
					}				
					
					
				}
				
				//product options
				$sql = "SELECT ".DB_PREFIX."order_options.* FROM ".DB_PREFIX."order_options where order_product_id=:order_product_id";			
				$orders_options_result = $db_pdo->prepare($sql);			
				$data=array(':order_product_id' => $this->Check_Field($product_row,'order_product_id'));			
				$orders_options_result->execute($data);
				$product_option="";
				foreach ($orders_options_result as $option_row) 
				{
					if($product_option!="")
					$product_option.=",";
					
					$product_option.=$this->Check_Field($option_row,'name').":".$this->Check_Field($option_row,'value');	
				}	
				
				if($product_option!="")
				$this->abantecart_orders[$counter]->order_product[$i]["Name"]=$this->Check_Field($product_row,'name')."~".$product_option;
				else		
				$this->abantecart_orders[$counter]->order_product[$i]["Name"]=$this->Check_Field($product_row,'name');
				
				//product dimention
				if($this->Check_Field($product_row,'length')>0)
				{
					$this->abantecart_orders[$counter]->order_product[$i]['ItemLength']=$this->Check_Field($product_row,'length');
					$this->abantecart_orders[$counter]->order_product[$i]['ItemWidth']=$this->Check_Field($product_row,'width');
					$this->abantecart_orders[$counter]->order_product[$i]['ItemHeight']=$this->Check_Field($product_row,'height');	
					
					$product_length_unit="";
					$sql = "SELECT ".DB_PREFIX."length_class_descriptions.* FROM ".DB_PREFIX."length_class_descriptions where length_class_id=:length_class_id";			
					$length_class_result = $db_pdo->prepare($sql);			
					$data=array(':length_class_id' => $this->Check_Field($product_row,'length_class_id'));			
					$length_class_result->execute($data);
					$product_length_unit="";
					foreach ($length_class_result as $length_class_row) 
					{
						$product_length_unit=$this->Check_Field($length_class_row,'unit');	
					}
					
					if($product_length_unit!="")
					$dim_unit=convert_dim_unit($product_length_unit);				
			    }			
				
				
				$i++;
			}
			
			$this->abantecart_orders[$counter]->num_of_products=$i;			
			$this->abantecart_orders[$counter]->order_info["ItemsTotal"]=$this->FormatNumber($items_cost,2);	
			$this->abantecart_orders[$counter]->order_info["ItemsTax"]=$this->FormatNumber($this->abantecart_orders[$counter]->order_info["ItemsTax"],2);	
			$this->abantecart_orders[$counter]->order_info["Total"]=$this->FormatNumber($this->Check_Field($abantecart_orders_row,'total'));			
			$this->abantecart_orders[$counter]->order_info["UOMWeight"]=strtoupper($uom_weight);
			if($dim_unit!="")
			$this->abantecart_orders[$counter]->order_info["UnitsOfMeasureLinear"]=$dim_unit;	
				
			$counter++;
			
			
			}//end foreach
			
			
		}

	
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->abantecart_orders))
				return $this->abantecart_orders;
			else
               return array();  

			
	}
	############################################## Function Check_Field #################################
		//Check & Return field value if available
		#######################################################################################################
		function Check_Field($arr,$field)
		{
			if(isset($arr[$field]))
			{
				
				return $arr[$field];
							
			}
			else
			{
				return "";
			}
			
		}
	  
	  

	#######################################################################################################
	############################################### Function PrepareOrderStatusString #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareAbantecartOrderStatusFilter()
	{

					$order_status_filter="";
					
					if(ABANTECART_RETRIEVE_ORDER_STATUS_0_INCOMPLETE==1)
					{
						$order_status_filter=" order_status_id='0' ";
					
					}
					if(ABANTECART_RETRIEVE_ORDER_STATUS_1_PENDING==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='1'";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='1'  ";
						}
					
					}
					if(ABANTECART_RETRIEVE_ORDER_STATUS_2_PROCESSING==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='2'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='2'  ";
						}
					
					}
					
					if(ABANTECART_RETRIEVE_ORDER_STATUS_3_SHIPPED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='3'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='3'  ";
						}
					
					}
					
					if(ABANTECART_RETRIEVE_ORDER_STATUS_4_COMPLETED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='5'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='5'  ";
						}
					
					}
					
					if(ABANTECART_RETRIEVE_ORDER_STATUS_5_CANCELLED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='7'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='7'  ";
						}
					
					}
					
					if($order_status_filter!="")
					$order_status_filter="( ".$order_status_filter." ) and";
					
			
			return $order_status_filter;
			
	}
	
	
}
######################################### End of class ShippingZAbantecart ###################################################
	
	//create object & perform tasks based on command
	$obj_shipping_abantecart=new ShippingZAbantecart;
	$obj_shipping_abantecart->ExecuteCommand();	

?>
