<?php

define("SHIPPINGZCRAFTCOMMERCE_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// { $Revision$ }
// { $File$ }

//Function for checking Include Files
function Check_Include_File($filename, $mage_check=0)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		if($mage_check)
		{
			echo "\"$filename\" is not accessible.<br><br>";
			echo "Please, place all ShippingZ PHP files which are listed below at root folder of your Joomla website.<br>";
			echo "-ShippingCraftCommercer.php<br>";
			echo "-ShippingZSettings.php<br>";
			echo "-ShippingZClasses.php<br>";
			echo "-ShippingZMessages.php<br>";
		}
		else
		{
			echo "\"$filename\" is not accessible.";
		}
		exit;
	}

}
//Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");

// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZCRAFTCOMMERCE_VERSION && SHIPPINGZCRAFTCOMMERCE_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingCraftCommercer.php [".SHIPPINGZCRAFTCOMMERCE_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

//Include reqired Craft files
if(file_exists(CRAFT_PATH."/app/bootstrap.php"))
{
	include(CRAFT_PATH."/app/bootstrap.php");
}
else
{

	//Include reqired Craft files
	define('CRAFT_BASE_PATH', dirname(__DIR__));
	define('CRAFT_VENDOR_PATH', CRAFT_BASE_PATH.'/vendor');
	
	// Load Composer's autoloader
	require_once CRAFT_VENDOR_PATH.'/autoload.php';
	
	
	if (class_exists('Dotenv\Dotenv') && file_exists(CRAFT_BASE_PATH.'/.env')) {
	  //(new Dotenv\Dotenv(CRAFT_BASE_PATH))->load();
	    Dotenv\Dotenv::create(CRAFT_BASE_PATH)->load();
	 }
	
	// Load Craft
	define('CRAFT_ENVIRONMENT', getenv('ENVIRONMENT') ?: 'production');
	
	$app = require CRAFT_VENDOR_PATH.'/craftcms/cms/bootstrap/web.php';
	
}

//craft commerce table prefix
$table_prefix=$app->db->tablePrefix;
############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");
############################################## Class ShippingCraftCommercer ##########################################
class ShippingCraftCommerce extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	############################################## Function Check_DB_Access #################################
	//Check Database access
	#######################################################################################################
	function Check_DB_Access()
	{
		
		global $app,$table_prefix;
		
		try //See if we can access craft database
		{
			if(version_compare($app->getVersion(),'3.0.0' ,'>='))
			{ 
				$query = $app->db->createCommand("Select * from ".$app->db->schema->quoteTableName($table_prefix."commerce_orderstatuses")." where 1")->queryAll();;
				$num_rows = count($query);	
			}
			else
			{
				$query = $app->db->createCommand();
				$num_rows = $query->select('*')->from($table_prefix.'commerce_orderstatuses')->queryScalar();
			}
			
			if($num_rows>0)
			$this->display_msg=DB_SUCCESS_MSG;
		}
		catch(Exception $e)
		{
			$this->display_msg="Could not access Craft database";
			$this->SetXmlError(1,$this->display_msg);
			exit;
				
		}
			
	}
	
	################################################ Function ConvertToPound() #######################
	//Converts weight values to pound
	#######################################################################################################
	function ConvertToPound($weight,$from_unit)
	{
		
		$from_unit=trim($from_unit);
		
		if($from_unit=='oz' || $from_unit=='ozs')
		{
			
			$converted_weight=$weight*0.0625;
		}
		else if($from_unit=='kg' || $from_unit=='kgs')
		{
		
			$converted_weight=$weight*2.20462;
		}
		else if($from_unit=='g' || $from_unit=='gm' || $from_unit=='gms')
		{
		
			$converted_weight=$weight*0.0022;
			
		}
		else 
		{
		
			$converted_weight=$weight;
		}
		return $converted_weight;
	}
	################################################ Function convert_dim_unit #######################
	//converts dim unit to desired units
	function convert_dim_unit($from_unit)
	{
		
		$from_unit=trim($from_unit);
		
		if($from_unit=='cm' || $from_unit=='in')
		{
			
			$converted_unit=strtoupper($from_unit);
		}
		else 
		{
		
			$converted_unit="Unknown";
		}
		
		return $converted_unit;
	}
	#################################################### Function get_uuid #####################################
	//generate random uid similar to craft commerce to be used in database insert
	function get_uuid()
	{
		return sprintf('%04x%04x-%04x-%04x-%04x-%04x%04x%04x',

			// 32 bits for "time_low"
			mt_rand(0, 0xffff), mt_rand(0, 0xffff),

			// 16 bits for "time_mid"
			mt_rand(0, 0xffff),

			// 16 bits for "time_hi_and_version", four most significant bits holds version number 4
			mt_rand(0, 0x0fff) | 0x4000,

			// 16 bits, 8 bits for "clk_seq_hi_res", 8 bits for "clk_seq_low", two most significant bits holds zero and
			// one for variant DCE1.1
			mt_rand(0, 0x3fff) | 0x8000,

			// 48 bits for "node"
			mt_rand(0, 0xffff), mt_rand(0, 0xffff), mt_rand(0, 0xffff)
		);
	}
	############################################## Function GetOrderCountByDate #################################
	//Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		global $app,$table_prefix;
		
		$order_status_filter=$this->PrepareCraftCommerceOrderStatusFilter();
			
		$datefrom_timestamp=$this->GetServerTimeLocal(true,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(true,$dateto);
		
		if(version_compare($app->getVersion(),'3.0.0' ,'>='))
		{ 
			$query = $app->db->createCommand('select id from '.$app->db->schema->quoteTableName($table_prefix."commerce_orders").' where '.$order_status_filter.' ('.$table_prefix.'commerce_orders.dateUpdated between '.$app->db->quoteValue($datefrom_timestamp )." and ".$app->db->quoteValue($dateto_timestamp).') OR   ('.$table_prefix.'commerce_orders.dateOrdered between '.$app->db->quoteValue($datefrom_timestamp )." and ".$app->db->quoteValue($dateto_timestamp).')')->queryAll();
		
			$num_rows = count($query);
		}
		else
		{
			$query = $app->db->createCommand();
			
			$num_rows = $query->select('id')->from($table_prefix.'commerce_orders')->where($order_status_filter.' ('.$table_prefix.'commerce_orders.dateUpdated between '.$app->db->getPdoInstance()->quote($datefrom_timestamp )." and ".$app->db->getPdoInstance()->quote($dateto_timestamp).') OR   ('.$table_prefix.'commerce_orders.dateOrdered between '.$app->db->getPdoInstance()->quote($datefrom_timestamp )." and ".$app->db->getPdoInstance()->quote($dateto_timestamp).')')->count('id');
		}
							
		return $num_rows;
	
	}
	############################################## Function UpdateShippingInfo #################################
	//Update order status
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $app,$table_prefix;
		
		if(version_compare($app->getVersion(),'3.0.0' ,'>='))
		{ 
			$result =$app->db->createCommand('select orderStatusId,customerId from '.$app->db->schema->quoteTableName($table_prefix."commerce_orders").' where id='.$app->db->quoteValue($OrderNumber))->queryAll();
			$num_rows = count($result);
		}
		else
		{ 
			$query = $app->db->createCommand();
			$num_rows = $query->select('orderStatusId')->from($table_prefix.'commerce_orders')->where('id='.$app->db->getPdoInstance()->quote($OrderNumber))->count('orderStatusId');
		}
		//check if order number is valid
		if($num_rows>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			$tracking_url="";	
			if($Carrier!="")
			{
				if(defined(strtoupper($Carrier)."_URL"))
				{
					$temp_url=constant(strtoupper($Carrier)."_URL");
					$tracking_url=$temp_url;
					$tracking_url=str_replace("[TRACKING_NUMBER]",$TrackingNumber,$tracking_url);
				}
				$Carrier=" via ".$Carrier;
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			if($TrackingNumber!="")
			{
				if($tracking_url!="")
				{
					$TrackingNumberString=", Tracking number is $TrackingNumber. Tracking url: $tracking_url";
				}
				else
				{
					$TrackingNumberString=", Tracking number $TrackingNumber";
				}
			}
			
			if(version_compare($app->getVersion(),'3.0.0' ,'<'))
			{
				
				$query_data = $app->db->createCommand();
				$result = $query_data->select('*')->from($table_prefix.'commerce_orders')->where('id='.$app->db->getPdoInstance()->quote($OrderNumber))->queryAll();
				$date_created=date('Y-m-d H:i:s');
				$uid=$this->get_uuid();
			}
			else
			{
				$date_created=date('Y-m-d H:i:s');
				$uid=$this->get_uuid();
			}
						
			foreach ($result as $order_row)
			{ 
				$current_order_status=$this->GetFieldNumber($order_row,"orderStatusId");
				$customer_id=$this->GetFieldNumber($order_row,"customerId");
			}
			
										
			//prepare $comments & save it
			$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
			
			//In deafult craft commerce, two types of order statuses are available
			//so change order status always Shipped i.e. 2
			
			$change_order_status=2;
			
			if(version_compare($app->getVersion(),'3.0.0' ,'>='))
		   {
		   	   $app->db->createCommand()->insert($table_prefix.'commerce_orderhistories',  array(
					'prevStatusId'      => $current_order_status,
					'newStatusId'     => $change_order_status,
					'orderId' => $OrderNumber,
					'customerId'     => $customer_id,
					'message'    => $comments,
					'dateCreated'    => $date_created,
					'dateUpdated'    => $date_created,
					'uid'    => $uid,
				))->execute();
				if($change_order_status!=$current_order_status)
				{
				  $app->db->createCommand()->update($table_prefix.'commerce_orders', array('orderStatusId' => $change_order_status), array('id' => $OrderNumber))->execute();
			    }
		   }
		   else
		   {
			     $app->db->createCommand()->insert($table_prefix.'commerce_orderhistories',  array(
					'prevStatusId'      => $current_order_status,
					'newStatusId'     => $change_order_status,
					'orderId' => $OrderNumber,
					'customerId'     => $customer_id,
					'message'    => $comments,
					'dateCreated'    => $date_created,
					'dateUpdated'    => $date_created,
					'uid'    => $uid,
				),false);
				
				if($change_order_status!=$current_order_status)
				{
					$app->db->createCommand()->update($table_prefix.'commerce_orders', array('orderStatusId' => $change_order_status), array('id' => $OrderNumber));
				 }
			}
			
			
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			//display error message
			$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		}	
	}
	############################################## Function Fetch_DB_Orders #################################
	//Fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $app, $table_prefix;
		
		$order_status_filter=$this->PrepareCraftCommerceOrderStatusFilter();
		
		$datefrom_timestamp=$this->GetServerTimeLocal(true,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(true,$dateto);
		
		if(version_compare($app->getVersion(),'3.0.0' ,'>='))
		{
			$order_data = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_orders").' where '.$order_status_filter.' ('.$table_prefix.'commerce_orders.dateUpdated between '.$app->db->quoteValue($datefrom_timestamp )." and ".$app->db->quoteValue($dateto_timestamp).') OR   ('.$table_prefix.'commerce_orders.dateOrdered between '.$app->db->quoteValue($datefrom_timestamp )." and ".$app->db->quoteValue($dateto_timestamp).')')->queryAll();
			
		}
		else
		{
			$query = $app->db->createCommand();
			
			$order_data = $query->select('*')->from($table_prefix.'commerce_orders')->where($order_status_filter.' ('.$table_prefix.'commerce_orders.dateUpdated between '.$app->db->getPdoInstance()->quote($datefrom_timestamp )." and ".$app->db->getPdoInstance()->quote($dateto_timestamp).') OR   ('.$table_prefix.'commerce_orders.dateOrdered between '.$app->db->getPdoInstance()->quote($datefrom_timestamp )." and ".$app->db->getPdoInstance()->quote($dateto_timestamp).')')->queryAll();
		}
		$this->craftcommerce_orders=array();
		$counter=0;
		
		
		foreach ($order_data as $craftcommerce_orders_row)
		{
			
			$billingAddressId=$this->GetFieldNumber($craftcommerce_orders_row,"billingAddressId");
			$shippingAddressId=$this->GetFieldNumber($craftcommerce_orders_row,"shippingAddressId");
			
			if(version_compare($app->getVersion(),'3.0.0' ,'>='))
	     	{
				$billing_address_arr = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_addresses").' where  id='.$app->db->quoteValue($billingAddressId))->queryAll();
				
				$shipping_address_arr = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_addresses").' where  id='.$app->db->quoteValue($shippingAddressId))->queryAll();
			}
			else
			{
				$query_billing = $app->db->createCommand();
				$billing_address_arr = $query_billing->select('*')->from($table_prefix.'commerce_addresses')->where('id='.$app->db->getPdoInstance()->quote($billingAddressId))->queryAll();
				$query_shipping = $app->db->createCommand();
				$shipping_address_arr = $query_shipping->select('*')->from($table_prefix.'commerce_addresses')->where('id='.$app->db->getPdoInstance()->quote($shippingAddressId))->queryAll();
			}
			
			
			//prepare order array
			$this->craftcommerce_orders[$counter]=new stdClass();
			$this->craftcommerce_orders[$counter]->orderid=$this->GetFieldNumber($craftcommerce_orders_row,"id");
				
			//shipping details
			foreach ($shipping_address_arr as $shipping_address)
		   {
				$this->craftcommerce_orders[$counter]->order_shipping["FirstName"]=$this->GetFieldString($shipping_address,"firstName");
				$this->craftcommerce_orders[$counter]->order_shipping["LastName"]=$this->GetFieldString($shipping_address,"lastName");
				$this->craftcommerce_orders[$counter]->order_shipping["Company"]=$this->GetFieldString($shipping_address,"businessName");
				$this->craftcommerce_orders[$counter]->order_shipping["Address1"]=$this->GetFieldString($shipping_address,"address1");		
				$this->craftcommerce_orders[$counter]->order_shipping["Address2"]=$this->GetFieldString($shipping_address,"address2");
				$this->craftcommerce_orders[$counter]->order_shipping["City"]=$this->GetFieldString($shipping_address,"city");
				
				//initialise state
				$this->craftcommerce_orders[$counter]->order_shipping["State"]="";
				
				$state_id=$this->GetFieldString($shipping_address,"stateId");
				
				if(version_compare($app->getVersion(),'3.0.0' ,'>='))
				{
					$shipping_state_arr = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_states").' where  id='.$app->db->quoteValue($state_id))->queryAll();
				}
				else
				{
					$query_shipping_state = $app->db->createCommand();
					$shipping_state_arr = $query_shipping_state->select('*')->from($table_prefix.'commerce_states')->where('id='.$app->db->getPdoInstance()->quote($state_id))->queryAll();
				}
				
				
				foreach ($shipping_state_arr as $shipping_state)
		  		{			
					$this->craftcommerce_orders[$counter]->order_shipping["State"]=$this->GetFieldString($shipping_state,"abbreviation");
				}
				
				$this->craftcommerce_orders[$counter]->order_shipping["PostalCode"]=$this->GetFieldString($shipping_address,"zipCode");	
				
				$country_id=$this->GetFieldString($shipping_address,"countryId");
				
				if(version_compare($app->getVersion(),'3.0.0' ,'>='))
				{
					$shipping_country_arr = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_countries").' where  id='.$app->db->quoteValue($country_id))->queryAll();
				}
				else
				{
					$query_shipping_country = $app->db->createCommand();
					$shipping_country_arr = $query_shipping_country->select('*')->from($table_prefix.'commerce_countries')->where('id='.$app->db->getPdoInstance()->quote($country_id))->queryAll();
				}
				$this->craftcommerce_orders[$counter]->order_shipping["Country"]="";
				foreach ($shipping_country_arr as $shipping_country)
		  		{		
					$this->craftcommerce_orders[$counter]->order_shipping["Country"]=$this->GetFieldString($shipping_country,"iso");
				}
				$this->craftcommerce_orders[$counter]->order_shipping["Phone"]=$this->GetFieldString($shipping_address,"phone");
				$this->craftcommerce_orders[$counter]->order_shipping["EMail"]=$this->GetFieldString($craftcommerce_orders_row,"email");
			}
			//billing details
			foreach ($billing_address_arr as $billing_address)
		   {
				$this->craftcommerce_orders[$counter]->order_billing["FirstName"]=$this->GetFieldString($billing_address,"firstName");
				$this->craftcommerce_orders[$counter]->order_billing["LastName"]=$this->GetFieldString($billing_address,"lastName");
				$this->craftcommerce_orders[$counter]->order_billing["Company"]=$this->GetFieldString($billing_address,"businessName");
				$this->craftcommerce_orders[$counter]->order_billing["Address1"]=$this->GetFieldString($billing_address,"address1");		
				$this->craftcommerce_orders[$counter]->order_billing["Address2"]=$this->GetFieldString($billing_address,"address2");
				$this->craftcommerce_orders[$counter]->order_billing["City"]=$this->GetFieldString($billing_address,"city");
				
				//initialise billing state
				$this->craftcommerce_orders[$counter]->order_billing["State"]="";
				
				$billing_state_id=$this->GetFieldString($billing_address,"stateId");
				
				if(version_compare($app->getVersion(),'3.0.0' ,'>='))
				{
					$billing_state_arr = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_states").' where  id='.$app->db->quoteValue($billing_state_id))->queryAll();
				}
				else
				{
					$query_billing_state = $app->db->createCommand();
					$billing_state_arr = $query_billing_state->select('*')->from($table_prefix.'commerce_states')->where('id='.$app->db->getPdoInstance()->quote($billing_state_id))->queryAll();
				}
				
				foreach ($billing_state_arr as $billing_state)
		        {
				 $this->craftcommerce_orders[$counter]->order_billing["State"]=$this->GetFieldString($billing_state,"abbreviation");
				}
				
				$this->craftcommerce_orders[$counter]->order_billing["PostalCode"]=$this->GetFieldString($billing_address,"zipCode");
				
				$billing_country_id=$this->GetFieldString($billing_address,"countryId");
				
				if(version_compare($app->getVersion(),'3.0.0' ,'>='))
				{
					$billing_country_arr = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_countries").' where  id='.$app->db->quoteValue($billing_country_id))->queryAll();
				}
				else
				{
					$query_billing_country = $app->db->createCommand();
				    $billing_country_arr = $query_billing_country->select('*')->from($table_prefix.'commerce_countries')->where('id='.$app->db->getPdoInstance()->quote($billing_country_id))->queryAll();
				}
				$this->craftcommerce_orders[$counter]->order_billing["Country"]="";
				foreach ($billing_country_arr as $billing_country)
		        {
					$this->craftcommerce_orders[$counter]->order_billing["Country"]=$this->GetFieldString($billing_country,"iso");
				}
				$this->craftcommerce_orders[$counter]->order_billing["Phone"]=$this->GetFieldString($billing_address,"phone");
				$this->craftcommerce_orders[$counter]->order_billing["EMail"]=$this->GetFieldString($craftcommerce_orders_row,"email");
			}
			
			//order info
			$this->craftcommerce_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTC(true,strtotime($this->GetFieldString($craftcommerce_orders_row,"dateCreated")));
			$this->craftcommerce_orders[$counter]->order_info["OrderNumber"]=$this->craftcommerce_orders[$counter]->orderid;
			
			if(version_compare($app->getVersion(),'3.0.0' ,'>='))
			{
				$gatewayId=$this->GetFieldNumber($craftcommerce_orders_row,"gatewayId");
				$payment_method = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_gateways").' where  id='.$app->db->quoteValue($gatewayId))->queryAll();
			}
			else
			{
				$paymentMethodId=$this->GetFieldNumber($craftcommerce_orders_row,"paymentMethodId");
				$query_payment_method = $app->db->createCommand();
				$payment_method = $query_payment_method->select('*')->from($table_prefix.'commerce_paymentmethods')->where('id='.$app->db->getPdoInstance()->quote($paymentMethodId))->queryAll();
			}
			
			$this->craftcommerce_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->GetFieldString($payment_method,"name"));
						
			//get shipping charges
			$this->craftcommerce_orders[$counter]->order_info["ShippingChargesPaid"]=$this->FormatNumber($this->GetFieldNumber($craftcommerce_orders_row,"baseShippingCost"));
			$this->craftcommerce_orders[$counter]->order_info["ShipMethod"]=$this->GetFieldString($craftcommerce_orders_row,"shippingMethod");
			
			if($this->GetFieldString($craftcommerce_orders_row,"paidStatus")=="paid")
				$this->craftcommerce_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->craftcommerce_orders[$counter]->order_info["PaymentStatus"]=0;
			
			//Order status	
			if($this->GetFieldString($craftcommerce_orders_row,"orderStatusId")==2)
				$this->craftcommerce_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->craftcommerce_orders[$counter]->order_info["IsShipped"]=0;
			
			//Get Customer Comments		
			$this->craftcommerce_orders[$counter]->order_info["Comments"]=$this->GetFieldString($craftcommerce_orders_row,"message");
			
			//Get order products
			$items_cost=0;
			
			
			if(version_compare($app->getVersion(),'3.0.0' ,'>='))
			{
				$product_result_arr = $app->db->createCommand('select * from '.$app->db->schema->quoteTableName($table_prefix."commerce_lineitems").','.$app->db->schema->quoteTableName($table_prefix."commerce_purchasables").'  where '.$table_prefix.'commerce_purchasables.id='.$table_prefix.'commerce_lineitems.purchasableId and  '.$table_prefix.'commerce_lineitems.orderId='.$app->db->quoteValue($this->GetFieldNumber($craftcommerce_orders_row,"id")))->queryAll();
			}
			else
			{
				$query_product = $app->db->createCommand();
				$product_result_arr = $query_product->select('*')->from($table_prefix.'commerce_lineitems')->join($table_prefix.'commerce_purchasables',$table_prefix.'commerce_purchasables.id='.$table_prefix.'commerce_lineitems.purchasableId' )->where('orderId='.$app->db->getPdoInstance()->quote($this->GetFieldNumber($craftcommerce_orders_row,"id")))->queryAll();
			}
			
			$i=0;
			$uom_weight="";
			$product_weight=0;
			
			$this->craftcommerce_orders[$counter]->order_info['PkgLength']="";
			$this->craftcommerce_orders[$counter]->order_info['PkgWidth']="";
			$this->craftcommerce_orders[$counter]->order_info['PkgHeight']="";
			$this->craftcommerce_orders[$counter]->order_info["ItemsTax"]=0;
			$dim_unit="";
			
			foreach ($product_result_arr as $product_row) 
			{			
				$unit_price=$this->GetFieldString($product_row,"price");
				$this->craftcommerce_orders[$counter]->order_product[$i]["Price"]=$this->FormatNumber($unit_price);
				$this->craftcommerce_orders[$counter]->order_product[$i]["ExternalID"]=$this->GetFieldString($product_row,"sku");
				$this->craftcommerce_orders[$counter]->order_product[$i]["Quantity"]=$this->GetFieldString($product_row,"qty");
				
				$this->craftcommerce_orders[$counter]->order_product[$i]["Total"]=$this->FormatNumber($unit_price*$this->GetFieldString($product_row,"qty"));
				
				$items_cost=$items_cost+$this->craftcommerce_orders[$counter]->order_product[$i]["Total"];
				
				//get weight & dim units from commerce settings
				if(version_compare($app->getVersion(),'3.0.0' ,'<'))
				{
					
					$query_commerce_settings = $app->db->createCommand();
					$commerce_settings_arr = $query_commerce_settings->select('*')->from($table_prefix.'plugins')->where('class='.$app->db->getPdoInstance()->quote('Commerce'))->queryAll();
					
					foreach ($commerce_settings_arr as $commerce_settings_rows)
					{			
						$commerce_setting_vals=json_decode($this->GetFieldString($commerce_settings_rows,"settings"));
											
						$uom_weight=$commerce_setting_vals->weightUnits;
						$commerce_dim_unit=$commerce_setting_vals->dimensionUnits;
						
					}
				}
				else
				{
					$uom_weight=craft\commerce\Plugin::getInstance()->getSettings()->weightUnits;
					$commerce_dim_unit=craft\commerce\Plugin::getInstance()->getSettings()->dimensionUnits;
				}
				
				$product_weight=$this->ConvertToPound($this->GetFieldString($product_row,"weight"),$uom_weight);
			   				
			    $this->craftcommerce_orders[$counter]->order_product[$i]["Total_Product_Weight"]=$product_weight*$this->GetFieldString($product_row,"qty");
			   			
				$snapshot=json_decode($this->GetFieldString($product_row,"snapshot"));
				
				$option_string="";			
				if(isset($snapshot->options))
				{
					$options=(array)$snapshot->options;
					
					foreach($options as $key1=>$val1)
					{
						if($option_string!="")
						$option_string.=",";
						
						$option_string.=$key1.":".$val1;
					}
				}
				if($option_string!="")
				$option_string=" (".$option_string.")";
				
				if(isset($snapshot->description))
				$this->craftcommerce_orders[$counter]->order_product[$i]["Name"]=$snapshot->description." ".$option_string;
				else
				$this->craftcommerce_orders[$counter]->order_product[$i]["Name"]=$this->GetFieldString($product_row,"sku")." ".$option_string;
				
				if($this->craftcommerce_orders[$counter]->order_info['PkgLength']=="" && $this->GetFieldString($product_row,"length")>0) 
				{
					$this->craftcommerce_orders[$counter]->order_info['PkgLength']=$this->GetFieldString($product_row,"length");
					$this->craftcommerce_orders[$counter]->order_info["PkgWidth"]=$this->GetFieldString($product_row,"width");
					$this->craftcommerce_orders[$counter]->order_info["PkgHeight"]=$this->GetFieldString($product_row,"height");
					$dim_unit=$this->convert_dim_unit($commerce_dim_unit);
				}
				$this->craftcommerce_orders[$counter]->order_product[$i]["IndividualProductWeight"]=number_format($product_weight*$this->GetFieldString($product_row,"qty"),2,'.','');
				
				$i++;
			}
			
			$this->craftcommerce_orders[$counter]->num_of_products=$i;
			
			$this->craftcommerce_orders[$counter]->order_info["ItemsTotal"]=$this->FormatNumber($items_cost,2);
			
			$this->craftcommerce_orders[$counter]->order_info["Total"]=$this->FormatNumber($this->GetFieldNumber($craftcommerce_orders_row,"totalPrice"));
			
			$this->craftcommerce_orders[$counter]->order_info["UOMWeight"]=strtoupper($uom_weight);
			
			//Extract tax amount
			$this->craftcommerce_orders[$counter]->order_info["ItemsTax"]+=$this->FormatNumber($this->GetFieldString($product_row,"tax"));
			
			if($dim_unit!="")
			$this->craftcommerce_orders[$counter]->order_info["UnitsOfMeasureLinear"]=$dim_unit;
						
			$counter++;
			
			
		}//end foreach
		
		
	}

	
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->craftcommerce_orders))
				return $this->craftcommerce_orders;
			else
               return array();  

			
	}
	  
	  

	#######################################################################################################
	############################################### Function PrepareOrderStatusString #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareCraftCommerceOrderStatusFilter()
	{
			global $table_prefix;
			$order_status_filter="";
			
			if(CRAFTCOMMERCE_RETRIEVE_ORDER_STATUS_1_PROCESSING==1)
			{
				$order_status_filter.=$table_prefix."commerce_orders.orderStatusId='1'  ";
									
			}
			if(CRAFTCOMMERCE_RETRIEVE_ORDER_STATUS_2_SHIPPED==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$table_prefix."commerce_orders.orderStatusId='2'  ";
				}
				else
				{
					$order_status_filter.=" OR ".$table_prefix."commerce_orders.orderStatusId='2'  ";
				}
			
			}
			
			
			if($order_status_filter!="")
			$order_status_filter="( ".$order_status_filter." ) and";
					
			
			return $order_status_filter;
			
	}
	
	
}
######################################### End of class ShippingCraftCommerce ###################################################
	
	//create object & perform tasks based on command
	$obj_shipping_craftcommerce=new ShippingCraftCommerce;
	$obj_shipping_craftcommerce->ExecuteCommand();	

?>
