<?php

define("SHIPPINGZCSCART_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

//Function for checking Include Files
function Check_Include_File($filename)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		echo "\"$filename\" is not accessible.";
		exit;
	}

}

//Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");


// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZCSCART_VERSION && SHIPPINGZCSCART_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZCscart.php [".SHIPPINGZCSCART_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

define('AREA', 'A');

// Include required CsCart files
if(file_exists(dirname(__FILE__) . '/prepare.php'))
require dirname(__FILE__) . '/prepare.php';

if(file_exists(dirname(__FILE__) . '/init.php'))
require dirname(__FILE__) . '/init.php';

// Check CsCart Version & Product type
$CSCART_PROFESSIONAL=0;
if (version_compare(PRODUCT_VERSION, '4.0.0', '>='))
$CSCART_ULTIMATE=1; // Always set to 1 for CS-Cart release 4 and up
else
$CSCART_ULTIMATE=0;

if(defined('PRODUCT_EDITION'))
{
	if(strtolower(PRODUCT_EDITION)=="professional")
	$CSCART_PROFESSIONAL=1;
		
	if(strtolower(PRODUCT_EDITION)=="ultimate")
	$CSCART_ULTIMATE=1;
}
else if(defined('PRODUCT_TYPE'))
{
	if(strtolower(PRODUCT_TYPE)=="professional")
	$CSCART_PROFESSIONAL=1;
	
	if(strtolower(PRODUCT_EDITION)=="ultimate")
	$CSCART_ULTIMATE=1;
	
}
define("CSCART_PROFESSIONAL",$CSCART_PROFESSIONAL); 
define("CSCART_ULTIMATE",$CSCART_ULTIMATE); 
 
if(CSCART_PROFESSIONAL==0 && CSCART_ULTIMATE==0) // Only for community editions and CsCart version  < 4
{
	define('AREA', 'C');
	
}
else if(file_exists(dirname(__FILE__) . '/prepare.php')) // For professional editions ( where "prepare.php" exists i.e. CsCart Version < 4 )
{
		// Include required additional files and connect to CsCart DB
		
		// Require configuration
		require(DIR_ROOT . '/config.php');
		
		if (isset($_REQUEST['version'])) {
			die(PRODUCT_NAME . ': version <b>' . PRODUCT_VERSION . ' ' . PRODUCT_TYPE . (PRODUCT_STATUS != '' ? (' (' . PRODUCT_STATUS . ')') : '') . '</b>');
		}
		
		if (isset($_REQUEST['check_https'])) {
			die(defined('HTTPS') ? 'OK' : '');
		}
		
		// Include core functions/classes
		require_once(DIR_CORE . 'db/' . $config['db_type'] . '.php');
		require_once(DIR_CORE . 'fn.database.php');
		require_once(DIR_CORE . 'fn.users.php');
		require_once(DIR_CORE . 'fn.catalog.php');
		require_once(DIR_CORE . 'fn.cms.php');
		require_once(DIR_CORE . 'fn.cart.php');
		require_once(DIR_CORE . 'fn.locations.php');
		require_once(DIR_CORE . 'fn.common.php');
		require_once(DIR_CORE . 'fn.fs.php');
		require_once(DIR_CORE . 'fn.requests.php');
		require_once(DIR_CORE . 'fn.images.php');
		require_once(DIR_CORE . 'fn.init.php');
		require_once(DIR_CORE . 'fn.control.php');
		require_once(DIR_CORE . 'fn.search.php');
		require_once(DIR_CORE . 'fn.promotions.php');
		require_once(DIR_CORE . 'fn.log.php');
		require_once(DIR_CORE . 'fn.companies.php');
		if (in_array(PRODUCT_TYPE, array('PROFESSIONAL', 'MULTIVENDOR', 'MULTISHOP'))) {
			require_once(DIR_CORE . 'editions/fn.pro_functions.php');
		}
		if (in_array(PRODUCT_TYPE, array('MULTIVENDOR', 'MULTISHOP'))) {
			require_once(DIR_CORE . 'editions/fn.mve_functions.php');
		}
		if (PRODUCT_TYPE == 'MULTISHOP') {
			require_once(DIR_CORE . 'editions/fn.mse_functions.php');
		}
		fn_define('ACCOUNT_TYPE', 'customer');
		if(file_exists(DIR_CORE . 'classes/profiler.php')) // ZF Case 31510
		{
			require_once(DIR_CORE . 'classes/profiler.php');
			require_once(DIR_CORE . 'classes/registry.php');
			require_once(DIR_CORE . 'classes/session.php');
		
		}
		else
		{
			require_once(DIR_CORE . 'class.profiler.php');
			require_once(DIR_CORE . 'class.registry.php');
			require_once(DIR_CORE . 'class.session.php');
		}
		
		if(is_array($config))
		{
			// Set configuration options from config.php to registry
			Registry::set('config', $config);
			unset($config);
			
			// Connect to cscart database
			$db_conn = db_initiate(Registry::get('config.db_host'), Registry::get('config.db_user'), Registry::get('config.db_password'), Registry::get('config.db_name'));
		}
}
// Can now access DB with Cscart functions
############################################## Always Enable Exception Handler ############################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");
############################################## Class ShippingZCscart ######################################
class ShippingZCscart extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	var $cscart_orders=array();
	############################################## Function Check_DB_Access ###############################
	//Check Database access
	#######################################################################################################
	
	function Check_DB_Access()
	{
		
     	global $db_conn;
		
		//check if cscart database can be acessed or not
		$shipping = db_get_array('SHOW COLUMNS FROM ?:orders', 'O');
    	if (db_get_found_rows()>0) 
		{
			$this->display_msg=DB_SUCCESS_MSG;
			
		}
		else
		{
			$this->display_msg=DB_ERROR_MSG;
		}
		
	}
	
	############################################## Function GetOrderCountByDate #################################
	//Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		global $db_conn;
		
		$order_status_filter=$this->PrepareCscartOrderStatusFilter();
		
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);
		
		$conditions = db_quote(" AND (".$order_status_filter.")");
		$conditions.= db_quote(" AND (?:orders.timestamp between ?i AND ?i)",$datefrom_timestamp, $dateto_timestamp);
		$vendor_id=$this->GetValues('vendor_id');
		if($vendor_id!="")
		$conditions .= db_quote(" AND (?:orders.company_id IN ( ".$vendor_id."))");
		
		//Get pending order count based on data range			
		$result = db_get_field(  "SELECT COUNT(*) as total_order FROM ?:orders WHERE  1 ?p", $conditions);
		
		return is_array($result) ? $result['total_order'] : $result;
	
	}
	############################################## Function UpdateShippingInfo #################################
	//Update order status
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		$conditions=db_quote(" AND (?:orders.order_id='$OrderNumber')");
		$vendor_id=$this->GetValues('vendor_id');
		if($vendor_id!="")
		$conditions = db_quote(" AND (?:orders.company_id IN ( ".$vendor_id."))");
		
		$sql = "SELECT COUNT(*) as total_order FROM ?:orders WHERE status in('O','P','C') ?p";
		
		$result = db_get_field($sql, $conditions);
		
		$formatted_carrier="";
		//check if order number is valid
		$tot_cnt=is_array($result) ? $result['total_order'] : $result;
		if($tot_cnt>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			$carriersql="";
			
			
			
			if($Carrier!="")
			{
				
				$formatted_carrier=$this->ConverCarrier($Carrier);
				
				$Carrier=" via ".$Carrier;
				
				$carriersql=",carrier='".$formatted_carrier."'";
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			$trackingsql="";
			if($TrackingNumber!="")
			{
				$TrackingNumberString=", Tracking number $TrackingNumber";
				$trackingsql=", tracking_number='".$TrackingNumber."'";
			}
			//get existing order status
			$sql = "SELECT * FROM ?:orders WHERE  order_id='".$OrderNumber."'";
			$result = db_get_array($sql);
			foreach ($result as $rows)
			{
				$current_order_status=$rows['status'];
				$existing_comments=$rows['details'];
				$existing_buyer_comments=$rows['notes'];
				
			}
			//check if gif certificate mass addon 
			$sql_gift = "SELECT * FROM ?:addons WHERE addon like 'gift_certificates_mass' ORDER BY priority";
			$result_gift = db_get_array($sql_gift);
			
			foreach ($result_gift as $row_gift)
			{
				$addon_status=$row_gift['status'];
				if($addon_status=="A" && !function_exists('fn_gift_cert_mass_check_if_giftcert_is_mass'))
				{
					if(file_exists(dirname(__FILE__) . '/addons/gift_certificates_mass/func.php'))
					require_once dirname(__FILE__) . '/addons/gift_certificates_mass/func.php';
				}
				
			}
			  
			//prepare $comments
			if(CSCART_UPDATE_STAFF_NOTES)
			{
				if($existing_comments!="")
				{
					$staff_comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString." ---- ".$existing_comments;
				}
				else
				{
					$staff_comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
				}
			}
			if(CSCART_UPDATE_CUSTOMER_NOTES)
			{
			
				if($existing_buyer_comments!="")
				{
				  $buyer_comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString." ---- ".$existing_buyer_comments;
				}
				else
				{
					$buyer_comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
				}
				 
			} 
			
			
			$order_data="";
			if(CSCART_ULTIMATE)//only for ULTIMATE version
			{
				//get shipping id from cscart database
				$shipping_id=1;
				$org_carrier=trim(str_replace('via ','',$Carrier));
				$org_service=trim(str_replace('[','',$Service));
				$org_service=trim(str_replace(']','',$org_service));
				
				$sql_order_shipdescription = "SELECT * FROM ?:shipping_descriptions, ?:shippings WHERE  ?:shipping_descriptions.shipping_id=?:shippings.shipping_id and ?:shippings.status='A' and (?:shipping_descriptions.shipping like '%".$org_carrier."%' and ?:shipping_descriptions.shipping like '%".$org_service."%')";
				
				$result_shipdescription= db_get_array($sql_order_shipdescription);
				foreach ($result_shipdescription as $rows_shipdescription_data)
				{
					$shipping_id=$rows_shipdescription_data['shipping_id'];
				}
				//create new shipment
				$shipment_id=db_query("insert into ?:shipments set shipping_id='$shipping_id'".$trackingsql.$carriersql.",timestamp='".time()."'");
				
				if(!is_numeric($shipment_id))
				{
					$shipment_res=db_get_row("SELECT * FROM ?:shipments order by shipment_id desc limit 0,1 ");
					$shipment_id=$shipment_res['shipment_id'];				
				
				}
				
				//insert shipment items
				$sql_order_items = "SELECT * FROM ?:order_details WHERE  order_id='".$OrderNumber."'";
				$result_items= db_get_array($sql_order_items);
				foreach ($result_items as $rows_item_data)
				{
					db_query("insert into ?:shipment_items set 	item_id='".$rows_item_data['item_id']."', shipment_id ='$shipment_id', order_id='".$OrderNumber."',product_id='".$rows_item_data['product_id']."',amount='".$rows_item_data['amount']."'");
					
				
				}
				
			
			}
			//Update tracking number & Carrier details
			if($TrackingNumber!="" || $Carrier!="")
			{
				
				$sql_order_data = "SELECT * FROM ?:order_data WHERE  order_id='".$OrderNumber."' and type='L'";
				$result_data= db_get_array($sql_order_data);
				foreach ($result_data as $rows_data)
				{
					$order_data=unserialize($rows_data['data']);
				
				
					$keys = array_keys($order_data);
					
					if(isset($keys[0]))
					{				
						$old_shipping_id=$keys[0];
						
						$order_data[$old_shipping_id]['tracking_number']=$TrackingNumber;
						if(CSCART_ULTIMATE)//only for ULTIMATE version
						{
							$order_data[$old_shipping_id]['shipping_id']=$shipping_id;
							$order_data[$old_shipping_id]['shipping']=$org_carrier;
						}
						else
						{
							$order_data[$old_shipping_id]['carrier']=$formatted_carrier;
						}
					}
													
				}
			
				$new_order_data=serialize($order_data); 
				db_query("update ?:order_data set data='".$new_order_data."' where order_id=".$OrderNumber." and type='L'");
				
										
			}
			if(CSCART_PROFESSIONAL)//only for professional version
			{
				//create new shipment
				$shipment_id=db_query("insert into ?:shipments set shipping_id='1'".$trackingsql.$carriersql.",timestamp='".time()."'");
				
				
				//insert shipment items
				$sql_order_items = "SELECT * FROM ?:order_details WHERE  order_id='".$OrderNumber."'";
				$result_items= db_get_array($sql_order_items);
				foreach ($result_items as $rows_item_data)
				{
					db_query("insert into ?:shipment_items set 	item_id='".$rows_item_data['item_id']."', shipment_id ='$shipment_id', order_id='".$OrderNumber."',product_id='".$rows_item_data['product_id']."',amount='".$rows_item_data['amount']."'");
					
				
				}
				$sql_order_data_prof = "SELECT COUNT(*) as specific_order_num FROM ?:order_data WHERE  order_id='".$OrderNumber."' and type='V'";
				$result_data_prof= db_get_array($sql_order_data_prof);
				$specific_order_num=0;
				foreach ($result_data_prof as $result_data_prof_item)
				{
					$specific_order_num=$result_data_prof_item['specific_order_num'];
				}
				
				if($specific_order_num==0)
				{
					//Enable RMA
					db_query("Insert into ?:order_data set  order_id=".$OrderNumber." , type='V', data='".time()."'");
				}
			
			}
				
			//update order table
			$update_notes_sql="";
			if(CSCART_UPDATE_STAFF_NOTES)
			{
			
				$update_notes_sql=" details='".$staff_comments."' ";
			}
			if(CSCART_UPDATE_CUSTOMER_NOTES)
			{
			
				$update_notes_sql.=" notes='".$buyer_comments."' ";
			}
			
			db_query("update ?:orders set  $update_notes_sql where order_id=".$OrderNumber);
			
			//call cscart core function to change order ststus
			if(CSCART_SHIPPED_STATUS_SET_TO_STATUS_4_COMPLETE==1)
			{
			 	fn_change_order_status($OrderNumber,'C', $current_order_status);					
				
			}
			else
			{
				if($current_order_status=='O'  )
					$change_order_status='P';
				else if($current_order_status=='P')
					$change_order_status='C';
				else
					$change_order_status=$current_order_status;
					
				fn_change_order_status($OrderNumber,$change_order_status, $current_order_status);
				
				
			}		 
				
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			//display error message
			$this->display_msg=str_replace("ENTERED_ORDERED_NUMBER","#$OrderNumber",INVAID_ORDER_NUMBER_ERROR_MSG);
			$this->SetXmlError(1,$this->display_msg);
		
		}
	}
	############################################## Function Fetch_DB_Orders #################################
	//Perform Database query & fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $active_db;
		
		$order_status_filter=$this->PrepareCscartOrderStatusFilter();
		
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);
		
		$conditions = db_quote(" AND (".$order_status_filter.")");
		$conditions.= db_quote(" AND (?:orders.timestamp between ?i AND ?i)",$datefrom_timestamp, $dateto_timestamp);
		
		$vendor_id=$this->GetValues('vendor_id');
		if($vendor_id!="")
		$conditions .= db_quote(" AND (?:orders.company_id IN ( ".$vendor_id."))");
		
		$result = db_get_array("SELECT * FROM ?:orders WHERE  1 ?p", $conditions);
		
		
		$counter=0;
		
		foreach ($result as $cscart_orders)
		{
			
			//prepare order array
			$cscart_orders_row=fn_get_order_info($this->GetFieldNumber($cscart_orders,"order_id"));
			$this->cscart_orders[$counter]=new stdClass();
			$this->cscart_orders[$counter]->orderid=$this->GetFieldNumber($cscart_orders,"order_id");
					
			//shipping details
			$this->cscart_orders[$counter]->order_shipping["FirstName"]=$this->GetFieldString($cscart_orders_row,"s_firstname");
			if($this->cscart_orders[$counter]->order_shipping["FirstName"]=="")
			$this->cscart_orders[$counter]->order_shipping["FirstName"]=$this->GetFieldString($cscart_orders_row,"firstname");
			$this->cscart_orders[$counter]->order_shipping["LastName"]=$this->GetFieldString($cscart_orders_row,"s_lastname");
			if($this->cscart_orders[$counter]->order_shipping["LastName"]=="")
			$this->cscart_orders[$counter]->order_shipping["LastName"]=$this->GetFieldString($cscart_orders_row,"lastname");
			$this->cscart_orders[$counter]->order_shipping["Company"]=$this->GetFieldString($cscart_orders_row,"company");
			$this->cscart_orders[$counter]->order_shipping["Address1"]=$this->GetFieldString($cscart_orders_row,"s_address");			
			$this->cscart_orders[$counter]->order_shipping["Address2"]=$this->GetFieldString($cscart_orders_row,"s_address_2");
			$this->cscart_orders[$counter]->order_shipping["City"]=$this->GetFieldString($cscart_orders_row,"s_city");		
			$this->cscart_orders[$counter]->order_shipping["State"]=$this->GetFieldString($cscart_orders_row,"s_state");
			$this->cscart_orders[$counter]->order_shipping["PostalCode"]=$this->GetFieldString($cscart_orders_row,"s_zipcode");			
			$this->cscart_orders[$counter]->order_shipping["Country"]=$this->GetFieldString($cscart_orders_row,"s_country");
			$this->cscart_orders[$counter]->order_shipping["Phone"]=$this->GetFieldString($cscart_orders_row,"s_phone");
			if($this->cscart_orders[$counter]->order_shipping["Phone"]=="")
			$this->cscart_orders[$counter]->order_shipping["Phone"]=$this->GetFieldString($cscart_orders_row,"phone");
			$this->cscart_orders[$counter]->order_shipping["EMail"]=$this->GetFieldString($cscart_orders_row,"email");
			
			//billing details
			$this->cscart_orders[$counter]->order_billing["FirstName"]=$this->GetFieldString($cscart_orders_row,"b_firstname");
			if($this->cscart_orders[$counter]->order_billing["FirstName"]=="")
			$this->cscart_orders[$counter]->order_billing["FirstName"]=$this->GetFieldString($cscart_orders_row,"firstname");
			$this->cscart_orders[$counter]->order_billing["LastName"]=$this->GetFieldString($cscart_orders_row,"b_lastname");
			if($this->cscart_orders[$counter]->order_billing["LastName"]=="")
			$this->cscart_orders[$counter]->order_billing["LastName"]=$this->GetFieldString($cscart_orders_row,"lastname");
			$this->cscart_orders[$counter]->order_billing["Company"]=$this->GetFieldString($cscart_orders_row,"company");
			$this->cscart_orders[$counter]->order_billing["Address1"]=$this->GetFieldString($cscart_orders_row,"b_address");			
			$this->cscart_orders[$counter]->order_billing["Address2"]=$this->GetFieldString($cscart_orders_row,"b_address_2");
			$this->cscart_orders[$counter]->order_billing["City"]=$this->GetFieldString($cscart_orders_row,"b_city");
			$this->cscart_orders[$counter]->order_billing["State"]=$this->GetFieldString($cscart_orders_row,"b_state");
			$this->cscart_orders[$counter]->order_billing["PostalCode"]=$this->GetFieldString($cscart_orders_row,"b_zipcode");
			$this->cscart_orders[$counter]->order_billing["Country"]=$this->GetFieldString($cscart_orders_row,"b_country");
			$this->cscart_orders[$counter]->order_billing["Phone"]=$this->GetFieldString($cscart_orders_row,"b_phone");
			$this->cscart_orders[$counter]->order_billing["EMail"]=$this->GetFieldString($cscart_orders_row,"email");
			
			//Shipping Name adjustment
			if($this->cscart_orders[$counter]->order_shipping["FirstName"]=="")
			$this->cscart_orders[$counter]->order_shipping["FirstName"]=$this->cscart_orders[$counter]->order_billing["FirstName"];
			if($this->cscart_orders[$counter]->order_shipping["LastName"]=="")
			$this->cscart_orders[$counter]->order_shipping["LastName"]=$this->cscart_orders[$counter]->order_billing["LastName"];
			
			//See if email present in business details, in case email id not available in order info
			if($this->GetFieldString($cscart_orders_row,"email")==NULL || strlen(trim($this->GetFieldString($cscart_orders_row,"email")))<1 )
			{
				$this->cscart_orders[$counter]->order_shipping["EMail"]=$this->GetFieldString($cscart_orders_row,"b_email");
				$this->cscart_orders[$counter]->order_billing["EMail"]=$this->GetFieldString($cscart_orders_row,"b_email");
			}
			
			//order info
			$this->cscart_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTC(true,$this->GetFieldString($cscart_orders_row,"timestamp"));
			$this->cscart_orders[$counter]->order_info["OrderNumber"]=$this->GetFieldNumber($cscart_orders_row,"order_id");
			
			//get payment method
			$pay_result_arr = db_get_array('SELECT * FROM ?:payment_descriptions WHERE  payment_id=?i', $this->GetFieldNumber($cscart_orders_row,"payment_id"));
			$payment_method="";
			foreach ($pay_result_arr as $pay_result)
			{
				$payment_method=$this->GetFieldString($pay_result,'payment');
			}
				
			$this->cscart_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($payment_method);
			
			//get shipping charges
			$ship_method="";
			$ship_result_arr=$this->GetFieldNumber($cscart_orders_row,"shipping");
			if(is_array($ship_result_arr))
			{
				foreach ($ship_result_arr as $ship_result)
				{
					$ship_method=$this->GetFieldString($ship_result,'shipping');
				}
			}
			$this->cscart_orders[$counter]->order_info["ShippingChargesPaid"]=$this->GetFieldNumber($cscart_orders_row,"display_shipping_cost");
			$this->cscart_orders[$counter]->order_info["ShipMethod"]=$ship_method;
			
			
			//Extract tax amount
			$tax="";
			$tax_arr=$this->GetFieldNumber($cscart_orders_row,"taxes");
			foreach ($tax_arr as $taxes)
			{
				$tax=$taxes['tax_subtotal'];
			}
			$this->cscart_orders[$counter]->order_info["Discount"]=0;
			if($this->GetFieldNumber($cscart_orders_row,"subtotal_discount")!=0)
			$this->cscart_orders[$counter]->order_info["Discount"]=$this->GetFieldNumber($cscart_orders_row,"subtotal_discount");
			
			$this->cscart_orders[$counter]->order_info["ItemsTax"]=$tax;
			
			if($this->GetFieldString($cscart_orders_row,"status")!="O")
				$this->cscart_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->cscart_orders[$counter]->order_info["PaymentStatus"]=0;
			
			//Show Order status	
			if($this->GetFieldString($cscart_orders_row,"status")=="C")
				$this->cscart_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->cscart_orders[$counter]->order_info["IsShipped"]=0;
			
			
			if($this->GetFieldString($cscart_orders_row,"status")=="I")
				$this->cscart_orders[$counter]->order_info["IsCancelled"]=1;
			else
				$this->cscart_orders[$counter]->order_info["IsCancelled"]=0;
				
			//Get Customer Comments
			$this->cscart_orders[$counter]->order_info["Comments"]=$this->GetFieldString($cscart_orders_row,"notes");
			
			//Get order products
			$items_cost=0;
				
			
			$product_result_arr =db_get_array("SELECT ?:order_details.*,?:product_descriptions.product,?:products.weight FROM ?:order_details INNER JOIN ?:product_descriptions ON ?:order_details.product_id = ?:product_descriptions.product_id INNER JOIN ?:products ON ?:order_details.product_id = ?:products.product_id WHERE ?:order_details.order_id =?i and  ?:product_descriptions.lang_code='EN'", $this->GetFieldNumber($cscart_orders_row,"order_id"));
			
			$i=0;
			
			foreach ($product_result_arr as $product_row) 
			{
				
				$this->cscart_orders[$counter]->order_product[$i]["Name"]=$this->GetFieldString($product_row,"product");
				$unit_price=$this->GetFieldNumber($product_row,"price");
				$this->cscart_orders[$counter]->order_product[$i]["Price"]=$unit_price;
				$this->cscart_orders[$counter]->order_product[$i]["ExternalID"]=$this->GetFieldString($product_row,"product_code");
				$this->cscart_orders[$counter]->order_product[$i]["Quantity"]=$this->GetFieldNumber($product_row,"amount");
				
				$this->cscart_orders[$counter]->order_product[$i]["Total"]=$this->FormatNumber($unit_price*$this->GetFieldNumber($product_row,"amount"));
				
				$this->cscart_orders[$counter]->order_product[$i]["IndividualProductWeight"]=number_format(($this->GetFieldNumber($product_row,"weight")*$this->GetFieldNumber($product_row,"amount")),2,'.','');
				
				$items_cost=$items_cost+$this->cscart_orders[$counter]->order_product[$i]["Total"];
						
				$this->cscart_orders[$counter]->order_product[$i]["Total_Product_Weight"]=number_format(($this->GetFieldNumber($product_row,"weight")*$this->GetFieldNumber($product_row,"amount")),2,'.','');
				
				$option_arr_temp=unserialize($this->GetFieldString($product_row,"extra"));
				$attributes="";

				$option_arr=$this->GetFieldString($option_arr_temp,"product_options_value");
				if(is_array($option_arr))
				{
					if(count($option_arr)>0)
					{
						foreach ($option_arr as $option_arr_row) 
						{
							if($attributes!="")
							$attributes.=",";
							
							$attributes.=$this->GetFieldString($option_arr_row,"option_name").":".$this->GetFieldString($option_arr_row,"variant_name");
						}
					}
				}
				
				$this->cscart_orders[$counter]->order_product[$i]["Notes"]=$attributes;
				
				if($attributes!="")
				$this->cscart_orders[$counter]->order_product[$i]["Name"]=$this->cscart_orders[$counter]->order_product[$i]["Name"]." (".$attributes.")";
				
				$i++;
			}
			
			$this->cscart_orders[$counter]->num_of_products=$i;
			
			$this->cscart_orders[$counter]->order_info["ItemsTotal"]=$this->FormatNumber($this->convert_to_safe_float($items_cost)-$this->convert_to_safe_float($this->cscart_orders[$counter]->order_info["ItemsTax"])-$this->convert_to_safe_float($this->cscart_orders[$counter]->order_info["ShippingChargesPaid"]),2);
			
			$this->cscart_orders[$counter]->order_info["Total"]=$this->FormatNumber($this->GetFieldNumber($cscart_orders_row,"total"));
			
			
			
			
			$counter++;
		}	
		
		
	}
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			
			if (isset($this->cscart_orders))
				return $this->cscart_orders;
			else
                       		return array();  


			
	}
	
	
	################################################ Function PrepareCscartOrderStatusFilter #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareCscartOrderStatusFilter()
	{
			
			$order_status_filter="";
			
			//Order statuses in this case:Complete ,Processed ,Open
			if(CSCART_RETRIEVE_ORDER_STATUS_1_OPEN==1)
			{
				$order_status_filter="?:orders.status= 'O' ";
				
			
			}
			if(CSCART_RETRIEVE_ORDER_STATUS_2_PROCESSED==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" ?:orders.status= 'P' ";
				}
				else
				{
					$order_status_filter.=" OR  ?:orders.status='P' ";
				}
				
			
			}
			if(CSCART_RETRIEVE_ORDER_STATUS_3_COMPLETE==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" ?:orders.status='C' ";
				}
				else
				{
					$order_status_filter.=" OR  ?:orders.status='C' ";
				}
							
			}
			if(CSCART_RETRIEVE_ORDER_STATUS_5_CANCELLED==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" ?:orders.status='I' ";
				}
				else
				{
					$order_status_filter.=" OR  ?:orders.status='I' ";
				}
							
			}
			
			
			
			return $order_status_filter;
			
	}
		function ConverCarrier($carrier)
		{
					$formatted_carrier="";
					$carrier=strtolower($carrier);
					
					switch($carrier)
					{
						case 'usps': 
						$formatted_carrier="USP";
						break;
						
						case 'ups':
						$formatted_carrier="UPS";
						break;
						
						case 'fedex':
						$formatted_carrier="FDX";
						break;
						
						case 'dhl':
						$formatted_carrier="DHL";
						break;
						
						case 'aup':
						$formatted_carrier="AUP";
						break;
						
						case 'chp':
						$formatted_carrier="CHP";
						break;
					
					}	
					return $formatted_carrier;
							
		
		}
		// Function to convert string or any value to safe float
		function convert_to_safe_float($value)
		{
			return floatval(preg_replace("/[^-0-9.]/","",$value));
		
		}
	
}
######################################### End of class ShippingZCscart ###################################################

	//create object & perform tasks based on command
	$obj_shipping_cscart=new ShippingZCscart;
	$obj_shipping_cscart->ExecuteCommand();	

?>
