<?php

define("SHIPPINGZEXCHANGEWP_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// Last mod to this file: $Change$

// Function for checking Include Files
function Check_Include_File($filename)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		echo "\"$filename\" is not accessible.";
		exit;
	}

}

// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");
// Check Request method, script ONLY executes if the desired http verbs are used
if($_SERVER['REQUEST_METHOD']!="GET" && $_SERVER['REQUEST_METHOD']!="POST")
exit;


// TEST that all the files are same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZEXCHANGEWP_VERSION && SHIPPINGZEXCHANGEWP_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZExchangewp.php [".SHIPPINGZEXCHANGEWP_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");

//include required wp file
if(Check_Include_File("wp-load.php"))
include("wp-load.php");

//DB connection
$port_number="";
$updated_host="";
if(strpos(DB_HOST, ':') !== false) {
  $split_host=explode(":",DB_HOST);
  $updated_host=$split_host[0];
  $port_number=$split_host[1];
} 

if($port_number!="")
$db_pdo=new PDO("mysql:host=".$updated_host.";port=".$port_number.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);
else
$db_pdo=new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);

global $wpdb;
											
################################################ Function convert_dim_unit #######################
//converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_unit=strtoupper($from_unit);
	}
	else 
	{
	
		$converted_unit="Unknown";
	}
	
	return $converted_unit;
}

############################################## Class ShippingZExchangewp ######################################
class ShippingZExchangewp extends ShippingZGenericShoppingCart
{

//cart specific functions goes here
var $exchangewp_orders=array();
############################################## Function Check_DB_Access #################################
//Check Database access
#######################################################################################################
function Check_DB_Access()
{
	global $db_pdo,$wpdb;
			
	$sql= "Select ID from ".$wpdb->prefix."posts order by ID limit 0,1";	
				
	$order_status = $db_pdo->prepare($sql);										
	$order_status->execute();
	
	if ($order_status->rowCount()) 
	{
		$this->display_msg=DB_SUCCESS_MSG;
		
	}
	else
	{
		$this->display_msg=$this->display_msg='Error occurred:'.implode(":",$order_status->errorInfo());
	}
	
}

############################################## Function GetOrderCountByDate #################################
//Get order count
#######################################################################################################
function GetOrderCountByDate($datefrom,$dateto)
{
	
	global $db_pdo,$wpdb;
			
	//Get order count based on data range
	$order_status_filter=$this->PrepareExchangewpOrderStatusFilter();
	
	$sql = "SELECT DISTINCT p.ID AS orders FROM " . $wpdb->prefix . "posts p, " . $wpdb->prefix . "postmeta pm where p.ID=pm.post_id AND  p.post_type='it_exchange_tran' AND pm.meta_key='_it_exchange_transaction_status'  AND " . $order_status_filter."  DATE_FORMAT(p.post_modified, '%Y-%m-%d %T') >= :datefrom  AND DATE_FORMAT(p.post_modified, '%Y-%m-%d %T') <= :dateto";
	$orders = $db_pdo->prepare($sql);
	$data=array(':datefrom' => $this->ConvertDateToDbFormat($datefrom) , ':dateto' => $this->ConvertDateToDbFormat($dateto));
	
	$orders->execute($data);
	
	return $orders->rowCount();

}
############################################## Function UpdateShippingInfo #################################
//Update order status 
#######################################################################################################
function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
{
	global $db_pdo,$wpdb;
		
	$sql = "SELECT pm.meta_value FROM " . $wpdb->prefix . "posts p, " . $wpdb->prefix . "postmeta pm where p.ID=pm.post_id AND  p.post_type='it_exchange_tran' AND pm.meta_key='_it_exchange_transaction_status'  AND p.ID=:order_id";
		
	$result = $db_pdo->prepare($sql);
	$result->execute(array(':order_id' => $OrderNumber));
	
	//check if order number is valid
	if($result->rowCount()>0)
	{
	
		if($ShipDate!="")
			$shipped_on=$ShipDate;
		else
			$shipped_on=date("m/d/Y");
			
		if($Carrier!="")
		{
			$original_carrier=$Carrier;
			$Carrier=" via ".$Carrier;
		}
		
		if($Service!="")
		$Service=" [".$Service."]";
		
		$TrackingNumberString="";
		if($TrackingNumber!="")
		$TrackingNumberString=", Tracking number $TrackingNumber";
		
			
		foreach( $result as $order )
		{
			$current_order_status=$order['meta_value'];
		}
		
		//prepare $comments & save it
		$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
		
			
		if(EXCHANGEWP_SHIPPED_STATUS_SET_TO_STATUS_2_PAID==1)
		{
						
			$change_order_status="paid";
		}
		else
		{
			 if(strtolower($current_order_status)=="pending")
				$change_order_status="paid";
			else
			$change_order_status=$current_order_status;
								
		}
		if($change_order_status!=$current_order_status)
		{
			$transaction = it_exchange_get_transaction( $OrderNumber );

			if ( ! $transaction )
				return false;
		
			$old_status         = $transaction->get_status();
			$old_status_cleared = it_exchange_transaction_is_cleared_for_delivery( $transaction );
			$transaction->update_status( $change_order_status );
		}
		
		$builder = new IT_Exchange_Txn_Activity_Builder( $OrderNumber, 'note' );
		$builder->set_public( false );
		$builder->set_description( $comments );
		$builder->set_actor( new IT_Exchange_Txn_Activity_User_Actor("1") );
		$note = $builder->build( it_exchange_get_txn_activity_factory() );
		$note_arr=$note->to_array();
		
		$sql_notes = "Update " . $wpdb->prefix . "posts  set post_parent=:order_id where ID=:note_id ";	
		$note_result = $db_pdo->prepare($sql_notes);	
		$data_notes=array(':order_id' => $OrderNumber, ':note_id'=>$note_arr['ID']);	
		$note_result->execute($data_notes);		
		
		$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
	}
	else
	{
		//display error message
		$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
		$this->SetXmlError(1,$this->display_msg);
	
	} 	
	
}
############################################## Function Fetch_DB_Orders #################################
//Perform Database query & fetch orders based on date range
#######################################################################################################

function Fetch_DB_Orders($datefrom,$dateto)
{
	//Get orders based on data range
	global $db_pdo,$wpdb;				
					
	//Get order count based on data range
	$order_status_filter=$this->PrepareExchangewpOrderStatusFilter();
	
	$sql = "SELECT DISTINCT p.ID AS orders FROM " . $wpdb->prefix . "posts p, " . $wpdb->prefix . "postmeta pm where p.ID=pm.post_id AND  p.post_type='it_exchange_tran' AND pm.meta_key='_it_exchange_transaction_status'  AND " . $order_status_filter."  DATE_FORMAT(p.post_modified, '%Y-%m-%d %T') >= :datefrom  AND DATE_FORMAT(p.post_modified, '%Y-%m-%d %T') <= :dateto";		
	$orders_result = $db_pdo->prepare($sql);	
	$data=array(':datefrom' => $this->ConvertDateToDbFormat($datefrom) , ':dateto' => $this->ConvertDateToDbFormat($dateto));	
	$orders_result->execute($data);
	
	$counter=0;
	$uom_weight="";
	$dim_unit="";
	foreach( $orders_result as $order )
	{
			
			$order_id=$order['orders'];
			$exchangewp_order_data = it_exchange_get_transaction($order_id);
			$exchangewp_order_products_temp=$exchangewp_order_data->cart_details->products;
			
			if(count($exchangewp_order_products_temp)==0)
			continue;
										
			//prepare order array
			$this->exchangewp_orders[$counter]=new stdClass();
			$this->exchangewp_orders[$counter]->orderid=$order_id;
			
			$customer_id=$exchangewp_order_data->customer_id;
			$exchangewp_customer_data_temp=it_exchange_get_customer( $customer_id );
			$exchangewp_customer_data=$exchangewp_customer_data_temp->data;
			$shipping_address_data=$exchangewp_customer_data->shipping_address;
			$billing_address_data=$exchangewp_customer_data->billing_address;
			
			//shipping details
			$this->exchangewp_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field($shipping_address_data,'first-name');
			$this->exchangewp_orders[$counter]->order_shipping["LastName"]=$this->Check_Field($shipping_address_data,'last-name');
			$this->exchangewp_orders[$counter]->order_shipping["Company"]=$this->Check_Field($shipping_address_data,'company-name');
			$this->exchangewp_orders[$counter]->order_shipping["Address1"]=$this->Check_Field($shipping_address_data,'address1');
			$this->exchangewp_orders[$counter]->order_shipping["Address2"]=$this->Check_Field($shipping_address_data,'address2');
			$this->exchangewp_orders[$counter]->order_shipping["City"]=$this->Check_Field($shipping_address_data,'city');
			$this->exchangewp_orders[$counter]->order_shipping["State"]=$this->Check_Field($shipping_address_data,'state');
			$this->exchangewp_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field($shipping_address_data,'zip');
			$this->exchangewp_orders[$counter]->order_shipping["Country"]=	$this->Check_Field($shipping_address_data,'country');
			$this->exchangewp_orders[$counter]->order_shipping["Phone"]=$this->Check_Field($shipping_address_data,'phone');
			
			if($this->Check_Field($shipping_address_data,'email')=="")
			$this->exchangewp_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($exchangewp_customer_data,'user_email');
			else
			$this->exchangewp_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($shipping_address_data,'email');
			
													
			//billing details
			if(is_array($billing_address_data))
			{
				$this->exchangewp_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($billing_address_data,'first-name');
				$this->exchangewp_orders[$counter]->order_billing["LastName"]=$this->Check_Field($billing_address_data,'last-name');
				$this->exchangewp_orders[$counter]->order_billing["Company"]=$this->Check_Field($billing_address_data,'company-name');
				$this->exchangewp_orders[$counter]->order_billing["Address1"]=$this->Check_Field($billing_address_data,'address1');
				$this->exchangewp_orders[$counter]->order_billing["Address2"]=$this->Check_Field($billing_address_data,'address2');
				$this->exchangewp_orders[$counter]->order_billing["City"]=$this->Check_Field($billing_address_data,'city');
				$this->exchangewp_orders[$counter]->order_billing["State"]=$this->Check_Field($billing_address_data,'state');
				$this->exchangewp_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($billing_address_data,'zip');
				$this->exchangewp_orders[$counter]->order_billing["Country"]=$this->Check_Field($billing_address_data,'country');
				$this->exchangewp_orders[$counter]->order_billing["Phone"]=$this->Check_Field($billing_address_data,'phone');
				
				if($this->Check_Field($billing_address_data,'email')=="")
				$this->exchangewp_orders[$counter]->order_billing["EMail"]=$this->Check_Field($exchangewp_customer_data,'user_email');
				else
				$this->exchangewp_orders[$counter]->order_billing["EMail"]=$this->Check_Field($billing_address_data,'email');
			}
			else
			{
				$this->exchangewp_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($shipping_address_data,'first-name');
				$this->exchangewp_orders[$counter]->order_billing["LastName"]=$this->Check_Field($shipping_address_data,'last-name');
				$this->exchangewp_orders[$counter]->order_billing["Company"]=$this->Check_Field($shipping_address_data,'company-name');
				$this->exchangewp_orders[$counter]->order_billing["Address1"]=$this->Check_Field($shipping_address_data,'address1');
				$this->exchangewp_orders[$counter]->order_billing["Address2"]=$this->Check_Field($shipping_address_data,'address2');
				$this->exchangewp_orders[$counter]->order_billing["City"]=$this->Check_Field($shipping_address_data,'city');
				$this->exchangewp_orders[$counter]->order_billing["State"]=$this->Check_Field($shipping_address_data,'state');
				$this->exchangewp_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($shipping_address_data,'zip');
				$this->exchangewp_orders[$counter]->order_billing["Country"]=$this->Check_Field($shipping_address_data,'country');
				$this->exchangewp_orders[$counter]->order_billing["Phone"]=$this->Check_Field($shipping_address_data,'phone');
				$this->exchangewp_orders[$counter]->order_billing["EMail"]=$this->exchangewp_orders[$counter]->order_shipping["EMail"];
			
			
			}	
				
									
			//order info
			$order_date_actual = new DateTime($this->Check_Field($exchangewp_order_data,'post_date'));
			$this->exchangewp_orders[$counter]->order_info["OrderDate"]= $order_date_actual->format('Y-m-d\TH:i:00\Z');
					
			$this->exchangewp_orders[$counter]->order_info["Total"]=number_format($exchangewp_order_data->cart_details->total,2,'.','');
			$this->exchangewp_orders[$counter]->order_info["ItemsTax"]=number_format($exchangewp_order_data->cart_details->taxes_raw,2,'.','');
							
			$this->exchangewp_orders[$counter]->order_info["OrderNumber"]=$order_id;
			$this->exchangewp_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($exchangewp_order_data->transaction_method);
			$this->exchangewp_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($exchangewp_order_data->cart_details->shipping_total/100,2,'.','');
			$this->exchangewp_orders[$counter]->order_info["ShipMethod"]=$exchangewp_order_data->cart_details->shipping_method;
			
			$this->exchangewp_orders[$counter]->order_info["Comments"]="";
			$sql_notes = "SELECT post_content FROM " . $wpdb->prefix . "posts  where post_parent=:order_id AND  post_type='ite_txn_activity' order by ID desc limit 0,1";		
			$note_result = $db_pdo->prepare($sql_notes);	
			$data_notes=array(':order_id' => $order_id);	
			$note_result->execute($data_notes);
			if($note_result->rowCount()>0)
			{
				foreach( $note_result as $notes)
				$this->exchangewp_orders[$counter]->order_info["Comments"]=$notes['post_content'];	
			}
			
			
			$this->exchangewp_orders[$counter]->order_info["ExternalID"]=$this->exchangewp_orders[$counter]->order_info["OrderNumber"] . '-' . $this->exchangewp_orders[$counter]->order_info["OrderDate"];		

			$order_status=$exchangewp_order_data->status;
			
			if( $order_status!="pending")
				$this->exchangewp_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->exchangewp_orders[$counter]->order_info["PaymentStatus"]=0;
			
			//Show Order status
			if($order_status=="paid")
				$this->exchangewp_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->exchangewp_orders[$counter]->order_info["IsShipped"]=0;
				
			//show if cancelled
			if($order_status=="cancelled" || $order_status=="cancelled")
				$this->exchangewp_orders[$counter]->order_info["IsCancelled"]=1;
			else
				$this->exchangewp_orders[$counter]->order_info["IsCancelled"]=0;
				
					
			$actual_number_of_products=0;
			
			$this->exchangewp_orders[$counter]->order_info["ItemsTotal"]=0;				
			foreach($exchangewp_order_products_temp as $key=>$exchangewp_order_products)
			{
			
			
			if($exchangewp_order_products['product_name']!="")
			{					
				$product_additional_details=$exchangewp_order_products['additional_data'];
									
				
				$this->exchangewp_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$exchangewp_order_products['product_name'];
				
				$this->exchangewp_orders[$counter]->order_product[$actual_number_of_products]["Price"]=0;
				if($exchangewp_order_products['count']!=0)
				$this->exchangewp_orders[$counter]->order_product[$actual_number_of_products]["Price"]=number_format((float)$exchangewp_order_products['product_base_price'],2,'.','');
				
				$this->exchangewp_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$exchangewp_order_products['product_id'];
				$this->exchangewp_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($exchangewp_order_products['count'],2,'.','');
				$this->exchangewp_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format((float)$exchangewp_order_products['product_subtotal'],2,'.','');	
				$this->exchangewp_orders[$counter]->order_product[$actual_number_of_products]["Notes"]="";
				$actual_number_of_products++;						
			}
		}
		  
	    $this->exchangewp_orders[$counter]->order_info["ItemsTotal"]=number_format($exchangewp_order_data->cart_details->sub_total,2,'.','');;	  
		$this->exchangewp_orders[$counter]->num_of_products=$actual_number_of_products;
		
		$counter++;
	}
}

################################### Function GetOrdersByDate($datefrom,$dateto) ######################
//Get orders based on date range
#######################################################################################################
function GetOrdersByDate($datefrom,$dateto)
{
		
		$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
		

		if (isset($this->exchangewp_orders))
			return $this->exchangewp_orders;
		else
						return array();  
		
}

############################################## Function Check_Field #################################
//Check & Return field value if available
#######################################################################################################
function Check_Field($obj,$field)
{
	if(is_object($obj))
	{
		
		if(null !==($obj->{$field}))
		{
					
			return $obj->{$field};
		}
		else
	   {
			return "";
		}
					
	}
	elseif(is_array($obj))
	{
		if(isset($obj[$field]))
		{
			if($obj[$field]!="")
			return $obj[$field];
			else
			return "";
		
		}
		else
		return "";
	}
	else
	{
		return "";
	}
	
}
############################################## Function ConvertDateToDbFormat #################################
//"T" & "Z" remove from UTC format(in ISO 8601) 
#######################################################################################################
function ConvertDateToDbFormat($server_date_utc)  
{
	if(strpos($server_date_utc,"Z"))
	{
		$utc_fotmat_temp=str_replace("Z","",$server_date_utc);
		$server_date_utc=str_replace("T","",$utc_fotmat_temp);
	   
	}  
	return $server_date_utc;
}

################################################ Function PrepareExchangewpOrderStatusFilter #######################
//Prepare order status string based on settings
#######################################################################################################
function PrepareExchangewpOrderStatusFilter()
{
		global $wpdb;
		
		$order_status_filter="";
		
		if(EXCHANGEWP_RETRIEVE_ORDER_STATUS_1_PENDING==1)
		{
			if($order_status_filter=="")
			{
				$order_status_filter.="pm.meta_value = 'pending'";
			}
			else
			{
				$order_status_filter.=" OR pm.meta_value = 'pending'";
			}
		
		}
		
		
		if(EXCHANGEWP_RETRIEVE_ORDER_STATUS_2_PAID==1 )
		{
			if($order_status_filter=="")
			{
				$order_status_filter.="pm.meta_value = 'paid'";
			}
			else
			{
				$order_status_filter.=" OR pm.meta_value= 'paid'";
			}
		}
		
		
		if($order_status_filter!="")
		$order_status_filter="( ".$order_status_filter." ) and";
		return $order_status_filter;
		
}
		

}

######################################### End of class ShippingZExchangewp ###################################################

	// create object & perform tasks based on command

	$obj_shipping_exchangewp=new ShippingZExchangewp;
	$obj_shipping_exchangewp->ExecuteCommand();

?>
