<?php
use \Joomla\CMS\Factory;

define("SHIPPINGZHIKASHOP_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// { $Revision$ }
// { $File$ }

// Function for checking Include Files
function Check_Include_File($filename, $mage_check=0)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		if($mage_check)
		{
			echo "\"$filename\" is not accessible.<br><br>";
			echo "Please, place all ShippingZ PHP files which are listed below at root folder of your Joomla website.<br>";
			echo "-ShippingZHikaShop.php<br>";
			echo "-ShippingZSettings.php<br>";
			echo "-ShippingZClasses.php<br>";
			echo "-ShippingZMessages.php<br>";
		}
		else
		{
			echo "\"$filename\" is not accessible.";
		}
		exit;
	}

}
// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");

// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZHIKASHOP_VERSION && SHIPPINGZHIKASHOP_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZHikaShop.php [".SHIPPINGZHIKASHOP_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}
################################################ Function convert_dim_unit #######################
//converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	if($from_unit=="inches")
	$from_unit="in";
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_unit=strtoupper($from_unit);
	}
	else 
	{
	
		$converted_unit="Unknown";
	}
	
	return $converted_unit;
}
define('_JEXEC', 1);
$startTime = microtime(1);
$startMem  = memory_get_usage();
if (file_exists(dirname(__FILE__) . '/defines.php')) {
    include_once dirname(__FILE__) . '/defines.php';
}
if (!defined('_JDEFINES')) {
    define('JPATH_BASE', dirname(__FILE__));
    require_once JPATH_BASE . '/includes/defines.php';
}


require_once JPATH_BASE . '/includes/framework.php';

// Set profiler start time and memory usage and mark afterLoad in the profiler.
JDEBUG && \Joomla\CMS\Profiler\Profiler::getInstance('Application')->setStart($startTime, $startMem)->mark('afterLoad');


JDEBUG ? JProfiler::getInstance('Application')->setStart($startTime, $startMem)->mark('afterLoad') : null;


$crlf = PHP_EOL;

// Database connection
$db = JFactory::getDbo();
############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");
############################################## Class ShippingZHikaShop ##########################################
class ShippingZHikaShop extends ShippingZGenericShoppingCart
{
	
	// Cart specific functions goes here
	var $hikashop_orders=array();
	############################################## Function Check_DB_Access #################################
	// Check Database access
	#######################################################################################################
	function Check_DB_Access()
	{
		
		global $db;
		
		try // See if we can access joomla database
		{
			$query="Show columns FROM #__hikashop_order ";
			$db->setQuery($query);
			$db->execute();
			$num_rows = $db->getNumRows();
			if($num_rows>0)
			$this->display_msg=DB_SUCCESS_MSG;
		}
		catch(Exception $e)
		{
			$this->display_msg="Could not access Joomla database";
			$this->SetXmlError(1,$this->display_msg);
			exit;
				
		}
			
	}
	
	
	############################################## Function GetOrderCountByDate #################################
	// Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		global $db;
		
		$order_status_filter=$this->PrepareHikaShopOrderStatusFilter();
			
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);
		
		$sql = "SELECT order_id FROM #__hikashop_order";
		$sql .= " WHERE " . $order_status_filter . "";
		$sql .= " ((order_modified between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp).") OR  (order_created between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp)." ))";
		
		$db->setQuery($sql);
		$db->execute();
		$num_rows = $db->getNumRows();
			
		return $num_rows;
	
	}
	############################################## Function UpdateShippingInfo #################################
	// Update order status
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $db;
		
		
		$sql = "SELECT order_status FROM #__hikashop_order WHERE order_id=".$db->quote($OrderNumber);
		
		$db->setQuery($sql);
		$db->execute();
		$num_rows = $db->getNumRows();
		// Check if order number is valid
		if($num_rows>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			$tracking_url="";	
			if($Carrier!="")
			{
				if(defined(strtoupper($Carrier)."_URL"))
				{
					$temp_url=constant(strtoupper($Carrier)."_URL");
					$tracking_url=" <a href=\"".$temp_url."\" target=\"_blank\"> $TrackingNumber</a>";
					$tracking_url=str_replace("[TRACKING_NUMBER]",$TrackingNumber,$tracking_url);
				}
				$Carrier=" via ".$Carrier;
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			if($TrackingNumber!="")
			{
				if($tracking_url!="")
				{
					$TrackingNumberString=", Tracking number $tracking_url";
				}
				else
				{
					$TrackingNumberString=", Tracking number $TrackingNumber";
				}
			}
			$result = $db->loadObjectList();
			
			foreach ($result as $order_row)
			{
				$current_order_status=$order_row->order_status;
			}
			
			
								
			// Prepare $comments & save it
			$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
			
			if(HIKASHOP_SHIPPED_STATUS_SET_TO_STATUS_3_SHIPPED==1)
			{

				$columns = array('history_order_id', 'history_new_status', 'history_created', 'history_notified', 'history_type', 'history_reason','history_data','history_user_id');
				$values = array(
					$db->quote($OrderNumber),
					$db->quote('shipped'),
					$db->quote(time()),
					'0',
					$db->quote('shipment'),
					$db->quote($comments),
					$db->quote($comments),
					'1'
				);
				
				$query = $db->getQuery(true);

				$query
				->insert($db->quoteName('#__hikashop_history'))
				->columns($db->quoteName($columns))
				->values(implode(',', $values));
				
				
				$db->setQuery($query);
				$db->setQuery($query);
				$db->execute();
				
				// Update order status
				$query_2 = $db->getQuery(true);  
				$fields = array(
				$db->quoteName('order_status') . ' = ' . $db->quote('shipped')			
			     );
			
				// Conditions for which records should be updated.
				$conditions = array(
					$db->quoteName('order_id') . ' = ' . $db->quote($OrderNumber)
				);
				
				$query_2->update($db->quoteName('#__hikashop_order'))->set($fields)->where($conditions);
	
				$db->setQuery($query_2);
				
				$result = $db->execute();

			 } 
			 else
			 {

				if($current_order_status=="created")

					$change_order_status="confirmed";

				else if($current_order_status=="confirmed")

					$change_order_status="shipped";

				else

					$change_order_status=$current_order_status;

				
				$db->execute();
				$columns = array('history_order_id', 'history_new_status', 'history_created', 'history_notified', 'history_type', 'history_reason','history_user_id');
				$values = array($db->quote($OrderNumber).", ".$change_order_status.",".$db->quote(time()).",'0', 'shipment',".$db->quote($comments),'1');
				
				$query = $db->getQuery(true);

				$query
				->insert($db->quoteName('#__hikashop_history'))
				->columns($db->quoteName($columns))
				->values(implode(',', $values));
									  

				if($change_order_status!=$current_order_status)
				{

					// Update order status
					$query_2 = $db->getQuery(true);  
					$fields = array(
					$db->quoteName('order_status') . ' = ' . $db->quote($change_order_status)			
					 );
				
					// Conditions for which records should be updated.
					$conditions = array(
						$db->quoteName('order_id') . ' = ' . $db->quote($OrderNumber)
					);
					
					$query_2->update($db->quoteName('#__hikashop_order'))->set($fields)->where($conditions);
		
					$db->setQuery($query_2);
					
					$result = $db->execute();

				 }
			 

			 }
			
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			// Display error message
			$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		}	
	}
	############################################## Function Fetch_DB_Orders #################################
	// Fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $db;
		
		$order_status_filter=$this->PrepareHikaShopOrderStatusFilter();
		
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);		
		
		//Check for Hikashop Starter or Business edition
		if (!defined('HIKASHOP_BUSINESS'))
		define("HIKASHOP_BUSINESS", 0); 
		
		if(HIKASHOP_BUSINESS)
		{
			$sql = "SELECT o.order_id,o.order_billing_address_id,o.order_shipping_address_id, o.order_user_id, o.order_status, o.order_type, o.order_number,o.order_created,o.order_modified, o.order_full_price,o.order_tax_info, o.order_payment_id,o.order_shipping_id,o.order_shipping_price FROM `#__hikashop_order` o";	
		}
		else
		{
			$sql = "SELECT o.order_id,o.order_billing_address_id,o.order_shipping_address_id, o.order_user_id, o.order_status, o.order_type, o.order_number,o.order_created,o.order_modified, o.order_full_price,o.order_tax_info, o.order_payment_id,o.order_shipping_id,o.order_shipping_price,o.comment FROM `#__hikashop_order` o";	
		}
		
			
		$sql .= " WHERE " . $order_status_filter . "";
		$sql .= " ((order_modified between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp).") OR  (order_created between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp)." ))";

		$db->setQuery($sql);
		$db->execute();
		$order_data = $db->loadObjectList();
		
		$this->hikashop_orders=array();
		$counter=0;
		
		foreach ($order_data as $hikashop_orders_row)
		{
			$dim_unit="";
			
			// Prepare order array
			$this->hikashop_orders[$counter]=new stdClass();
			$this->hikashop_orders[$counter]->orderid=$hikashop_orders_row->order_id;
				
			// Get user details
			$user_id=$hikashop_orders_row->order_user_id;			
			$sql_user_details= "Select * from #__hikashop_user where user_id=".$db->quote($user_id);
			$db->setQuery($sql_user_details);
			$db->execute();
			$user_details = $db->loadObjectList();			
			
			foreach ($user_details as $user_details_row)
			{
				$user_email=$user_details_row->user_email;
			}	
			
			// Shipping details
			$shipping_address_id=$hikashop_orders_row->order_shipping_address_id;			
			$sql_shipping_details= "Select * from #__hikashop_address where address_id=".$db->quote($shipping_address_id);
			$db->setQuery($sql_shipping_details);
			$db->execute();
			$shipping_details = $db->loadObjectList();			
			
			foreach ($shipping_details as $shipping_details_row)
			{
				$this->hikashop_orders[$counter]->order_shipping["FirstName"]=$shipping_details_row->address_firstname;
				$this->hikashop_orders[$counter]->order_shipping["LastName"]=$shipping_details_row->address_lastname;
				$this->hikashop_orders[$counter]->order_shipping["Company"]=$shipping_details_row->address_company;
				$this->hikashop_orders[$counter]->order_shipping["Address1"]=$shipping_details_row->address_street;			
				$this->hikashop_orders[$counter]->order_shipping["Address2"]=$shipping_details_row->address_street2;
				$this->hikashop_orders[$counter]->order_shipping["City"]=$shipping_details_row->address_city;	
				
				if(isset($shipping_details_row->address_state))
				{
					$state_temp=explode("_",$shipping_details_row->address_state);
					$state_formatted = implode("_",array_slice($state_temp, 1, -1));
					$state_formatted=str_replace("_"," ",$state_formatted);
					
					$this->hikashop_orders[$counter]->order_shipping["State"]=$state_formatted;
				}
				$this->hikashop_orders[$counter]->order_shipping["PostalCode"]=$shipping_details_row->address_post_code;
				
				if(isset($shipping_details_row->address_country))
				{
					$country_temp=explode("_",$shipping_details_row->address_country);
					$country_formatted = implode("_",array_slice($country_temp, 1, -1));
					$country_formatted=str_replace("_"," ",$country_formatted);
					
					$this->hikashop_orders[$counter]->order_shipping["Country"]=$country_formatted;
				}			
				
				$this->hikashop_orders[$counter]->order_shipping["Phone"]=$shipping_details_row->address_telephone;
				$this->hikashop_orders[$counter]->order_shipping["EMail"]=$user_email;
			}
			
			// Billing details
			$billing_address_id=$hikashop_orders_row->order_billing_address_id;			
			$sql_billing_details= "Select * from #__hikashop_address where address_id=".$db->quote($billing_address_id);
			$db->setQuery($sql_billing_details);
			$db->execute();
			$billing_details = $db->loadObjectList();			
			
			foreach ($billing_details as $billing_details_row)
			{
				$this->hikashop_orders[$counter]->order_billing["FirstName"]=$billing_details_row->address_firstname;
				$this->hikashop_orders[$counter]->order_billing["LastName"]=$billing_details_row->address_lastname;
				$this->hikashop_orders[$counter]->order_billing["Company"]=$billing_details_row->address_company;
				$this->hikashop_orders[$counter]->order_billing["Address1"]=$billing_details_row->address_street;			
				$this->hikashop_orders[$counter]->order_billing["Address2"]=$billing_details_row->address_street2;
				$this->hikashop_orders[$counter]->order_billing["City"]=$billing_details_row->address_city;
				if(isset($billing_details_row->address_state))
				{
					$state_temp=explode("_",$billing_details_row->address_state);
					$state_formatted = implode("_",array_slice($state_temp, 1, -1));
					$state_formatted=str_replace("_"," ",$state_formatted);
					$this->hikashop_orders[$counter]->order_billing["State"]=$state_formatted;
				}
				$this->hikashop_orders[$counter]->order_billing["PostalCode"]=$billing_details_row->address_post_code;
				if(isset($billing_details_row->address_country))
				{
					$country_temp=explode("_",$billing_details_row->address_country);
					$country_formatted = implode("_",array_slice($country_temp, 1, -1));
					$country_formatted=str_replace("_"," ",$country_formatted);
					$this->hikashop_orders[$counter]->order_billing["Country"]=$country_formatted;
				}
				$this->hikashop_orders[$counter]->order_billing["Phone"]=$billing_details_row->address_telephone;
				$this->hikashop_orders[$counter]->order_billing["EMail"]=$user_email;
			}
			
					
			// Order info
			$this->hikashop_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTC(true,$hikashop_orders_row->order_created);
			$this->hikashop_orders[$counter]->order_info["OrderNumber"]=$hikashop_orders_row->order_id;
			
			
			$sql_payment_details= "Select * from #__hikashop_payment where payment_id=".$db->quote($hikashop_orders_row->order_payment_id);
			$db->setQuery($sql_payment_details);
			$db->execute();
			$payment_details = $db->loadObjectList();			
			
			$this->hikashop_orders[$counter]->order_info["PaymentType"]="";
			foreach ($payment_details as $payment_details_row)
			{
				$this->hikashop_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($payment_details_row->payment_name);
			}
			
					
			// Get shipping charges
			$this->hikashop_orders[$counter]->order_info["ShippingChargesPaid"]=$this->FormatNumber($hikashop_orders_row->order_shipping_price);
			$sql_shipping_details= "Select * from #__hikashop_shipping where shipping_id=".$db->quote($hikashop_orders_row->order_shipping_id);
			$db->setQuery($sql_shipping_details);
			$db->execute();
			$shipping_details = $db->loadObjectList();			
			
			$this->hikashop_orders[$counter]->order_info["ShipMethod"]="";
			foreach ($shipping_details as $shipping_details_row)
			{
				$this->hikashop_orders[$counter]->order_info["ShipMethod"]=$shipping_details_row->shipping_name;
			}
			
			// Extract tax amount
			$tax_amount=0;
			$tax_temp=$hikashop_orders_row->order_tax_info;
			$tax_array=unserialize($tax_temp);
			if(is_array($tax_array))
			{
				foreach($tax_array as $key=>$val)
				{
					if($key!="")
					$tax_amount+=$val->tax_amount;	
				}
			}
			$this->hikashop_orders[$counter]->order_info["ItemsTax"]=$this->FormatNumber($tax_amount);
				
			// Payment Status		
			if($hikashop_orders_row->order_status!="created")
				$this->hikashop_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->hikashop_orders[$counter]->order_info["PaymentStatus"]=0;
			
			// Order status	
			if($hikashop_orders_row->order_status=="shipped")
				$this->hikashop_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->hikashop_orders[$counter]->order_info["IsShipped"]=0;
				
			if($hikashop_orders_row->order_status=="cancelled")
				$this->hikashop_orders[$counter]->order_info["IsCancelled"]=1;
			else
				$this->hikashop_orders[$counter]->order_info["IsCancelled"]=0;
			
			//Get Customer Comments
			$this->hikashop_orders[$counter]->order_info["Comments"]="";
			if(isset($hikashop_orders_row->comment))
			$this->hikashop_orders[$counter]->order_info["Comments"]=$hikashop_orders_row->comment;
			
			//Get order products
			$items_cost=0;		
			
			$sql_product='SELECT op.order_product_id,op.order_product_name,op.order_product_code,op.order_product_price,op.order_product_quantity,op.order_product_options,p.product_weight,p.product_weight_unit,p.product_dimension_unit,p.product_width,p.product_length,p.product_height from #__hikashop_order_product op, #__hikashop_product p where op.order_id='.$db->quote($hikashop_orders_row->order_id).' and op.product_id=p.product_id';
			
			
			$i=0;
			$db->setQuery($sql_product);
			$db->execute();
			$product_result_arr = $db->loadObjectList();
			$uom_weight="";
			$product_weight=0;
			
			foreach ($product_result_arr as $product_row) 
			{			
				$unit_price=$product_row->order_product_price;
				$this->hikashop_orders[$counter]->order_product[$i]["Price"]=$this->FormatNumber($unit_price);
				$this->hikashop_orders[$counter]->order_product[$i]["ExternalID"]=$product_row->order_product_code;
				$this->hikashop_orders[$counter]->order_product[$i]["Quantity"]=$product_row->order_product_quantity;				
				$this->hikashop_orders[$counter]->order_product[$i]["Total"]=$this->FormatNumber($unit_price*$product_row->order_product_quantity);				
				$items_cost=$items_cost+$this->hikashop_orders[$counter]->order_product[$i]["Total"];
				
				$product_weight=$this->ConvertToAcceptedUnitWeight($product_row->product_weight,$product_row->product_weight_unit);
				$uom_weight=$product_row->product_weight_unit;					
				
				$this->hikashop_orders[$counter]->order_product[$i]["Total_Product_Weight"]=((float)$product_weight*$product_row->order_product_quantity);				
				$this->hikashop_orders[$counter]->order_product[$i]["Name"]=$product_row->order_product_name;
				
				if($product_row->product_length>0)
				{
					$this->hikashop_orders[$counter]->order_product[$i]['ItemLength']=$product_row->product_length;
					$this->hikashop_orders[$counter]->order_product[$i]['ItemWidth']=$product_row->product_width;
					$this->hikashop_orders[$counter]->order_product[$i]['ItemHeight']=$product_row->product_height;	
					
					if($product_row->product_dimension_unit!="")
					$dim_unit=convert_dim_unit($product_row->product_dimension_unit);				
			    }			
				
				
				$i++;
			}
			
			$this->hikashop_orders[$counter]->num_of_products=$i;			
			$this->hikashop_orders[$counter]->order_info["ItemsTotal"]=$this->FormatNumber($items_cost,2);			
			$this->hikashop_orders[$counter]->order_info["Total"]=$this->FormatNumber($hikashop_orders_row->order_full_price);			
			$this->hikashop_orders[$counter]->order_info["UOMWeight"]=strtoupper($uom_weight);
			if($dim_unit!="")
			$this->hikashop_orders[$counter]->order_info["UnitsOfMeasureLinear"]=$dim_unit;	
				
			$counter++;
			
			
		}//end foreach
		
		
	}

	
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->hikashop_orders))
				return $this->hikashop_orders;
			else
               return array();  

			
	}
	  
	  

	#######################################################################################################
	############################################### Function PrepareOrderStatusString #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareHikaShopOrderStatusFilter()
	{

					$order_status_filter="";
					
					if(HIKASHOP_RETRIEVE_ORDER_STATUS_1_CREATED==1)
					{
						$order_status_filter=" order_status='created' ";
					
					}
					if(HIKASHOP_RETRIEVE_ORDER_STATUS_2_CONFIRMED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status='confirmed'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status='confirmed'  ";
						}
					
					}
					if(HIKASHOP_RETRIEVE_ORDER_STATUS_3_SHIPPED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status='shipped'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status='shipped'  ";
						}
					
					}
					
					if(HIKASHOP_RETRIEVE_ORDER_STATUS_4_CANCELLED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status='cancelled'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status='cancelled'  ";
						}
					
					}
					
					if($order_status_filter!="")
					$order_status_filter="( ".$order_status_filter." ) and";
					
			
			return $order_status_filter;
			
	}
	
	
}
######################################### End of class ShippingZHikaShop ###################################################
	
	//create object & perform tasks based on command
	$obj_shipping_hikashop=new ShippingZHikaShop;
	$obj_shipping_hikashop->ExecuteCommand();	

?>
