<?php

define("SHIPPINGZJIGOSHOP_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// Last mod to this file: $Change$

// Function for checking Include Files
function Check_Include_File($filename)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		echo "\"$filename\" is not accessible.";
		exit;
	}

}

// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");


// TEST that all the files are same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZJIGOSHOP_VERSION && SHIPPINGZJIGOSHOP_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZJigoshop.php [".SHIPPINGZJIGOSHOP_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");

//include required wp file
if(Check_Include_File("wp-load.php"))
include("wp-load.php");

//Check Permalink structure
$port_number="";
$updated_host="";
if(strpos(DB_HOST, ':') !== false) {
  $split_host=explode(":",DB_HOST);
  $updated_host=$split_host[0];
  $port_number=$split_host[1];
} 

if($port_number!="")
$db_pdo=new PDO("mysql:host=".$updated_host.";port=".$port_number.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);
else
$db_pdo=new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);

global $wpdb;
											

################################################ Function convert_dim_unit #######################
//converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_unit=strtoupper($from_unit);
	}
	else 
	{
	
		$converted_unit="Unknown";
	}
	
	return $converted_unit;
}
########################################### Function get_actual_order_id ##############################
function get_actual_order_id($OrderNumber)
{
	global $wpdb;
	//Check if sequencial order number plugin is installed
	$args = array(
		'meta_key' => '_order_number',
		'meta_value' => $OrderNumber,
		'post_type' => 'shop_order'
	);
	$order_posts = get_posts($args);
	if(is_array($order_posts) && count($order_posts)>0)
	{
		$OrderNumber=$order_posts[0]->ID; //Find out actual order id
	}
	return $OrderNumber;
}
#######################################################################
		
//Use DB integration				
if($port_number!="")
$db_pdo=new PDO("mysql:host=".$updated_host.";port=".$port_number.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);
else
$db_pdo=new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);

############################################## Class SHIPPINGZJIGOSHOP ######################################
class SHIPPINGZJIGOSHOP extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	var $jigoshop_orders=array();
	############################################## Function Check_DB_Access #################################
	//Check Database access
	#######################################################################################################
	function Check_DB_Access()
	{
		global $db_pdo,$wpdb;
				
		$sql= "SHOW COLUMNS FROM ".$wpdb->prefix."posts ";	
					
		$order_status = $db_pdo->prepare($sql);										
		$order_status->execute();
		
		if ($order_status->rowCount()) 
		{
			$this->display_msg=DB_SUCCESS_MSG;
			
		}
		else
		{
			$this->display_msg=$this->display_msg='Error occurred:'.implode(":",$order_status->errorInfo());
		}
		
	}
	
	############################################## Function GetOrderCountByDate #################################
	//Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		
		global $db_pdo,$wpdb;
				
		//Get order count based on data range
		$order_status_filter=$this->PrepareJigoshopOrderStatusFilter();
		$sql = "SELECT DISTINCT " . $wpdb->prefix . "postmeta.post_id AS orders FROM " . $wpdb->prefix . "postmeta LEFT JOIN " . $wpdb->prefix . "posts ON (" . $wpdb->prefix . "postmeta.post_id = " . $wpdb->prefix . "posts.ID) LEFT JOIN " . $wpdb->prefix . "term_relationships ON (" . $wpdb->prefix . "posts.ID = " . $wpdb->prefix . "term_relationships.object_id) LEFT JOIN " . $wpdb->prefix . "term_taxonomy ON (" . $wpdb->prefix . "term_relationships.term_taxonomy_id = " . $wpdb->prefix . "term_taxonomy.term_taxonomy_id) LEFT JOIN " . $wpdb->prefix . "terms ON (" . $wpdb->prefix . "term_taxonomy.term_id = " . $wpdb->prefix . "terms.term_id) WHERE " . $wpdb->prefix . "posts.post_status = 'publish' AND " . $wpdb->prefix . "term_taxonomy.taxonomy = 'shop_order_status' AND " . $order_status_filter."  DATE_FORMAT(" . $wpdb->prefix . "posts.post_modified, '%Y-%m-%d %T') >= :datefrom  AND DATE_FORMAT(" . $wpdb->prefix . "posts.post_modified, '%Y-%m-%d %T') <= :dateto and ". $wpdb->prefix."posts.post_type='shop_order'";
		
		$orders = $db_pdo->prepare($sql);
		
		$data=array(':datefrom' => $this->ConvertDateToDbFormat($datefrom) , ':dateto' => $this->ConvertDateToDbFormat($dateto));
		
		$orders->execute($data);
		
		return $orders->rowCount();
	
	}
	############################################## Function UpdateShippingInfo #################################
	//Update order status 
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $db_pdo,$wpdb;
			
		$OrderNumber=get_actual_order_id($OrderNumber);
		$sql = "SELECT *," . $wpdb->prefix . "terms.name as order_status, ".$wpdb->prefix . "terms.term_id as order_status_id FROM " . $wpdb->prefix . "postmeta LEFT JOIN " . $wpdb->prefix . "posts ON (" . $wpdb->prefix . "postmeta.post_id = " . $wpdb->prefix . "posts.ID) LEFT JOIN " . $wpdb->prefix . "term_relationships ON (" . $wpdb->prefix . "posts.ID = " . $wpdb->prefix . "term_relationships.object_id) LEFT JOIN " . $wpdb->prefix . "term_taxonomy ON (" . $wpdb->prefix . "term_relationships.term_taxonomy_id = " . $wpdb->prefix . "term_taxonomy.term_taxonomy_id) LEFT JOIN " . $wpdb->prefix . "terms ON (" . $wpdb->prefix . "term_taxonomy.term_id = " . $wpdb->prefix . "terms.term_id) WHERE " . $wpdb->prefix . "posts.post_status = 'publish' AND " . $wpdb->prefix . "term_taxonomy.taxonomy = 'shop_order_status' and ".$wpdb->prefix . "postmeta.post_id=:order_id  and ". $wpdb->prefix."posts.post_type='shop_order'";
		
		
		$result = $db_pdo->prepare($sql);
		$result->execute(array(':order_id' => $OrderNumber));
		
		//check if order number is valid
		if($result->rowCount()>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
				
			if($Carrier!="")
			{
				$original_carrier=$Carrier;
				$Carrier=" via ".$Carrier;
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			if($TrackingNumber!="")
			$TrackingNumberString=", Tracking number $TrackingNumber";
			
				
			foreach( $result as $order )
			{
				$current_order_status=$order['order_status'];
			}
			
			//prepare $comments & save it
			$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
			
			$jigoshop_order_data = new jigoshop_order($OrderNumber);
			
			if(JIGOSHOP_SHIPPED_STATUS_SET_TO_STATUS_4_COMPLETE==1)
			{
							
				$change_order_status="completed";
			}
			else
			{
				 if(strtolower($current_order_status)=="on-hold")
					$change_order_status="pending";
				 else if(strtolower($current_order_status)=="waiting-for-payment")
					$change_order_status="pending";	
				else if(strtolower($current_order_status)=="pending")
					$change_order_status="processing";
				else if(strtolower($current_order_status)=="processing")
					$change_order_status="completed";
				else
				$change_order_status=$current_order_status;
									
			}
			
			
			// Update tracking information
			if(JIGOSHOP_TRACKING_NOTES_UPDATE_ONLY)
			{
				$jigoshop_order_data->add_order_note($comments);
			}
			else
			{
				$jigoshop_order_data->update_status($change_order_status, $comments );
			}
			
			
			
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			//display error message
			$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		} 	
		
	}
	############################################## Function Fetch_DB_Orders #################################
	//Perform Database query & fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		//Get orders based on data range
		global $db_pdo,$wpdb,$product_weight_unit;
				
		//Get order count based on data range
		$order_status_filter=$this->PrepareJigoshopOrderStatusFilter();
		
		$sql = "SELECT DISTINCT " . $wpdb->prefix . "postmeta.post_id AS orders FROM " . $wpdb->prefix . "postmeta LEFT JOIN " . $wpdb->prefix . "posts ON (" . $wpdb->prefix . "postmeta.post_id = " . $wpdb->prefix . "posts.ID) LEFT JOIN " . $wpdb->prefix . "term_relationships ON (" . $wpdb->prefix . "posts.ID = " . $wpdb->prefix . "term_relationships.object_id) LEFT JOIN " . $wpdb->prefix . "term_taxonomy ON (" . $wpdb->prefix . "term_relationships.term_taxonomy_id = " . $wpdb->prefix . "term_taxonomy.term_taxonomy_id) LEFT JOIN " . $wpdb->prefix . "terms ON (" . $wpdb->prefix . "term_taxonomy.term_id = " . $wpdb->prefix . "terms.term_id) WHERE " . $wpdb->prefix . "posts.post_status = 'publish' AND " . $wpdb->prefix . "term_taxonomy.taxonomy = 'shop_order_status' AND " . $order_status_filter."  DATE_FORMAT(" . $wpdb->prefix . "posts.post_modified, '%Y-%m-%d %T') >= :datefrom  AND DATE_FORMAT(" . $wpdb->prefix . "posts.post_modified, '%Y-%m-%d %T') <= :dateto and ". $wpdb->prefix."posts.post_type='shop_order'";
	
		
		$orders_result = $db_pdo->prepare($sql);
		
		$data=array(':datefrom' => $this->ConvertDateToDbFormat($datefrom) , ':dateto' => $this->ConvertDateToDbFormat($dateto));

		
		$orders_result->execute($data);
		
		$counter=0;
		$uom_weight="";
		$dim_unit="";
		foreach( $orders_result as $order )
		{
				
				$jigoshop_order_data = new jigoshop_order($order['orders']);
				$order_id=trim(str_replace('#', '', $jigoshop_order_data->get_order_number()));
				
				$order_tax_arr=$jigoshop_order_data->order_tax;
				$order_tax=0;
				if(isset($order_tax_arr['jigoshop_zero_rate']['amount']))
				$order_tax=$order_tax_arr['jigoshop_zero_rate']['amount'];
				
				$jigoshop_order_products_temp=(array) maybe_unserialize( get_post_meta($order_id, 'order_items', true) );
				
				if(count($jigoshop_order_products_temp)==0)
				continue;
											
				//prepare order array
				$this->jigoshop_orders[$counter]=new stdClass();
				$this->jigoshop_orders[$counter]->orderid=$order_id;
																
				//billing details
				$this->jigoshop_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($jigoshop_order_data,'billing_first_name');
				$this->jigoshop_orders[$counter]->order_billing["LastName"]=$this->Check_Field($jigoshop_order_data,'billing_last_name');
				$this->jigoshop_orders[$counter]->order_billing["Company"]=$this->Check_Field($jigoshop_order_data,'billing_company');
				$this->jigoshop_orders[$counter]->order_billing["Address1"]=$this->Check_Field($jigoshop_order_data,'billing_address_1');
				$this->jigoshop_orders[$counter]->order_billing["Address2"]=$this->Check_Field($jigoshop_order_data,'billing_address_2');
				$this->jigoshop_orders[$counter]->order_billing["City"]=$this->Check_Field($jigoshop_order_data,'billing_city');
				$this->jigoshop_orders[$counter]->order_billing["State"]=$this->Check_Field($jigoshop_order_data,'billing_state');
				$this->jigoshop_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($jigoshop_order_data,'billing_postcode');
				$this->jigoshop_orders[$counter]->order_billing["Country"]=$this->Check_Field($jigoshop_order_data,'billing_country');
				$this->jigoshop_orders[$counter]->order_billing["Phone"]=$this->Check_Field($jigoshop_order_data,'billing_phone');
				
				//shipping details
				$this->jigoshop_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field($jigoshop_order_data,'shipping_first_name');
				$this->jigoshop_orders[$counter]->order_shipping["LastName"]=$this->Check_Field($jigoshop_order_data,'shipping_last_name');
				$this->jigoshop_orders[$counter]->order_shipping["Company"]=$this->Check_Field($jigoshop_order_data,'shipping_company');
				$this->jigoshop_orders[$counter]->order_shipping["Address1"]=$this->Check_Field($jigoshop_order_data,'shipping_address_1');
				$this->jigoshop_orders[$counter]->order_shipping["Address2"]=$this->Check_Field($jigoshop_order_data,'shipping_address_2');
				$this->jigoshop_orders[$counter]->order_shipping["City"]=$this->Check_Field($jigoshop_order_data,'shipping_city');
				$this->jigoshop_orders[$counter]->order_shipping["State"]=$this->Check_Field($jigoshop_order_data,'shipping_state');
				$this->jigoshop_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field($jigoshop_order_data,'shipping_postcode');
				$this->jigoshop_orders[$counter]->order_shipping["Country"]=	$this->Check_Field($jigoshop_order_data,'shipping_country');
				$this->jigoshop_orders[$counter]->order_shipping["Phone"]=$this->Check_Field($jigoshop_order_data,'billing_phone');
				$this->jigoshop_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($jigoshop_order_data,'billing_email');
					
										
				//order info
				$order_date_actual = new DateTime($this->Check_Field($jigoshop_order_data,'order_date'));
				$this->jigoshop_orders[$counter]->order_info["OrderDate"]= $order_date_actual->format('Y-m-d\TH:i:00\Z');
				
							
				$this->jigoshop_orders[$counter]->order_info["Total"]=number_format((float)$this->Check_Field($jigoshop_order_data,'order_total'),2,'.',''); 
				$this->jigoshop_orders[$counter]->order_info["ItemsTax"]=number_format((float)$order_tax,2,'.','');
					
					
				$this->jigoshop_orders[$counter]->order_info["OrderNumber"]=$order_id;
				$this->jigoshop_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->Check_Field($jigoshop_order_data,'payment_method_title'));
				
				
				$this->jigoshop_orders[$counter]->order_info["ShippingChargesPaid"]=number_format((float)$this->Check_Field($jigoshop_order_data,'order_shipping'),2,'.','');
				$this->jigoshop_orders[$counter]->order_info["ShipMethod"]=$this->Check_Field($jigoshop_order_data,'shipping_method');
				
				$this->jigoshop_orders[$counter]->order_info["Comments"]=$this->Check_Field($jigoshop_order_data,'customer_note');	
				
				$customer_id=(int)get_post_meta($order_id, 'customer_user', true);
				
				if($customer_id>0)
				{
					$customer = get_userdata($customer_id);
					$this->jigoshop_orders[$counter]->order_info["ExternalID"]=$customer->display_name." ".$this->jigoshop_orders[$counter]->order_info["OrderNumber"] . '-' . $this->jigoshop_orders[$counter]->order_info["OrderDate"];
				}	
				else
				$this->jigoshop_orders[$counter]->order_info["ExternalID"]=$this->jigoshop_orders[$counter]->order_info["OrderNumber"] . '-' . $this->jigoshop_orders[$counter]->order_info["OrderDate"];		
	
				$order_status=$this->Check_Field($jigoshop_order_data,'status');
				
				if($order_status!="on-hold" && $order_status!="pending"  && $order_status!="waiting-for-payment" )
					$this->jigoshop_orders[$counter]->order_info["PaymentStatus"]=2;
				else
					$this->jigoshop_orders[$counter]->order_info["PaymentStatus"]=0;
				
				//Show Order status
				if($order_status=="completed" || $order_status=="completed")
					$this->jigoshop_orders[$counter]->order_info["IsShipped"]=1;
				else
					$this->jigoshop_orders[$counter]->order_info["IsShipped"]=0;
					
				//show if cancelled
				if($order_status=="cancelled" || $order_status=="cancelled")
					$this->jigoshop_orders[$counter]->order_info["IsCancelled"]=1;
				else
					$this->jigoshop_orders[$counter]->order_info["IsCancelled"]=0;
					
						
				$actual_number_of_products=0;
				
				$this->jigoshop_orders[$counter]->order_info["ItemsTotal"]=0;				
				foreach($jigoshop_order_products_temp as $key=>$jigoshop_order_products)
				{
				
				
				if($jigoshop_order_products['name']!="")
				{					
					$product_additional_details=$jigoshop_order_data->get_product_from_item($jigoshop_order_products);
					
					$product_attr_string="";
					if(isset($jigoshop_order_products['variation_id']))
					{
						if($jigoshop_order_products['variation_id']!="")
						{
							$attributes_arr=$jigoshop_order_products['variation'];
							if(is_array($attributes_arr))
							{
								foreach($attributes_arr as $key=>$val)
								{
									$key=str_replace("tax_","",$key);
									if($product_attr_string!="")
									$product_attr_string.=",";
									
									$product_attr_string.=$key.":".$val;
								
								}
							  }
						}					
					}
					if($product_attr_string!="")
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$jigoshop_order_products['name']." (".$product_attr_string.")";
					else
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$jigoshop_order_products['name'];
					
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Price"]=number_format($jigoshop_order_products['cost'],2,'.','');
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$product_additional_details->get_sku();
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($jigoshop_order_products['qty'],2,'.','');
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format(($jigoshop_order_products['cost']*$jigoshop_order_products['qty']),2,'.','');
					$this->jigoshop_orders[$counter]->order_info["ItemsTotal"]+=$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Total"];
					$product_weight=$product_additional_details->get_weight();
					$dimensions = $product_additional_details->has_dimensions();
					
					if($product_additional_details->has_dimensions(true))
					{
						
										
						if($product_additional_details->get_length()>0)
						$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]['ItemLength']=number_format($product_additional_details->get_length(),2,'.','');
						if($product_additional_details->get_width()>0)
						$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]['ItemWidth']=number_format($product_additional_details->get_width(),2,'.','');
						if($product_additional_details->get_height()>0)
						$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]['ItemHeight']=number_format($product_additional_details->get_height(),2,'.','');
						
						$dim_unit=convert_dim_unit(Jigoshop_Base::get_options()->get('jigoshop_dimension_unit'));
					}	
					$product_weight_unit=Jigoshop_Base::get_options()->get('jigoshop_weight_unit');
					if($product_weight!="")
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format($product_weight*$jigoshop_order_products['qty'],2,'.','');
					
					$total_weight_with_unit=$this->ConvertToAcceptedUnitWeight(($product_weight*$jigoshop_order_products['qty']),strtolower($product_weight_unit));
					$total_weight_with_unit=explode("~",$total_weight_with_unit);
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format($total_weight_with_unit[0],2,'.','');
					$uom_weight=$total_weight_with_unit[1];
					$this->jigoshop_orders[$counter]->order_product[$actual_number_of_products]["Notes"]="";
					$actual_number_of_products++;						
				}
			  }
			$this->jigoshop_orders[$counter]->num_of_products=$actual_number_of_products;
			$this->jigoshop_orders[$counter]->order_info["UnitsOfMeasureWeight"]=$uom_weight;
			if($dim_unit!="")
			$this->jigoshop_orders[$counter]->order_info["UnitsOfMeasureLinear"]=$dim_unit;	
			$counter++;
		}
		
	}
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->jigoshop_orders))
				return $this->jigoshop_orders;
			else
							return array();  
			
	}
	############################################## Function Check_Field #################################
	//Check & Return field value if available
	#######################################################################################################
	function Check_Field($obj,$field)
	{
		if(is_object($obj))
		{
			
			if(null !==($obj->{$field}))
			{
						
				return $obj->{$field};
			}
			else
		   {
				return "";
			}
						
		}
		else
		{
			return "";
		}
		
	}
	############################################## Function ConvertDateToDbFormat #################################

	//"T" & "Z" remove from UTC format(in ISO 8601) 
	#######################################################################################################
	function ConvertDateToDbFormat($server_date_utc)  
	{
		if(strpos($server_date_utc,"Z"))
		{
			$utc_fotmat_temp=str_replace("Z","",$server_date_utc);
			$server_date_utc=str_replace("T","",$utc_fotmat_temp);
		   
		}  
		return $server_date_utc;
	}
	
	################################################ Function PrepareJigoshopOrderStatusFilter #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareJigoshopOrderStatusFilter()
	{
			global $wpdb;
			
			$order_status_filter="";
			
			
			if(JIGOSHOP_RETRIEVE_ORDER_STATUS_0_ON_HOLD==1)
			{
				$order_status_filter=$wpdb->prefix . "terms.name = 'on-hold'";
			
			}
			if(JIGOSHOP_RETRIEVE_ORDER_STATUS_1_WAITING_FOR_PAYMENT==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "terms.name = 'waiting-for-payment'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "terms.name = 'waiting-for-payment'";
				}
			
			}
			if(JIGOSHOP_RETRIEVE_ORDER_STATUS_2_PENDING==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "terms.name = 'pending'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "terms.name = 'pending'";
				}
			
			}
			if(JIGOSHOP_RETRIEVE_ORDER_STATUS_3_PROCESSING==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "terms.name = 'processing'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "terms.name = 'processing'";
				}
			
			}
			
			if(JIGOSHOP_RETRIEVE_ORDER_STATUS_4_COMPLETE==1 )
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "terms.name = 'completed'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "terms.name= 'completed'";
				}
			}
			if(JIGOSHOP_RETRIEVE_ORDER_STATUS_5_CANCELLED==1)
			{
			
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "terms.name = 'cancelled'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "terms.name = 'cancelled'";
				}
			
			}

			
			if($order_status_filter!="")
			$order_status_filter="( ".$order_status_filter." ) and";
			return $order_status_filter;
			
	}
			
	
}
######################################### End of class SHIPPINGZJIGOSHOP ###################################################

	// create object & perform tasks based on command

	$obj_shipping_jigoshop=new SHIPPINGZJIGOSHOP;
	$obj_shipping_jigoshop->ExecuteCommand();

?>
