<?php

define("SHIPPINGZJMARKET_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// { $Revision$ }
// { $File$ }

//Function for checking Include Files
function Check_Include_File($filename, $mage_check=0)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		if($mage_check)
		{
			echo "\"$filename\" is not accessible.<br><br>";
			echo "Please, place all ShippingZ PHP files which are listed below at root folder of your Joomla website.<br>";
			echo "-ShippingZJmarket.php<br>";
			echo "-ShippingZSettings.php<br>";
			echo "-ShippingZClasses.php<br>";
			echo "-ShippingZMessages.php<br>";
		}
		else
		{
			echo "\"$filename\" is not accessible.";
		}
		exit;
	}

}
//Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");

// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZJMARKET_VERSION && SHIPPINGZJMARKET_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZJmarket.php [".SHIPPINGZJMARKET_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

//Incude reqired Joomla files
define('_JEXEC', 1);
define( 'DS', DIRECTORY_SEPARATOR );
if (file_exists(dirname(__FILE__) . '/defines.php')) {
	include_once dirname(__FILE__) . '/defines.php';
}

if (!defined('_JDEFINES')) {
	define('JPATH_BASE', dirname(__FILE__));
	require_once JPATH_BASE.'/includes/defines.php';
}

require_once( JPATH_BASE . DS . 'libraries' . DS . 'import.php' ); // framework
require_once( JPATH_BASE . DS . 'configuration.php' ); // config file

require_once JPATH_BASE.'/includes/framework.php';

$db = JFactory::getDBO();
############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");
############################################## Class ShippingZJmarket ##########################################
class ShippingZJmarket extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	############################################## Function Check_DB_Access #################################
	//Check Database access
	#######################################################################################################
	function Check_DB_Access()
	{
		
		global $db;
		
		try //See if we can access joomla database
		{
			$query="Show columns FROM #__orders_node ";
			$db->setQuery($query);
			$db->query();
			$num_rows = $db->getNumRows();
			if($num_rows>0)
			$this->display_msg=DB_SUCCESS_MSG;
		}
		catch(Exception $e)
		{
			
			$this->display_msg="Could not access Joomla database";
			$this->SetXmlError(1,$this->display_msg);
			exit;
				
		}
			
	}
	
	
	############################################## Function Check_Field #################################
	//Check & Return field value if available
	#######################################################################################################
	function Check_Field($obj,$field,$arg="")
	{
		if(is_object($obj))
		{
			if($arg!="")
			{
				if($arg!=0)
				{
					if(null !==($obj->{$field}($arg)))
					{
						
						return $obj->{$field}($arg);
					}
					else
					{
						return "";
					}
				}
				else
				{
					if(null !==($obj->{$field}()))
					{
						
						return $obj->{$field}();
					}
					else
					{
						return "";
					}
				}
			}
			else
			{
				
				if($obj->{$field}!="")
				{
					
					return $obj->{$field};
				}
				else
				{
					return "";
				}
			}
			
		}
		else
		{
			return "";
		}
		
	}
	############################################## Function GetOrderCountByDate #################################
	//Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		global $db;
		
		$order_status_filter=$this->PrepareJmarketOrderStatusFilter();
				
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);
		
		$sql = "SELECT oid FROM #__orders_node ";
		$sql .= " WHERE " . $order_status_filter . "";
		$sql .= " (( modified between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp).") OR  ( created between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp)." ))";
		
		$db->setQuery($sql);
		$db->query();
		$num_rows = $db->getNumRows();
			
		return $num_rows;
	
	}
	############################################## Function UpdateShippingInfo #################################
	//Update order status
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		
		global $db;
				
		$sql = "SELECT * FROM #__orders_node where oid=".$OrderNumber;
		$db->setQuery($sql);
		$db->query();
		$num_rows = $db->getNumRows();
		
		//check if order number is valid
		if($num_rows>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			$tracking_url="";	
			if($Carrier!="")
			{
				if(defined(strtoupper($Carrier)."_URL"))
				{
					$tracking_url=" <a href=\"".$Carrier."_URL"."\" target=\"_blank\"> $TrackingNumber</a>";
					$tracking_url=str_replace("[TRACKING_NUMBER]",$TrackingNumber,$tracking_url);
				}
				$Carrier=" via ".$Carrier;
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			if($TrackingNumber!="")
			{
				if($tracking_url!="")
				{
					$TrackingNumberString=", Tracking number $tracking_url";
				}
				else
				{
					$TrackingNumberString=", Tracking number $TrackingNumber";
				}
			}
			
			$order_data_row = $db->loadObjectList();
			
			foreach ($order_data_row as $order_data)
			{
				$current_order_status=$order_data->ostatusid;
				$payid=$order_data->payid;
				$uid=$order_data->uid;
			}
			
			
								
			//prepare $comments & save it
			$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
			
			if(JMARKET_SHIPPED_STATUS_SET_TO_STATUS_4_COMPLETED==1)
			{
				$change_order_status=20; //completed			  
			} 
			else
			{
			 	
				if($current_order_status==10) //pending=>in-progress
					$change_order_status=15;
				else if($current_order_status==15)//in-progress=>processed
					$change_order_status=25;
				else if($current_order_status==25)//processed=>completed
					$change_order_status=20;
				else
					$change_order_status=$current_order_status;
				
						 
			 }
			 
			 $sql = "Update #__orders_node set comments=".$db->quote($comments).",  trackno=".$db->quote($TrackingNumber).", ostatusid=".$db->quote($change_order_status).", modified='".time()."' where oid=".$OrderNumber;
			 $db->setQuery($sql);
			 $db->query();
			 
			 if($change_order_status!=$current_order_status)
			 {
				 $sql = "Insert into #__orders_history set oid='".$OrderNumber."',  ostatusid=".$db->quote($change_order_status).", payid=".$db->quote($payid).", created='".time()."', uid=".$db->quote($uid);
				  $db->setQuery($sql);
				 $db->query();
			}
			
			 $this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			//display error message
			$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		}	
		
	}
	############################################## Function Fetch_DB_Orders #################################
	//Fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $db;
		
		$order_status_filter=$this->PrepareJmarketOrderStatusFilter();
				
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);
		
		$sql = "SELECT * FROM #__orders_node ";
		$sql .= " WHERE " . $order_status_filter . "";
		$sql .= " (( modified between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp).") OR  ( created between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp)." ))";
		
		$db->setQuery($sql);
		$order_data = $db->loadObjectList();
		
		$this->jmarket_orders=array();
		$counter=0;
		
		foreach ($order_data as $order) 
		{
		
			$order_id=$order->oid;
			
				
			//prepare order array
			$this->jmarket_orders[$counter]=new stdClass();
			$this->jmarket_orders[$counter]->orderid=$order_id;
			
			$user_id=$order->uid;
			
			$sql_user = "SELECT * FROM #__members_node ";
            $sql_user .= " WHERE uid=".$user_id;
				
			$db->setQuery($sql_user);
		    $user_data_row = $db->loadObjectList();
			$user_data=$user_data_row[0];
			
			$address_id_billing=$order->adidbilling;
			$sql_address = "SELECT * FROM #__address_node ";
            $sql_address .= " WHERE adid=".$address_id_billing;
				
			$db->setQuery($sql_address);
		    $billing_address_data_row = $db->loadObjectList();
			$billing_address_data=$billing_address_data_row[0];
			
			$country_id=$billing_address_data->ctyid;
			$sql_country = "SELECT * FROM #__joobi_countries ";
            $sql_country .= " WHERE ctyid=".$country_id;
				
			$db->setQuery($sql_country);
		    $country_data_row = $db->loadObjectList();
		    $country_data= $country_data_row[0];
			
			
			$currency_id=$order->curid;
			$sql_currency = "SELECT * FROM #__currency_node ";
            $sql_currency .= " WHERE curid=".$currency_id;
				
			$db->setQuery($sql_currency);
		    $currency_data_row = $db->loadObjectList();
			$currency_data=$currency_data_row[0];
						
			//billing details
			$this->jmarket_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($user_data,'name');
			$this->jmarket_orders[$counter]->order_billing["LastName"]="";
			$this->jmarket_orders[$counter]->order_billing["Company"]="";
			$this->jmarket_orders[$counter]->order_billing["Address1"]=$this->Check_Field($billing_address_data,'address1');
			$this->jmarket_orders[$counter]->order_billing["Address2"]=$this->Check_Field($billing_address_data,'address2');
			$this->jmarket_orders[$counter]->order_billing["City"]=$this->Check_Field($billing_address_data,'city');
			$this->jmarket_orders[$counter]->order_billing["State"]=$this->Check_Field($billing_address_data,'state');
			$this->jmarket_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($billing_address_data,'zipcode');
			$this->jmarket_orders[$counter]->order_billing["Country"]=$this->Check_Field($country_data,'name');
			$this->jmarket_orders[$counter]->order_billing["Phone"]=$this->Check_Field($billing_address_data,'phone');
			
			//shipping details
			$this->jmarket_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field($user_data,'name');
			$this->jmarket_orders[$counter]->order_shipping["LastName"]="";
			$this->jmarket_orders[$counter]->order_shipping["Company"]="";
			$this->jmarket_orders[$counter]->order_shipping["Address1"]=$this->Check_Field($billing_address_data,'address1');
			$this->jmarket_orders[$counter]->order_shipping["Address2"]=$this->Check_Field($billing_address_data,'address2');
			$this->jmarket_orders[$counter]->order_shipping["City"]=$this->Check_Field($billing_address_data,'city');
			$this->jmarket_orders[$counter]->order_shipping["State"]=$this->Check_Field($billing_address_data,'state');
			$this->jmarket_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field($billing_address_data,'zipcode');
			$this->jmarket_orders[$counter]->order_shipping["Country"]=$this->Check_Field($country_data,'name');
			$this->jmarket_orders[$counter]->order_shipping["Phone"]=$this->Check_Field($billing_address_data,'phone');
			
			$this->jmarket_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($user_data,'email');
			
					
			//order info
			$this->jmarket_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTC(true,$this->Check_Field($order,'created'));
			$this->jmarket_orders[$counter]->order_info["Currency"]=strtoupper(($this->Check_Field($currency_data,'code')));
			$this->jmarket_orders[$counter]->order_info["ItemsTotal"]=number_format($this->Check_Field($order,'subtotal'),2,'.','');
			$this->jmarket_orders[$counter]->order_info["Total"]=number_format($this->Check_Field($order,'totalprice'),2,'.','');
				
					
			if($this->Check_Field($order,'totaltax')!="")
			{
				
				$this->jmarket_orders[$counter]->order_info["ItemsTax"]=number_format($this->Check_Field($order,'totaltax'),2,'.','');
				
			}
			else
			{
				$this->jmarket_orders[$counter]->order_info["ItemsTax"]=0.00;
			}
			$this->jmarket_orders[$counter]->order_info["OrderNumber"]=$order_id;
			
			//Get Payment details
			$payment_id=$order->payid;
			$sql_payment = "SELECT * FROM #__payment_node ";
            $sql_payment .= " WHERE payid=".$payment_id;
				
			$db->setQuery($sql_payment);
		    $payment_data_row = $db->loadObjectList();
			$payment_data=$payment_data_row[0];
			$payment_method=$this->Check_Field($payment_data,'name');
			
			if($payment_method!="")
			{
				$this->jmarket_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($payment_method);
			}
			else
			{
				$this->jmarket_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType("other");
			}
			
			$this->jmarket_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($this->Check_Field($order,'totalshipping'),2,'.','');
			
			//shipping details
			$shipping_method="";
			$shipping_id=$order->shipid;
			if($shipping_id>0)
			{
				$sql_shipping = "SELECT * FROM #__shipping_node ";
				$sql_shipping .= " WHERE shipid=".$shipping_id;
					
				$db->setQuery($sql_shipping);
				$shipping_data_row = $db->loadObjectList();
				$shipping_data=$shipping_data_row[0];
				$shipping_method=$this->Check_Field($shipping_data,'name');		
			}
				
			$this->jmarket_orders[$counter]->order_info["ShipMethod"]=$shipping_method;
			$this->jmarket_orders[$counter]->order_info["Comments"]=$this->Check_Field($order,'comments');			
			
			if($order->ostatusid!=10)
				$this->jmarket_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->jmarket_orders[$counter]->order_info["PaymentStatus"]=0;
			
			//Show Order status
			if($order->ostatusid==20)
				$this->jmarket_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->jmarket_orders[$counter]->order_info["IsShipped"]=0;
			
				
			//show if cancelled
			if($order->ostatusid==99)
				$this->jmarket_orders[$counter]->order_info["IsCancelled"]=1;
			else
				$this->jmarket_orders[$counter]->order_info["IsCancelled"]=0;
					
			
			
			//Get order products
			$actual_number_of_products=0;
			
			$sql_products = "SELECT * FROM #__orders_products ";
            $sql_products .= " WHERE oid=".$order_id;
				
			$db->setQuery($sql_products);
		    $order_items = $db->loadObjectList();
			
					
			foreach ($order_items as $item)
			{
							
				$product_id=$item->pid;
				$sql_product_weight = "SELECT * FROM #__product_node";
                $sql_product_weight .= " WHERE pid=".$product_id;
				
			    $db->setQuery($sql_product_weight);
		        $product_details_data_row = $db->loadObjectList();
			    $product_details_data=$product_details_data_row[0];
			   
			    $item_weight=$product_details_data->weight;
				
		
				
				//attribute details
				$ordproduct_id=$item->ordpid;
				$sql_product_attributes = "SELECT * FROM #__orders_poptions";
                $sql_product_attributes .= " WHERE oid=".$order_id." and ordpid=".$ordproduct_id;
				
			    $db->setQuery($sql_product_attributes);
		        $product_attributes_data_row = $db->loadObjectList();
			  
			   
			    $attribute_str="";
			    foreach( $product_attributes_data_row as  $product_attributes_data)
				{
						
						if($attribute_str!="")
						$attribute_str.=",";
						
						
						$attribute_str.=$product_attributes_data->optname.":".$product_attributes_data->optvaluename;
				}
				
				if($attribute_str!="")
				$attribute_str=" (".$attribute_str.")";
				
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$this->Check_Field($item,'name').$attribute_str;
							
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$this->Check_Field($item,'unitprice');
							
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$product_details_data->namekey;
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=$this->Check_Field($item,'quantity');
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format(($item_weight*$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format(($this->Check_Field($item,'price')*$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format(($item_weight*$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');
				
				$this->jmarket_orders[$counter]->order_product[$actual_number_of_products]["Notes"]="";
				
								
				$actual_number_of_products++;
				
				
			}
			
			$this->jmarket_orders[$counter]->num_of_products=$actual_number_of_products;
			
			
			
			$counter++;
		}	
	
		
		
	}

	
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->jmarket_orders))
				return $this->jmarket_orders;
			else
               return array();  

			
	}
	  
	  

	#######################################################################################################
	############################################### Function PrepareOrderStatusString #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareJmarketOrderStatusFilter()
	{
			
					$order_status_filter="";
					
					if(JMARKET_RETRIEVE_ORDER_STATUS_1_PENDING==1)
					{
						$order_status_filter=" ostatusid='10' ";
					
					}
					if(JMARKET_RETRIEVE_ORDER_STATUS_2_IN_PROGRESS==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" ostatusid='15'  ";
						}
						else
						{
							$order_status_filter.=" OR ostatusid='15'  ";
						}
					
					}
					if(JMARKET_RETRIEVE_ORDER_STATUS_3_PROCESSED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" ostatusid='25'  ";
						}
						else
						{
							$order_status_filter.=" OR ostatusid='25'  ";
						}
					
					}
					if(JMARKET_RETRIEVE_ORDER_STATUS_4_COMPLETED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" ostatusid='20'  ";
						}
						else
						{
							$order_status_filter.=" OR ostatusid='20' ";
						}
					
					}
					if(JMARKET_RETRIEVE_ORDER_STATUS_5_CANCELLED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" ostatusid='99'  ";
						}
						else
						{
							$order_status_filter.=" OR ostatusid='99'  ";
						}
					
					}
					
					if($order_status_filter!="")
					$order_status_filter="( ".$order_status_filter." ) and";
					
			
			return $order_status_filter;
			
	}
	
	
}
######################################### End of class ShippingZJmarket ###################################################
	
	//create object & perform tasks based on command
	$obj_shipping_jmarket=new ShippingZJmarket;
	$obj_shipping_jmarket->ExecuteCommand();	

?>
