<?php
define("SHIPPINGZMAGENTO_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// { $Revision$ }
// { $File$ }

// Function for checking Include Files
function Check_Include_File($filename, $mage_check=0)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		if($mage_check)
		{
			echo "\"$filename\" is not accessible.<br><br>";
			echo "Please, place all ShippingZ PHP files which are listed below at root folder of your magento website.<br>";
			echo "-ShippingZMagento.php<br>";
			echo "-ShippingZSettings.php<br>";
			echo "-ShippingZClasses.php<br>";
			echo "-ShippingZMessages.php<br>";
		}
		else
		{
			echo "\"$filename\" is not accessible.";
		}
		exit;
	}

}

// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");

// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZMAGENTO_VERSION && SHIPPINGZMAGENTO_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZMagento.php [".SHIPPINGZMAGENTO_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

// Magento Version Detection
if(file_exists("app/Mage.php")) //If Mage.php exists, it indicates Magento 1.x
{
 // *********Magento 1.x Section****************** Magento 1.x Section **********************************************/
	include("app/Mage.php");
	
	
	if(!defined("Magento_Store_Code_To_Service"))
	define("Magento_Store_Code_To_Service","-ALL-");
	
	if(!defined("Magento_Enterprise_Edition"))
	define("Magento_Enterprise_Edition",0);
	
	$app = Mage::app();
	$magentoVersion = Mage::getVersion();
	
	if(Magento_Store_Code_To_Service!='-ALL-')
	{
		$single_store=0;
		$allStores = array_keys(Mage::app()->getStores());
	
		if(!strstr(Magento_Store_Code_To_Service,","))
		{
			$single_store=1; // single store 
		}
		else
		{
			$seleted_store_code_arr=explode(",",Magento_Store_Code_To_Service);
				
		}
	
		foreach ($allStores as $_eachStoreId)
		{
		   $store = Mage::app()->getStore($_eachStoreId);
		   					
		   if($single_store)
		   {
				if($store->getCode()==Magento_Store_Code_To_Service) 
				{
					$selected_store_id=$_eachStoreId;
					$selected_store_filter=" store_id=".$selected_store_id;		
				}
			}
			else
			{
				if(in_array($store->getCode(),$seleted_store_code_arr)) 
				{
					$selected_store_id=$_eachStoreId;
					
					if($selected_store_filter=="")
					$selected_store_filter.=" ( ";
					else 
					$selected_store_filter.=" OR ";
					
					$selected_store_filter.=" store_id=".$selected_store_id;
				}
			}
		}
		
		if(!$single_store)
		$selected_store_filter.=" ) ";	
	}
	else
	$selected_store_filter="";
	
	################################################ POS/Warehouses ##########################################################
	$selected_warehouse_filter="";
	if(!defined(Magento_Wyomind_Advanced_Inventory))
	define("Magento_Wyomind_Advanced_Inventory","0");
	
	if(Magento_Wyomind_Advanced_Inventory)
	{
		if(Magento_Warehouse_To_Service!="-ALL-")
		{
			$allWarehouses = Mage::getModel('pointofsale/pointofsale')->getCollection();;
			foreach($allWarehouses as $warehouses)
			{				
				$warehouses_id=$warehouses['place_id'];
				$warehouses_code=$warehouses['store_code'];
				$warehouses_name=$warehouses['name'];
				
				if(Magento_Warehouse_To_Service==$warehouses_code)
				{
					$select_warehouse_id=$warehouses_id;
					$selected_warehouse_filter=" and FIND_IN_SET('".$warehouses_id."',assignation_warehouse) > 0 ";
				}
			}
		}
	}
	
	############################################### Check & adjust "default_socket_timeout"#######################################
	$timeout_value="";
	$timeout_value=@ini_get("default_socket_timeout");
	if($timeout_value!="" && $timeout_value<120)
	@ini_set("default_socket_timeout",120);
	
	############################################## Always Enable Exception Handler ###############################################
	error_reporting(E_ALL);
	ini_set('display_errors', '1');
	set_error_handler("ShippingZ_Exception_Error_Handler");
	
	############################################## Class ShippingZMagento ########################################################
	class ShippingZMagento extends ShippingZGenericShoppingCart
	{
		
		// cart specific functions goes here
		############################################## Function Check_DB_Access #################################
		// Check Database access(for magento everything will be done using mage, hence check access to order model)
		#########################################################################################################
		
		function Check_DB_Access()
		{			
			try //See if we can access order model
			{
				$orders_data = Mage::getModel('sales/order')->getCollection();
				$this->display_msg=DB_SUCCESS_MSG;
			}
			catch(Exception $e)
			{
				
				$this->display_msg="Could not access order model";
				$this->SetXmlError(1,$this->display_msg);
				exit;					
			}				
		}
		
		############################################## Function UpdateDatefrom  #################################
		// if Day(DateFrom) = Day(DateTo) then set DateFrom to previous day
		#######################################################################################################
		function UpdateDatefrom($datefrom,$dateto)
		{
			
			$day_datefrom=substr($datefrom,0,10);
			$day_dateto=substr($dateto,0,10);
			
			$time_str_datefrom=substr($datefrom,10);
			
			if($day_datefrom==$day_dateto)
			{
				$updated_date_from=date("Y-m-d",strtotime("-1 day", strtotime($day_datefrom)));
				$updated_date_from=$updated_date_from.$time_str_datefrom;
				return $updated_date_from;
			}
			else
			{
				return $datefrom;
			}			
		}
		
		############################################## Function SafeUnserialize  #################################
		// This will return false in case the passed string is not unserializeable
		#######################################################################################################
		function SafeUnserialize($serialized_string) 
		{
			if (strpos($serialized_string, "\0") === false &&  is_string($serialized_string) ) {
				if (strpos($serialized_string, 'O:') === false) {
				  
					return @unserialize($serialized_string);
				} else if (!preg_match('/(^|;|{|})O:[0-9]+:"/', $serialized_string)) {
				   
					return @unserialize($serialized_string);
				}
			}
			return false;
		}
		############################################## Function GetProductOptions  #################################
		// Used to get product attributes and sku for product variations
		#######################################################################################################
		function GetProductOptions($option_arr,$code='')
		{
				if($code=="")
				{
					// get attribute details
					$formatted_option_variation_details="";
								
					if(isset($option_arr['attributes_info']) && is_array($option_arr['attributes_info']))
					{						
						foreach($option_arr['attributes_info'] as $key=>$val)
						{							
							if(is_array($val))
							{
								foreach($val as $key2=>$value2)
								{									
									if($key2=="label")
									{
										$curr_label=$value2;
									}
									else if($key2=="value")
									{
										if($formatted_option_variation_details!="")
											$formatted_option_variation_details.=", ".$curr_label.":".$value2;
										else
											$formatted_option_variation_details=$curr_label.":".$value2;
									}									
								}
							}							
						}		
						
						if($formatted_option_variation_details!="")
						{
							return " (".$formatted_option_variation_details.")";	
						}
						else
						{						
							return '';
						}						
					}
				}
				else
				{	
						//get simple sku
						if(isset($option_arr[$code]))
							return "-".$option_arr[$code];
						else
							return '';									
				}	
		}
		
		############################################## Function GetProductOptionValuebyLabel  #################################
		// Used to get product attributes by label
		#######################################################################################################################
		function GetProductOptionValuebyLabel($option_string,$label='')
		{
				$option_arr=$this->SafeUnserialize($option_string);
				
				// get attribute details
				$formatted_option_variation_details="";
							
				if(isset($option_arr['attributes_info']))
				{
					foreach($option_arr['attributes_info'] as $key=>$val)
					{
						$curr_label=0;
						
						foreach($val as $key2=>$value2)
						{
							if($key2=="label")
							{
								if($value2==$label)
								{
									$curr_label=1;
								}
							}
							else if($key2=="value" && $curr_label==1)
							{
								return $value2;
							}							
						}						
					}
				}			
		}
		############################################## Function GetCustomFieldsByLabel  #################################
		// Used to get product custom fields by label
		#######################################################################################################################
		function GetCustomFieldsByLabel($option_arr,$label='')
		{
				// get custom field details
				$formatted_option_variation_details="";
							
				if(isset($option_arr['options']))
				{
					foreach($option_arr['options'] as $key=>$val)
					{
						$curr_label=0;
						
						foreach($val as $key2=>$value2)
						{
							if($key2=="label")
							{
								if($value2==$label)
								{
									$curr_label=1;
								}
							}
							else if($key2=="value" && $curr_label==1)
							{
								return $value2;
							}							
						}						
					}
				}			
		}
		
		############################################## Function Check_Field ###################################
		// Check & Return field value if available
		#######################################################################################################
		function Check_Field($obj,$field,$arg="")
		{
			if(is_object($obj))
			{
				if($arg!="")
				{
					if($arg!=0)
					{
						if(null !==($obj->{$field}($arg)))
						{
							
							return $obj->{$field}($arg);
						}
						else
						{
							return "";
						}
					}
					else
					{
						if(null !==($obj->{$field}()))
						{
							return $obj->{$field}();
						}
						else
						{
							return "";
						}
					}
				}
				else
				{					
					if($obj->{$field}!="")
					{
						return $obj->{$field};
					}
					else
					{
						return "";
					}
				}				
			}
			else
			{
				return "";
			}			
		}
		
		############################################## Function GetOrderCountByDate #################################
		// Get order count
		#############################################################################################################
		function GetOrderCountByDate($datefrom,$dateto)
		{
			global $selected_store_filter,$magentoVersion,$selected_warehouse_filter;
			
			$order_status_filter=$this->PrepareMagentoOrderStatusFilter();
			
			if(!StandardPerformanceTest)
			$datefrom=$this->UpdateDatefrom($datefrom,$dateto);
			
			$coreResource = Mage::getSingleton('core/resource')->getConnection('core_read');
				 
			$whereCond  = array(
				$coreResource->quoteInto('updated_at >?', $this->GetServerTimeLocalMagento($datefrom)),
			   $coreResource->quoteInto('updated_at<=?', $this->GetServerTimeLocalMagento($dateto))
			);
			
			$whereCondString=join(' AND ', $whereCond);
					
			if(Magento_Store_Code_To_Service!="-ALL-" && $selected_store_filter!="")
			{
					// count orders from specific store
					$orders_data = Mage::getModel('sales/order')->getCollection();
					
					if($magentoVersion>1.3 || Magento_Enterprise_Edition==1)
					{
						$orders_data->addAttributeToSelect("increment_id")->getSelect()->where("(".$order_status_filter." ".$whereCondString." AND ".$selected_store_filter.$selected_warehouse_filter.")");
					}
					else
					{
						$orders_data->addFieldToFilter($order_status_filter)->addAttributeToSelect("increment_id")->getSelect()->where("( ".$whereCondString." AND ".$selected_store_filter.$selected_warehouse_filter.")");
					}
			}
			else
			{
					// count orders from all stores
					$orders_data = Mage::getModel('sales/order')->getCollection();
					
					if($magentoVersion>1.3 || Magento_Enterprise_Edition==1)
					{
						$orders_data->addAttributeToSelect("increment_id")->getSelect()->where("(".$order_status_filter." ".$whereCondString.$selected_warehouse_filter.")");
					}
					else
					{
						$orders_data->addFieldToFilter($order_status_filter)->addAttributeToSelect("increment_id")->getSelect()->where($whereCondString.$selected_warehouse_filter);
					}
			}
			$total_count = $orders_data->count();
				
			return $total_count;
		}
		
		############################################## Function UpdateShippingInfo #################################
		// Update order status
		############################################################################################################
		function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
		{
			global $selected_store_filter;
			
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			if($Carrier!="")
			{
				$SelectedCarrier=$Carrier;
				$Carrier=" via ".$Carrier;
			}
			else
			{
				$SelectedCarrier="ups";
			}
				
			if($Service!="")
				$ServiceString=" [".$Service."]";
			else
				$ServiceString="";
			
			if(Magento_SendsShippingEmail_AddComments==1)
				$send_email_include_comments=true;
			else
				$send_email_include_comments=false;
				
			// prepare $comments 
			$TrackingString="";
			if($TrackingNumber!="")
			$TrackingString=", Tracking number $TrackingNumber";
			
			$comments="Shipped on $shipped_on".$Carrier.$ServiceString.$TrackingString;
			
			$coreResource = Mage::getSingleton('core/resource')->getConnection('core_read');
				 
			$whereCond  = $coreResource->quoteInto('increment_id=?', $OrderNumber);
				
			if($selected_store_filter!="")
			{
			    $orders_data = Mage::getModel('sales/order')->getCollection();
				$orders_data->addAttributeToSelect("*")
				->getSelect()
				->where("(".$whereCond." and ".$selected_store_filter.")");
				 $orders_data->loadData();
			}
			else
			{
				$orders_data = Mage::getModel('sales/order')->getCollection();
				$orders_data->addAttributeToSelect("*")
				->getSelect()
				->where("(".$whereCond.")");
				 $orders_data->loadData();
			}
					
			foreach ($orders_data as $order) 
			{
				$current_order_status=$order->getStatus();
				$related_store_id=$order->store_id;
			}
			if(!isset($order)) // check if order exits in magento store
			{
				$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
				$this->SetXmlError(1,$this->display_msg);
			}
			
			if(MAGENTO_SHIPPED_STATUS_COMPLETE_ALL_SHIPPED_ORDERS==1)
			{
				$change_order_status="complete";
			}
			else
			{   				
				if(strtolower($current_order_status)=="pending")
					$change_order_status="processing";
				else if(strtolower($current_order_status)=="processing")
					$change_order_status="complete";
				else
				    $change_order_status=$current_order_status;
			}
			$isCustomerNotified=false;
			if(Magento_SendsBuyerEmail==1)
			$isCustomerNotified=true;
			
			if(Magento_StoreShippingInComments==1)
			{
				try
				{
					// add comment using sales_order.addComment method
					$order->addStatusToHistory($change_order_status, $comments,$isCustomerNotified);
					
					if(Magento_SendsBuyerEmail==1 && !strstr($_SERVER['HTTP_HOST'],'localhost'))
					$order->sendOrderUpdateEmail(true, $comments);
					
					$order->save();
				}
				catch( Exception $e )
				{
					// display error message
					$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
					$this->SetXmlError(1,$this->display_msg);
				}
		   }
		   else
		   {
				try
				{
					// check if shipment id exists
					$shipment = $order->getShipmentsCollection()->getFirstItem();
					$newShipmentId = $shipment->getIncrementId();
					
					if(!isset($newShipmentId))
					{
						//create new shipment
						 $shipment = $order->prepareShipment();
						 $shipment->register();
						 $shipment->addComment($comments, false);
					}
					
					// add tracking number
					if($Service=="")
					$Service="Shipping Tracking";
					
					$track = Mage::getModel('sales/order_shipment_track')->setNumber($TrackingNumber);
			
					$track->setCarrierCode(strtolower($SelectedCarrier));
					$track->setTitle($SelectedCarrier." ".$Service);
					$shipment->addTrack($track);
					
					$transactionSave = Mage::getModel('core/resource_transaction')
						->addObject($shipment)
						->addObject($shipment->getOrder())
						->save();			
					 
					 // send shipment email
					if(Magento_SendsShippingEmail)
					{
					   $shipment->sendEmail(true, ($send_email_include_comments ? $comments : ''));		
					   $shipment->setEmailSent(true);
					   $shipment->save();
					}
				
					// force status change
					$order->addStatusToHistory($change_order_status, $coreResource->quote($comments),$isCustomerNotified);
					
					if(Magento_SendsBuyerEmail==1 && !strstr($_SERVER['HTTP_HOST'],'localhost'))
					$order->sendOrderUpdateEmail(true, $comments);
					
					$order->save();
					$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success")); 
				}
				catch( Exception $e )
				{
					// display error message
					$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
					$this->SetXmlError(1,$e->getMessage());
				}
		   }			
		}
		
		############################################## Function Fetch_DB_Orders #################################
		// Fetch orders based on date range using sales_order.list method
		#########################################################################################################
		
		function Fetch_DB_Orders($datefrom,$dateto)
		{
			global $selected_store_filter,$magentoVersion,$selected_warehouse_filter;
			
			$order_status_filter=$this->PrepareMagentoOrderStatusFilter();
			$pageCount=1000;
			
			if(!StandardPerformanceTest)
			$datefrom=$this->UpdateDatefrom($datefrom,$dateto);
			
			$coreResource = Mage::getSingleton('core/resource')->getConnection('core_read');
				 
			$whereCond  = array(
				$coreResource->quoteInto('updated_at >?', $this->GetServerTimeLocalMagento($datefrom)),
			    $coreResource->quoteInto('updated_at<=?', $this->GetServerTimeLocalMagento($dateto))
			);
			
			$whereCondString=join(' AND ', $whereCond);
			
			if(Magento_Store_Code_To_Service!="-ALL-" && $selected_store_filter!="")
			{	
				// fetch orders from specific store
				$orders_data = Mage::getModel('sales/order')->getCollection();
				
				if($magentoVersion>1.3 || Magento_Enterprise_Edition==1)
				{
					$orders_data->addAttributeToSelect("*")
					->getSelect()
				 	->where("(".$order_status_filter." ".$whereCondString." AND ".$selected_store_filter.$selected_warehouse_filter.")");
				}
				else
				{
					$orders_data->addFieldToFilter($order_status_filter)->addAttributeToSelect("*")
					->getSelect()
				 	->where("( ".$whereCondString." AND ".$selected_store_filter.$selected_warehouse_filter.")");
				}
				
				$orders_data->setPageSize($pageCount)
				 ->setCurPagE(1)
				 ->loadData();
			}
			else
			{
				// fetch all orders irrespective of store
				$orders_data = Mage::getModel('sales/order')->getCollection();
				
				if($magentoVersion>1.3 || Magento_Enterprise_Edition==1)
				{
					$orders_data->addAttributeToSelect("*")
					->getSelect()
					->where("(".$order_status_filter." ".$whereCondString.$selected_warehouse_filter.")");
				}
				else
				{
					$orders_data->addFieldToFilter($order_status_filter)->addAttributeToSelect("*")
					->getSelect()
					->where($whereCondString.$selected_warehouse_filter);
				}
				
				$orders_data->setPageSize($pageCount)
				->setCurPagE(1)
				->loadData();
			}			
			
			$this->magento_orders=array();
			$counter=0;
			foreach ($orders_data as $order) 
			{
				$order_id=$order->getIncrementId();
			
				// prepare order array
				$this->magento_orders[$counter]=new stdClass();
				$this->magento_orders[$counter]->orderid=$order_id;
				
				if(MAGENTO_READ_INVOICES)
				{
						// Retrieve invoice numbers
						$invoice_str="";
						
						$invoices = $order->getInvoiceCollection();
						if(isset($invoices))
						{
							foreach($invoices as $invoice)
							{
								if($invoice_str!="")
								$invoice_str.=" ";
								
								$invoice_str.=$invoice->getIncrementId();								
							}
							
							$invoice_str=substr($invoice_str,0,50); // consider upto 50 chars
							$invoice_str=trim($invoice_str);				
						}						
				}
				
				// shipping details
				$ShippingAddress=$order->getShippingAddress();
						
				$this->magento_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field($ShippingAddress,'firstname');
				$this->magento_orders[$counter]->order_shipping["LastName"]=$this->Check_Field($ShippingAddress,'lastname');
				$this->magento_orders[$counter]->order_shipping["Company"]=$this->Check_Field($ShippingAddress,'getCompany','0');
				$this->magento_orders[$counter]->order_shipping["Address1"]=$this->Check_Field($ShippingAddress,'getStreet','1');
				$this->magento_orders[$counter]->order_shipping["Address2"]=$this->Check_Field($ShippingAddress,'getStreet','2');
				$this->magento_orders[$counter]->order_shipping["City"]=$this->Check_Field($ShippingAddress,'getCity','0');
				$this->magento_orders[$counter]->order_shipping["State"]=$this->Check_Field($ShippingAddress,'getRegionCode','0');
				$this->magento_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field($ShippingAddress,'getPostcode','0');
				$this->magento_orders[$counter]->order_shipping["Country"]=$this->Check_Field($ShippingAddress,'getCountryId','0');
				$this->magento_orders[$counter]->order_shipping["Phone"]=$this->Check_Field($ShippingAddress,'getTelephone','0');
				
				$this->magento_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($order,'getCustomerEmail','0');
				
				// billing details
				$BillingAddress = $order->getBillingAddress();
				
				$this->magento_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($BillingAddress,'firstname');
				$this->magento_orders[$counter]->order_billing["LastName"]=$this->Check_Field($BillingAddress,'lastname');
				$this->magento_orders[$counter]->order_billing["Company"]=$this->Check_Field($BillingAddress,'getCompany','0');
				$this->magento_orders[$counter]->order_billing["Address1"]=$this->Check_Field($BillingAddress,'getStreet','1');
				$this->magento_orders[$counter]->order_billing["Address2"]=$this->Check_Field($BillingAddress,'getStreet','2');
				$this->magento_orders[$counter]->order_billing["City"]=$this->Check_Field($BillingAddress,'getCity','0');
				$this->magento_orders[$counter]->order_billing["State"]=$this->Check_Field($BillingAddress,'getRegionCode','0');
				$this->magento_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($BillingAddress,'getPostcode','0');
				$this->magento_orders[$counter]->order_billing["Country"]=$this->Check_Field($BillingAddress,'getCountryId','0');
				$this->magento_orders[$counter]->order_billing["Phone"]=$this->Check_Field($BillingAddress,'getTelephone','0');
				
				// order info
				$this->magento_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTCMagento($order->getCreatedAt());
				
				if(MAGENTO_READ_INVOICES)
				$this->magento_orders[$counter]->order_info["ExternalID"]=$invoice_str;
				
				$this->magento_orders[$counter]->order_info["Currency"]=strtoupper($order->getOrderCurrencyCode());
				$this->magento_orders[$counter]->order_info["ItemsTotal"]=number_format($order->getSubtotal(),2,'.','');
				$this->magento_orders[$counter]->order_info["Total"]=number_format($order->getGrandTotal(),2,'.','');
					
				if(MAGENTO_MULTI_CURRENCY_VIEW_AS_BASE_CURRENCY)
				{
					$this->magento_orders[$counter]->order_info["Currency"]=strtoupper($order->getBaseCurrencyCode());
					$this->magento_orders[$counter]->order_info["ItemsTotal"]=number_format($order->getBaseSubtotal(),2,'.','');
					$this->magento_orders[$counter]->order_info["Total"]=number_format($order->getBaseGrandTotal(),2,'.','');
				}
				
				if($order->getTaxAmount()!="")
				{
					
					$this->magento_orders[$counter]->order_info["ItemsTax"]=number_format($order->getTaxAmount(),2,'.','');
					if(MAGENTO_MULTI_CURRENCY_VIEW_AS_BASE_CURRENCY)
					{
						$this->magento_orders[$counter]->order_info["ItemsTax"]=number_format($order->getBaseTaxAmount(),2,'.','');
					}
				}
				else
				{
					$this->magento_orders[$counter]->order_info["ItemsTax"]=0.00;
				}
				$this->magento_orders[$counter]->order_info["OrderNumber"]=$order_id;
				
				// Get Payment details
				$payment=$order->getPayment();
				$payment_method=Mage::helper('payment')->getMethodInstance($payment->getMethod());
				
				if($this->Check_Field($payment_method,"getTitle","0"))
				{
					$this->magento_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($payment_method->getTitle());
				}
				else
				{
					$this->magento_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType("other");
				}
				
				$this->magento_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($order->getShippingAmount(),2,'.','');
				
				if(MAGENTO_MULTI_CURRENCY_VIEW_AS_BASE_CURRENCY)
				{
					$this->magento_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($order->getBaseShippingAmount(),2,'.','');
				}
				
				$this->magento_orders[$counter]->order_info["ShipMethod"]=$order->getShippingDescription();
				$this->magento_orders[$counter]->order_info["Comments"]="";			
				
				if($order->getStatus()!="pending")
					$this->magento_orders[$counter]->order_info["PaymentStatus"]=2;
				else
					$this->magento_orders[$counter]->order_info["PaymentStatus"]=0;
				
				// Show Order status
				if($order->getStatus()=="complete")
					$this->magento_orders[$counter]->order_info["IsShipped"]=1;
				else
					$this->magento_orders[$counter]->order_info["IsShipped"]=0;
					
				// show if cancelled
				if($order->getStatus()=="canceled")
					$this->magento_orders[$counter]->order_info["IsCancelled"]=1;
				else
					$this->magento_orders[$counter]->order_info["IsCancelled"]=0;
					
					
				 // handle closed order
				if($order->getStatus()=="closed")
				{
					$this->magento_orders[$counter]->order_info["IsCancelled"]=1;
					$this->magento_orders[$counter]->order_info["PaymentStatus"]=0;
					$this->magento_orders[$counter]->order_info["IsShipped"]=0;
				}
				
				// Order Level Gift Message
				if(Magento_RetrieveOrderGiftMessage==1)
				{
					$message = Mage::getModel('giftmessage/message');
					$gift_message_id = $order->getGiftMessageId();
					
					if(!is_null($gift_message_id)) 
					{
							$message->load((int)$gift_message_id);
							$this->magento_orders[$counter]->order_info["Comments"]=$this->GetGiftMessageText($message);
					}
				}
				
				// Get customer note, if it is available from order comments module
				if($order->customer_note!="")
				{
					if($this->magento_orders[$counter]->order_info["Comments"]=="")
					$this->magento_orders[$counter]->order_info["Comments"]=$order->customer_note;
					else
					$this->magento_orders[$counter]->order_info["Comments"].="~".$order->customer_note;
				}
				else
				{
					$history = $order->getStatusHistoryCollection()->getLastItem();
					 
					if($history->getComment()!="")
					{
						if($this->magento_orders[$counter]->order_info["Comments"]=="")
						$this->magento_orders[$counter]->order_info["Comments"]=$history->getComment();
						else
						$this->magento_orders[$counter]->order_info["Comments"].="~".$history->getComment();
					}
				}
				
				// Get order products
				$actual_number_of_products=0;
				
				$order_items=$order->getAllItems();
				$product_stock_arr=array();
				if(Magento_Wyomind_Advanced_Inventory)
				{ 
				  if(Magento_Warehouse_To_Service!="-ALL-")
				  {
						 global $select_warehouse_id;
						 
						 $assignation_stock_arr=json_decode($order->assignation_stock); 
						
						 foreach($assignation_stock_arr as $ordered_product_id=>$warehouse_val_arr)
						 {
							foreach($warehouse_val_arr as $assigned_warehouse_id=>$assigned_stock)
							{
								if($assigned_warehouse_id==$select_warehouse_id)
								$product_stock_arr[$ordered_product_id]=$assigned_stock;
							}
						}
					}				
				}
				if(!defined("RETRIEVE_CUSTOM_FIELD_IN_NOTES"))
				define("RETRIEVE_CUSTOM_FIELD_IN_NOTES","");
				
				foreach ($order_items as $item)
				{
					if($item->getParentItemId()=="")
					{
						if(count($product_stock_arr)>0)
						{
							if(array_key_exists($item->product_id,$product_stock_arr))
							{
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$item->getName().$this->GetProductOptions($item->getProductOptions());									
								    if (version_compare(Mage::getVersion(), '1.3.0', '>='))
									{
										$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getPrice();
									}
									else
									{
										if ($item->hasOriginalPrice())
										{
											$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getOriginalPrice();
										}
										elseif ($item->hasCustomPrice())
										{
											$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getCustomPrice();
										}
										
									}
										
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$item->getSku().$this->GetProductOptions($item->getProductOptionByCode('simple_sku'));
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($product_stock_arr[$item->product_id],2,'.','');									
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');	
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format(($this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');									
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]=$this->GetCustomFieldsByLabel($item->GetProductOptions(),RETRIEVE_CUSTOM_FIELD_IN_NOTES);//get custom field value based on setting
									
									// Product Level Gift Message
									if(Magento_RetrieveProductGiftMessage==1)
									{
										$gift_message_id = $item->getGiftMessageId();
										
										if(!is_null($gift_message_id)) 
										{
												$message->load((int)$gift_message_id);
												if($this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]!="")
												$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"].=",";
												
												$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]=$message->getData('message');

										}
									}
									$actual_number_of_products++;
							}
						}
						else
						{		
							$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$item->getName().$this->GetProductOptions($item->getProductOptions());
							if (version_compare(Mage::getVersion(), '1.3.0', '>='))
							{
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getPrice();
							}
							else
							{
								if ($item->hasOriginalPrice())
								{
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getOriginalPrice();
								}
								elseif ($item->hasCustomPrice())
								{
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getCustomPrice();
								}
							}
							
							$this->magento_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$item->getSku().$this->GetProductOptions($item->getProductOptionByCode('simple_sku'));
							$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($item->getQtyOrdered(),2,'.','');
							$this->magento_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');	
							$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format(($this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');
							$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');							
							$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]=$this->GetCustomFieldsByLabel($item->GetProductOptions(),RETRIEVE_CUSTOM_FIELD_IN_NOTES); //get custom field values based on setting
							
							// Product Level Gift Message
							if(Magento_RetrieveProductGiftMessage==1)
							{
								$gift_message_id = $item->getGiftMessageId();
								
								if(!is_null($gift_message_id)) 
								{
									$message->load((int)$gift_message_id);
									if($this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]!="")
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"].=",";
									
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]=$message->getData('message');
								}
							}
							$actual_number_of_products++;
						}
					}
				}
				
				$this->magento_orders[$counter]->num_of_products=$actual_number_of_products;
				
				$counter++;
			}	
		}
		############################################## Function RetrieveCatalogCount #################################
		// Get catalog count
		#######################################################################################################
		function RetrieveCatalogCount()
		{
			$total_count = Mage::getModel('catalog/product')->getCollection()->addAttributeToSelect('*')->count();
		
			return  $total_count;
		}
		############################################## Function Fetch_DB_Catalog #################################
		// Fetch catalog
		##########################################################################################################
		function Fetch_DB_Catalog($limit,$offset)
		{
			$catalog_data=Mage::getModel('catalog/product')->getCollection()->addAttributeToSelect('*');
			$page=($offset/$limit)+1;
			
			$catalog_data->setPageSize($limit)->setCurPage($page)->loadData();
			$counter=0;
			foreach ($catalog_data as $catalog) 
			{
				$this->magento_commodities[$counter]->catalog_commodity["Currency"]=Mage::app()->getStore()->getCurrentCurrencyCode();
				$this->magento_commodities[$counter]->catalog_commodity["Price"]=$catalog->getPrice();
				$this->magento_commodities[$counter]->catalog_commodity["CountryOfOrigin"]="";
				$this->magento_commodities[$counter]->catalog_commodity["UnitsOfMeasureLinear"]="";
				$this->magento_commodities[$counter]->catalog_commodity["UnitsOfMeasureWeight"]="";
				$this->magento_commodities[$counter]->catalog_commodity["Weight"]=$catalog->getWeight();
				
				$this->magento_commodities[$counter]->catalog_commodity["Length"]="";	
				$this->magento_commodities[$counter]->catalog_commodity["Width"]="";
				$this->magento_commodities[$counter]->catalog_commodity["Height"]="";
				
				$stock = Mage::getModel('cataloginventory/stock_item')->loadByProduct($catalog);
				$this->magento_commodities[$counter]->catalog_commodity["Quantity"]=(int)$stock->getQty();
				
				$this->magento_commodities[$counter]->catalog_commodity["Volume"]="";
				$this->magento_commodities[$counter]->catalog_commodity["LengthPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["WidthPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["HeightPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["WeightPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["RowIndex"]="";
				$this->magento_commodities[$counter]->catalog_commodity["SKU"]=$catalog->getSKU();
				$this->magento_commodities[$counter]->catalog_commodity["Name"]=utf8_encode($catalog->getName());
				$this->magento_commodities[$counter]->catalog_commodity["Description"]=utf8_encode($catalog->getDescription());
				$this->magento_commodities[$counter]->catalog_commodity["ExternalID"]=$catalog->getId();
				
				$this->magento_commodities[$counter]->catalog_commodity["URL"]=$catalog->getProductUrl();
				
				$this->magento_commodities[$counter]->catalog_commodity["UPC"]="";
				$this->magento_commodities[$counter]->catalog_commodity["VolumePackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["Condition"]="";
				
				$this->magento_commodities[$counter]->catalog_commodity["Manufacturer"]=$catalog->getAttributeText('manufacturer');
				
				$this->magento_commodities[$counter]->catalog_commodity["ImageURL"]= Mage::helper('catalog/image')->init($catalog, 'thumbnail');;
				
				$counter++;
				
		    }
		}
		 ############################################## Function UpdateCatalog #################################
		// Update catalog
		#######################################################################################################
		function UpdateCatalog($ExternalID ,$Quantity )
		{
			$stockItem = Mage::getModel('cataloginventory/stock_item')->loadByProduct($ExternalID);
			
			// check if commodity id is valid
			if ($stockItem->getId() > 0 && $stockItem->getManageStock()) 
			{
				$stockItem->setQty($Quantity);
				$stockItem->setIsInStock((int)($Quantity > 0));
				$stockItem->save();	
				$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));	
			   
			}
			else
			{
				//display error message
				$this->display_msg=INVAID_COMMODITY_NUMBER_ERROR_MSG;
				$this->SetXmlError(1,$this->display_msg);
			
			}
		  
		}
		function GetGiftMessageText($message)
		{
			   $result = "";
			   if ($message->getData('sender')) $result = $result."From: ".$message->getData('sender')."\r\n";
			   if ($message->getData('recipient')) $result = $result."To: ".$message->getData('recipient')."\r\n\r\n";
			   $result = $result.$message->getData('message');
			   return $result;
		}
	
		################################### Function GetOrdersByDate($datefrom,$dateto) #######################
		// Get orders based on date range
		#######################################################################################################
		function GetOrdersByDate($datefrom,$dateto)
		{
				$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
	
				if (isset($this->magento_orders))
					return $this->magento_orders;
				else
				   return array();  
		}
		  
		  #################################### Convert UTC time to Magento Format ########################################################
		  /* Magento stores all times in UTC but not in ISO 8601 format.Hence, change "YYYY-MM-DDThh:mm:ssZ" to "YYYY-MM-DD hh:mm:ss"*/
		  ################################################################################################################################
		  function GetServerTimeLocalMagento($server_date_iso) 
		  {
				if(strpos($server_date_iso,"Z"))
				{
					$utc_fotmat_temp=str_replace("Z","",$server_date_iso);
					$server_date_utc=str_replace("T"," ",$utc_fotmat_temp); // "T" & "Z" removed from UTC format(in ISO 8601)
				}
				return $server_date_utc;
		  }	
		  
		   #################################### Convert Magento Format to UTC########################################################
		  /* Magento stores all times in UTC but not in ISO 8601 format.Hence, format date to ISO 8601 i.e "YYYY-MM-DDThh:mm:ssZ" */
		  ###########################################################################################################################
		  function ConvertServerTimeToUTCMagento($server_date_utc) 
		  {
			$utc_fotmat_temp=$server_date_utc."Z";
			$server_date_iso=str_replace(" ","T",$utc_fotmat_temp); // "T" & "Z" removed from UTC format(in ISO 8601)
			return $server_date_iso;
		  }	
		  ################################################## Function GetCatalog() #############################
		   // Get catalog based on paging
		  #######################################################################################################
		  function GetCatalog()
		   {
				$this->Fetch_DB_Catalog($this->Limit,$this->Offset);
				
				if (isset($this->magento_commodities))
					return $this->magento_commodities;
				else
					return array();  
			}
		############################################### Function PrepareOrderStatusString #######################
		// Prepare order status string based on settings
		#########################################################################################################
		function PrepareMagentoOrderStatusFilter()
		{
				global $magentoVersion;
				
				if($magentoVersion>1.3 || Magento_Enterprise_Edition==1)
				{
						$order_status_filter="";
						
						if(MAGENTO_RETRIEVE_ORDER_STATUS_1_PENDING==1)
						{
							$order_status_filter=" status='pending' ";
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_2_PROCESSING==1)
						{
							if($order_status_filter=="")
							{
								$order_status_filter.=" status='processing'  ";
							}
							else
							{
								$order_status_filter.=" OR status='processing'  ";
							}
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_3_COMPLETE==1)
						{
							if($order_status_filter=="")
							{
								$order_status_filter.=" status='complete'  ";
							}
							else
							{
								$order_status_filter.=" OR status='complete'  ";
							}
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_4_CLOSED==1)
						{
							if($order_status_filter=="")
							{
								$order_status_filter.=" status='closed'  ";
							}
							else
							{
								$order_status_filter.=" OR status='closed' ";
							}
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_4_CANCELLED==1)
						{
							if($order_status_filter=="")
							{
								$order_status_filter.=" status='canceled'  ";
							}
							else
							{
								$order_status_filter.=" OR status='canceled'  ";
							}
						}
						
						if($order_status_filter!="")
						$order_status_filter="( ".$order_status_filter." ) and";						
				}
				else
				{
						$order_status_filter=array();
				
						if(MAGENTO_RETRIEVE_ORDER_STATUS_1_PENDING==1)
						{
							$filter_pending=array('attribute'=>'status','eq'=>Mage_Sales_Model_Order::STATE_PROCESSING);
							array_push($order_status_filter,$filter_pending);	
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_2_PROCESSING==1)
						{
							$filter_processing=array('attribute'=>'status','eq'=>Mage_Sales_Model_Order::STATE_PROCESSING);
							array_push($order_status_filter,$filter_processing);	
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_3_COMPLETE==1)
						{
							$filter_complete=array('attribute'=>'status','eq'=>Mage_Sales_Model_Order::STATE_COMPLETE);
							array_push($order_status_filter,$filter_complete);	
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_4_CLOSED==1)
						{
							$filter_closed=array('attribute'=>'status','eq'=>Mage_Sales_Model_Order::STATE_CLOSED);
							array_push($order_status_filter,$filter_closed);	
						}
						if(MAGENTO_RETRIEVE_ORDER_STATUS_4_CANCELLED==1)
						{
							$filter_cancelled=array('attribute'=>'status','eq'=>Mage_Sales_Model_Order::STATE_CANCELED);
							array_push($order_status_filter,$filter_cancelled);	
						}
				}
				return $order_status_filter;
		}
	}
}

else
{
	 // ********* Magento 2.x Section ****************** Magento 2.x Section **********************************************/
	
	############################################## Include bootstrap, create application & helper class  ####################################################
	if(Check_Include_File("app/bootstrap.php",1))
	include("app/bootstrap.php");
	else if(Check_Include_File("../app/bootstrap.php",1)) // Check if Magento is being served from pub/ directory
	include("../app/bootstrap.php");
	
	$params['MAGE_RUN_CODE'] = 'admin';
	$params['custom_entry_point'] = true;	
	
	$bootstrap = \Magento\Framework\App\Bootstrap::create(BP, $params);
	$obj = $bootstrap->getObjectManager();
	
	$state = $obj->get('Magento\Framework\App\State');
	$state->setAreaCode('frontend');
	
	$shiprush_eventManager = $obj->create('\Magento\Framework\Event\Manager');
	
	############################### Store Related Code Block ####################################
	function get_store_id($storecode)
	{
		$object_Manager =  \Magento\Framework\App\ObjectManager::getInstance();    
		$store_Manager = $object_Manager->create("\Magento\Store\Model\StoreManagerInterface");
		
		$all_stores = $store_Manager->getStores(true, true);
		
		if(isset($all_stores[$storecode])){
			$store_id = $all_stores[$storecode]->getId();
		}
		return $store_id; 
	}
	
	if(!defined("Magento_Store_Code_To_Service"))
	define("Magento_Store_Code_To_Service","-ALL-");
	$selected_store_filter="";
	if(Magento_Store_Code_To_Service!='-ALL-')
	{
		$single_store=0;
		
		if(!strstr(Magento_Store_Code_To_Service,","))
		{
			$single_store=1; // single store 
		}
		else
		{
			$seleted_store_code_arr=explode(",",Magento_Store_Code_To_Service);
		}
		
		if($single_store)
		{
			 $selected_store_code=Magento_Store_Code_To_Service;
			 $selected_store_filter=get_store_id($selected_store_code);		
		}
		else
		{	
		  	foreach($seleted_store_code_arr as $key=>$selected_store_code)
			{
				if($selected_store_filter!="")
				$selected_store_filter.=",";
				
				$selected_store_filter.=get_store_id($selected_store_code);
			}
		  }
	  }
	  else
	  $selected_store_filter="";
	
	######################################################################################
	/* the application */
	class Magentoapp
	  extends \Magento\Framework\App\Http
	  implements \Magento\Framework\AppInterface 
	  {
	  	protected $_objectManager;
	
			
		public function __construct(\Magento\Framework\ObjectManagerInterface $objectManager) 
		{
			$this->_objectManager = $objectManager;
			if(stristr(PHP_OS, 'LINUX'))
			{
			    global $shiprush_eventManager;
				$this->_eventManager = $shiprush_eventManager;
			}
		   
		}
		public function connect()
		{
			// order object
			$order_obj=$this->_objectManager->create('\Magento\Sales\Model\Order');
			$collections=$order_obj->getCollection();
			 if($collections->getSize())
     		{
			 	return $collections->getSize();
				
			}
			else
			{
				return 0;
			}
		}
		
		public function collection_count($status_filter, $datefrom, $dateto)
		{
			global $selected_store_filter;
			// order object
			$order_obj=$this->_objectManager->create('\Magento\Sales\Model\Order');
			$collections=$order_obj->getCollection();
			
			if($selected_store_filter!="")
			return $collections->addAttributeToFilter('updated_at', [ 'from' => $datefrom, 'to' => $dateto ])
			->addAttributeToFilter('status', ['in' => $status_filter])->addAttributeToFilter('store_id', ['in' => $selected_store_filter])->count();
			else
			return $collections->addAttributeToFilter('updated_at', [ 'from' => $datefrom, 'to' => $dateto ])
			->addAttributeToFilter('status', ['in' => $status_filter])->count();
		}
		
		public function collection_data($status_filter, $datefrom, $dateto)
		{
			global $selected_store_filter;
			// order object
			$order_obj=$this->_objectManager->create('\Magento\Sales\Model\Order');
			$collections=$order_obj->getCollection();
			
			if($selected_store_filter!="")
			 return $collections->addAttributeToFilter('updated_at', [ 'from' => $datefrom, 'to' => $dateto ])
			->addAttributeToFilter('status', ['in' => $status_filter])->addAttributeToFilter('store_id', ['in' => $selected_store_filter]);
			else
			return $collections->addAttributeToFilter('updated_at', [ 'from' => $datefrom, 'to' => $dateto ])
			->addAttributeToFilter('status', ['in' => $status_filter]);
		}
		
		public function collection_data_by_id($increment_id)
		{
			// order object
			$order_obj=$this->_objectManager->create('\Magento\Sales\Model\Order');
			$collections=$order_obj->getCollection();
				
			 return $collections->addAttributeToFilter('increment_id', ['eq' => $increment_id]);
		}
		
		public function ship_order_coverter()
		{
			// converter object
			$converter_obj=$this->_objectManager->create('\Magento\Sales\Model\Convert\Order');
			return $converter_obj;
		}
		
		public function ship_track()
		{
			// track object
			$track_obj=$this->_objectManager->create('Magento\Sales\Model\Order\Shipment\Track');
			return $track_obj;
		}
		public function get_giftmessage()
		{
			// giftmessage object
			$giftmessage_obj=$this->_objectManager->create('\Magento\GiftMessage\Helper\Message');
			return $giftmessage_obj;
		}
		
		public function trans()
		{
			// transaction object
			$trans_obj=$this->_objectManager->create('\Magento\Framework\DB\Transaction');
			return $trans_obj;
		}
		function shipment_notify()
		{
			// shipment notify object
			$shipment_notify_obj=$this->_objectManager->create('Magento\Shipping\Model\ShipmentNotifier');
			return $shipment_notify_obj;
		}
		public function order_comment_sender()
		{
			$sender_obj=$this->_objectManager->create('Magento\Sales\Model\Order\Email\Sender\OrderCommentSender');
			return $sender_obj;
		
		}
		
		public function ship_shipment_loader()
		{
			// shipment loaded object
			$loader_obj=$this->_objectManager->create('\Magento\Shipping\Controller\Adminhtml\Order\ShipmentLoaderFactory');
			return $loader_obj;
		}
		
		public function catalog_count()
		{
			$catalog=$this->_objectManager->create('Magento\Catalog\Model\ResourceModel\Product\Collection');
			return $catalog->addAttributeToSelect('*')->count();
		}
		public function catalog_product($id)
		{
			$catalog=$this->_objectManager->create('Magento\Catalog\Model\ResourceModel\Product\Collection');
			return $catalog->addAttributeToFilter('entity_id',$id);
		}
		public function product_repository($productId)
		{
			$productRepository =$this->_objectManager->get('Magento\Catalog\Model\ProductRepository');
			return $productRepository->getById($productId);
		}
		public function check_if_child_of_configurable($productId)
		{
			$product =$this->_objectManager->create('Magento\ConfigurableProduct\Model\ResourceModel\Product\Type\Configurable')->getParentIdsByChild($productId);
			if(isset($product[0])){
				return $product[0];
			}
			return false;
		}
		public function get_product_option($product)
		{
			$customProductOptions = $this->_objectManager->get('Magento\Catalog\Model\Product\Option')->getProductOptionCollection($product);
			return $customProductOptions;
		}
		public function get_catalog($limit,$offset)
		{
			$page=($offset/$limit)+1;
			
			$catalog=$this->_objectManager->create('Magento\Catalog\Model\ResourceModel\Product\Collection');
			$collection = $catalog->addAttributeToSelect('*')->setPageSize($limit)->setCurPage($page)->load();
			return $collection;
			
		}
		public function get_store()
		{
			$store_obj=$this->_objectManager->create('Magento\Store\Model\StoreManagerInterface');
			return $store_obj;
		} 
		public function config_details()
		{
			$config_obj=$this->_objectManager->create('Magento\Framework\App\Config\ScopeConfigInterface');
			return $config_obj;
		}
		public function get_stock()
		{
			$stock_obj=$this->_objectManager->create('Magento\CatalogInventory\Api\StockRegistryInterface');
			return $stock_obj;
		}
		
	}
	
	$ship_app = $bootstrap->createApplication('Magentoapp');
	
	############################################## Always Enable Exception Handler ###############################################
	error_reporting(E_ALL);
	ini_set('display_errors', '1');
	set_error_handler("ShippingZ_Exception_Error_Handler");
	
	############################################## Class ShippingZMagento ##########################################
	class ShippingZMagento extends ShippingZGenericShoppingCart
	{
		// cart specific functions goes here
		############################################## Function Check_DB_Access #################################
		// Check Database access
		#########################################################################################################		
		function Check_DB_Access()
		{
			try // See if we can access order model
			{
				global $ship_app;
				$ship_app->connect();
				$this->display_msg=DB_SUCCESS_MSG;
			}
			catch(Exception $e)
			{
				$this->display_msg="Could not access order model";
				$this->SetXmlError(1,$this->display_msg);
				exit;
			}
				
		}
		
		############################################## Function UpdateDatefrom  #################################
		// if Day(DateFrom) = Day(DateTo) then set DateFrom to previous day
		#########################################################################################################
		function UpdateDatefrom($datefrom,$dateto)
		{
			
			$day_datefrom=substr($datefrom,0,10);
			$day_dateto=substr($dateto,0,10);
			
			$time_str_datefrom=substr($datefrom,10);
			
			if($day_datefrom==$day_dateto)
			{
				$updated_date_from=date("Y-m-d",strtotime("-1 day", strtotime($day_datefrom)));
				$updated_date_from=$updated_date_from.$time_str_datefrom;
				return $updated_date_from;
			}
			else
			{
				return $datefrom;
			}
			
		}
		
		############################################## Function SafeUnserialize  #################################
		// This will return false in case the passed string is not unserializeable
		##########################################################################################################
		function SafeUnserialize($serialized_string) 
		{
			if (strpos($serialized_string, "\0") === false &&  is_string($serialized_string) ) {
				if (strpos($serialized_string, 'O:') === false) {
				  
					return @unserialize($serialized_string);
				} else if (!preg_match('/(^|;|{|})O:[0-9]+:"/', $serialized_string)) {
				   
					return @unserialize($serialized_string);
				}
			}
			return false;
		}
		
		############################################## Function GetProductOptions  #################################
		// Used to get product attributes and sku for product variations
		############################################################################################################
		function GetProductOptions($option_arr,$code='')
		{				
				if($code=="")
				{
					// get attribute details
					$formatted_option_variation_details="";
								
					if(isset($option_arr['attributes_info']) && is_array($option_arr['attributes_info']))
					{
						foreach($option_arr['attributes_info'] as $key=>$val)
						{
							if(is_array($val))
							{
								foreach($val as $key2=>$value2)
								{
									if($key2=="label")
									{
										$curr_label=$value2;
									}
									else if($key2=="value")
									{
										if($formatted_option_variation_details!="")
											$formatted_option_variation_details.=", ".$curr_label.":".$value2;
										else
											$formatted_option_variation_details=$curr_label.":".$value2;
									}
								}
							}
						}
						
						if($formatted_option_variation_details!="")
						{
							return " (".$formatted_option_variation_details.")";	
						}
						else
						{
						
							return '';
						}
					}
				}
				else
				{
						// get simple sku
						if(isset($option_arr[$code]))
							return "-".$option_arr[$code];
						else
							return '';
				}
		}
		
		############################################## Function GetProductOptionValuebyLabel  #################################
		// Used to get product attributes by label
		#######################################################################################################################
		function GetProductOptionValuebyLabel($option_string,$label='')
		{
			    $option_arr=$this->SafeUnserialize($option_string);
				
				//get attribute details
				$formatted_option_variation_details="";
							
				if(isset($option_arr['attributes_info']))
				{
					foreach($option_arr['attributes_info'] as $key=>$val)
					{
						$curr_label=0;
						
						foreach($val as $key2=>$value2)
						{
							if($key2=="label")
							{
								if($value2==$label)
								{
									$curr_label=1;
								}
							}
							else if($key2=="value" && $curr_label==1)
							{
								return $value2;
							}
						}
					}
				}			
		 }
		 
		############################################## Function Check_Field #################################
		// Check & Return field value if available
		#####################################################################################################
		function Check_Field_V2($arr,$field)
		{
			if(is_array($arr))
			{
				if(isset($arr[$field]))
				return $arr[$field];
				else
				return "";				
			}
			else
				return "";			
		}
		
		############################################## Function GetOrderCountByDate #################################
		// Get order count
		#############################################################################################################
		function GetOrderCountByDate($datefrom,$dateto)
		{
			global $ship_app,$selected_store_filter,$magentoVersion,$selected_warehouse_filter;
			
			$order_status_filter=$this->PrepareMagentoOrderStatusFilter();
			if(!StandardPerformanceTest)
			$datefrom=$this->UpdateDatefrom($datefrom,$dateto);
			
			$total_count=$ship_app->collection_count($order_status_filter, $this->GetServerTimeLocalMagento($datefrom),  $this->GetServerTimeLocalMagento($dateto));
				
			return $total_count;		
		}
		
		############################################## Function UpdateShippingInfo #################################
		// Update order status
		############################################################################################################
		function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
		{
			global $selected_store_filter,$ship_app;
			
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			if($Carrier!="")
			{
				$SelectedCarrier=$Carrier;
				$Carrier=" via ".$Carrier;							
			}
			else
			{
				$SelectedCarrier="ups";
			}
				
			if($Service!="")
				$ServiceString=" [".$Service."]";
			else
				$ServiceString="";			
					
			if(Magento_SendsShippingEmail_AddComments==1)
				$send_email_include_comments=true;
			else
				$send_email_include_comments=false;
				
			// prepare $comments 
			$TrackingString="";
			if($TrackingNumber!="")
			$TrackingString=", Tracking number $TrackingNumber";
			
			$comments="Shipped on $shipped_on".$Carrier.$ServiceString.$TrackingString;
			
			$orders_data=$ship_app->collection_data_by_id($OrderNumber);
			
			foreach ($orders_data as $order) 
			{
				$current_order_status=$order->getStatus();
				
			}
			if(!isset($order)) // check if order exits in magento store
			{
				$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
				$this->SetXmlError(1,$this->display_msg);
			}
			
			if(MAGENTO_SHIPPED_STATUS_COMPLETE_ALL_SHIPPED_ORDERS==1)
			{
				$change_order_status="complete";
			}
			else
			{   
				if(strtolower($current_order_status)=="pending")
					$change_order_status="processing";
				else if(strtolower($current_order_status)=="processing")
					$change_order_status="complete";
				else
				$change_order_status=$current_order_status;
			}
			$isCustomerNotified=false;
			if(Magento_SendsBuyerEmail==1 || Magento_SendsShippingEmail==1)
			$isCustomerNotified=true;
			
			if(Magento_StoreShippingInComments==1)
			{
				try
				{
					// add comment 
					$order->addStatusToHistory($change_order_status, $comments,$isCustomerNotified);
					
					if(Magento_SendsBuyerEmail==1 && !strstr($_SERVER['HTTP_HOST'],'localhost'))
					$order->sendOrderUpdateEmail(true, $comments);
					
					$order->save();
				}
				catch( Exception $e )
				{
					//display error message
					$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
					$this->SetXmlError(1,$this->display_msg);
				}
		   }
		   else
		   {
				try
				{
					//check if shipment id exists
					$shipment = $order->getShipmentsCollection()->getFirstItem();
					$newShipmentId = $shipment->getIncrementId();
					
					if(!isset($newShipmentId))
					{
						//create new shipment
						 $actual_order_item="";
						 $order->getItemByQuoteItemId($order->getQuoteId());
						  foreach ($order->getItemsCollection() as $orderItem) 
						  {
							if (!$orderItem->isDeleted() && !$orderItem->getParentItemId()) 
							{					 
								$actual_order_item= $orderItem;
							}
					      }						
						 
						$shipmentLoader= $ship_app->ship_shipment_loader()->create();
						$shipmentData = [$actual_order_item->getId() => $actual_order_item->getQtyToShip()];
						$shipmentLoader->setOrderId($actual_order_item->getOrderId());
						$shipmentLoader->setShipment($shipmentData);
						$shipment = $shipmentLoader->load();
						
						if ($shipment) 
						{
							$shipment->register();
							$shipment->getOrder()->setIsInProcess(true);
							$shipmentTransaction = $ship_app->trans()
								->addObject($shipment)
								->addObject($shipment->getOrder());
							$shipmentTransaction->save();
						}
						$shipment = $order->getShipmentsCollection()->getFirstItem();
					}	 
					
					// add tracking number
					if($Service=="")
					$Service="Shipping Tracking";
					
					 if ($shipment) {
						$track = $ship_app->ship_track()->setNumber(
							$TrackingNumber
						)->setCarrierCode(
							strtolower($SelectedCarrier)
						)->setTitle(
							$SelectedCarrier." ".$Service
						);
						$shipment->addTrack($track)->save();
						
						// send shipment email
						if(Magento_SendsShippingEmail)
						$ship_app->shipment_notify()->notify($shipment);
						
					}
					
					// force status change
					$order->addStatusToHistory($change_order_status, $comments,$isCustomerNotified);
					
					if(Magento_SendsBuyerEmail==1 && !strstr($_SERVER['HTTP_HOST'],'localhost'))
					$ship_app->order_comment_sender()->send($order, $isCustomerNotified , $comments);
					
					$order->save();
					$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success")); 
				}
				catch( Exception $e )
				{
					// display error message
					$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
					$this->SetXmlError(1,$e->getMessage());
				}
		   }
			
		}
		
		############################################## Function Fetch_DB_Orders #################################
		// Fetch orders based on date range using sales_order.list method
		#########################################################################################################
		
		function Fetch_DB_Orders($datefrom,$dateto)
		{
			global $ship_app,$selected_store_filter,$magentoVersion,$selected_warehouse_filter;
			
			$order_status_filter=$this->PrepareMagentoOrderStatusFilter();
			if(!StandardPerformanceTest)
			$datefrom=$this->UpdateDatefrom($datefrom,$dateto);
			
			$orders_data=$ship_app->collection_data($order_status_filter, $this->GetServerTimeLocalMagento($datefrom),  $this->GetServerTimeLocalMagento($dateto));
			
			$this->magento_orders=array();
			$counter=0;
			foreach ($orders_data as $order) 
			{
				$order_id=$this->Check_Field_V2($order->getData(),'increment_id');
				
				// prepare order array
				$this->magento_orders[$counter]=new stdClass();
				$this->magento_orders[$counter]->orderid=$order_id;
				
				if(MAGENTO_READ_INVOICES)
				{				
						// Retrieve invoice numbers
						$invoice_str="";
						
						$invoices = $order->getInvoiceCollection();
						if(isset($invoices))
						{
							foreach($invoices as $invoice)
							{
								if($invoice_str!="")
								$invoice_str.=" ";
								
								$invoice_str.=$invoice->getIncrementId();
							}
							$invoice_str=substr($invoice_str,0,50); // consider upto 50 chars
							$invoice_str=trim($invoice_str);				
						}
						
				}
							
				// billing details
				$BillingAddress = $order->getBillingAddress()->getData(); 
				$BillingStreet=$order->getBillingAddress()->getStreet();
									
				$this->magento_orders[$counter]->order_billing["FirstName"]=$this->Check_Field_V2($BillingAddress,'firstname');
				$this->magento_orders[$counter]->order_billing["LastName"]=$this->Check_Field_V2($BillingAddress,'lastname');
				$this->magento_orders[$counter]->order_billing["Company"]=$this->Check_Field_V2($BillingAddress,'company');
				$this->magento_orders[$counter]->order_billing["Address1"]=$this->Check_Field_V2($BillingStreet,'0');
				$this->magento_orders[$counter]->order_billing["Address2"]=$this->Check_Field_V2($BillingStreet,'1');;
				$this->magento_orders[$counter]->order_billing["City"]=$this->Check_Field_V2($BillingAddress,'city');
				$this->magento_orders[$counter]->order_billing["State"]=$this->Check_Field_V2($BillingAddress,'region');
				$this->magento_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field_V2($BillingAddress,'postcode');
				$this->magento_orders[$counter]->order_billing["Country"]=$this->Check_Field_V2($BillingAddress,'country_id');
				$this->magento_orders[$counter]->order_billing["Phone"]=$this->Check_Field_V2($BillingAddress,'telephone');
				
				
				// shipping details				
				if($this->Check_Field_V2($order->getData(),'shipping_address_id')!="")
				{
					$ShippingAddress=$order->getShippingAddress()->getData();
					$ShippingStreet=$order->getShippingAddress()->getStreet();
								
					$this->magento_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field_V2($ShippingAddress,'firstname');
					$this->magento_orders[$counter]->order_shipping["LastName"]=$this->Check_Field_V2($ShippingAddress,'lastname');
					$this->magento_orders[$counter]->order_shipping["Company"]=$this->Check_Field_V2($ShippingAddress,'company');
					$this->magento_orders[$counter]->order_shipping["Address1"]=$this->Check_Field_V2($ShippingStreet,'0');
					$this->magento_orders[$counter]->order_shipping["Address2"]=$this->Check_Field_V2($ShippingStreet,'1');
					$this->magento_orders[$counter]->order_shipping["City"]=$this->Check_Field_V2($ShippingAddress,'city');
					$this->magento_orders[$counter]->order_shipping["State"]=$this->Check_Field_V2($ShippingAddress,'region');
					$this->magento_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field_V2($ShippingAddress,'postcode');
					$this->magento_orders[$counter]->order_shipping["Country"]=$this->Check_Field_V2($ShippingAddress,'country_id');
					$this->magento_orders[$counter]->order_shipping["Phone"]=$this->Check_Field_V2($ShippingAddress,'telephone');					
					$this->magento_orders[$counter]->order_shipping["EMail"]=$this->Check_Field_V2($ShippingAddress,'email');
				}
				else
				{
					$this->magento_orders[$counter]->order_shipping["FirstName"]=$this->magento_orders[$counter]->order_billing["FirstName"];
					$this->magento_orders[$counter]->order_shipping["LastName"]=$this->magento_orders[$counter]->order_billing["LastName"];
					$this->magento_orders[$counter]->order_shipping["Company"]=$this->magento_orders[$counter]->order_billing["Company"];
					$this->magento_orders[$counter]->order_shipping["Address1"]=$this->magento_orders[$counter]->order_billing["Address1"];
					$this->magento_orders[$counter]->order_shipping["Address2"]=$this->magento_orders[$counter]->order_billing["Address2"];
					$this->magento_orders[$counter]->order_shipping["City"]=$this->magento_orders[$counter]->order_billing["City"];
					$this->magento_orders[$counter]->order_shipping["State"]=$this->magento_orders[$counter]->order_billing["State"];
					$this->magento_orders[$counter]->order_shipping["PostalCode"]=$this->magento_orders[$counter]->order_billing["PostalCode"];
					$this->magento_orders[$counter]->order_shipping["Country"]=$this->magento_orders[$counter]->order_billing["Country"];
					$this->magento_orders[$counter]->order_shipping["Phone"]=$this->magento_orders[$counter]->order_billing["Phone"];					
					$this->magento_orders[$counter]->order_shipping["EMail"]=$this->Check_Field_V2($order->getData(),'customer_email');
				
				}
				
				// order info
				$this->magento_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTCMagento($order->getCreatedAt());
				
				if(MAGENTO_READ_INVOICES)
				$this->magento_orders[$counter]->order_info["ExternalID"]=$invoice_str;
				
				$this->magento_orders[$counter]->order_info["Currency"]=strtoupper($order->getOrderCurrencyCode());
				$this->magento_orders[$counter]->order_info["ItemsTotal"]=number_format($order->getSubtotal(),2,'.','');
				$this->magento_orders[$counter]->order_info["Total"]=number_format($order->getGrandTotal(),2,'.','');
					
				if(MAGENTO_MULTI_CURRENCY_VIEW_AS_BASE_CURRENCY)
				{
					$this->magento_orders[$counter]->order_info["Currency"]=strtoupper($order->getBaseCurrencyCode());
					$this->magento_orders[$counter]->order_info["ItemsTotal"]=number_format($order->getBaseSubtotal(),2,'.','');
					$this->magento_orders[$counter]->order_info["Total"]=number_format($order->getBaseGrandTotal(),2,'.','');
				}
				
				if($order->getTaxAmount()!="")
				{
					$this->magento_orders[$counter]->order_info["ItemsTax"]=number_format($order->getTaxAmount(),2,'.','');
					if(MAGENTO_MULTI_CURRENCY_VIEW_AS_BASE_CURRENCY)
					{
						$this->magento_orders[$counter]->order_info["ItemsTax"]=number_format($order->getBaseTaxAmount(),2,'.','');
					}
				}
				else
				{
					$this->magento_orders[$counter]->order_info["ItemsTax"]=0.00;
				}
				$this->magento_orders[$counter]->order_info["OrderNumber"]=$order_id;
				
				// Get Payment details
				$payment=$order->getPayment()->getData();
				$payment_method=$this->Check_Field_V2($payment,'method');
				
				if($this->Check_Field_V2($payment['additional_information'],"method_title"))
				{
					$this->magento_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->Check_Field_V2($payment['additional_information'],"method_title"));
				}
				else
				{
					$this->magento_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType("other");
				}
				
				$this->magento_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($order->getShippingAmount(),2,'.','');
				
				if(MAGENTO_MULTI_CURRENCY_VIEW_AS_BASE_CURRENCY)
				{
					$this->magento_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($order->getBaseShippingAmount(),2,'.','');
				}
				
				$this->magento_orders[$counter]->order_info["ShipMethod"]=$order->getShippingDescription();
				$this->magento_orders[$counter]->order_info["Comments"]="";			
				
				if($order->getStatus()!="pending")
					$this->magento_orders[$counter]->order_info["PaymentStatus"]=2;
				else
					$this->magento_orders[$counter]->order_info["PaymentStatus"]=0;
				
				// Show Order status
				if($order->getStatus()=="complete")
					$this->magento_orders[$counter]->order_info["IsShipped"]=1;
				else
					$this->magento_orders[$counter]->order_info["IsShipped"]=0;
					
				// show if cancelled
				if($order->getStatus()=="canceled")
					$this->magento_orders[$counter]->order_info["IsCancelled"]=1;
				else
					$this->magento_orders[$counter]->order_info["IsCancelled"]=0;					
					
				 // handle closed order
				if($order->getStatus()=="closed")
				{
					$this->magento_orders[$counter]->order_info["IsCancelled"]=1;
					$this->magento_orders[$counter]->order_info["PaymentStatus"]=0;
					$this->magento_orders[$counter]->order_info["IsShipped"]=0;
				}
				
				// Order Level Gift Message
				if(Magento_RetrieveOrderGiftMessage==1)
				{
					$gift_message_id = $order->getGiftMessageId();										
					if(!is_null($gift_message_id)) 
					{
							$obtained_message=$ship_app->get_giftmessage()->getEscapedGiftMessage($order);
							$this->magento_orders[$counter]->order_info["Comments"]=$obtained_message;
					}
					
				}
				
				// Get customer note, if it is available from order comments module
				$customer_note_available=0;
				if($this->Check_Field_V2($order->getData(),'customer_note')!="")
				{
					$customer_note_available=1;
				}
				
				if($customer_note_available)
				{
					if($this->magento_orders[$counter]->order_info["Comments"]=="")
					$this->magento_orders[$counter]->order_info["Comments"]=$this->Check_Field_V2($order->getData(),'customer_note');
					else
					$this->magento_orders[$counter]->order_info["Comments"].="~".$this->Check_Field_V2($order->getData(),'customer_note');
				}
				else
				{
					$history = $order->getStatusHistoryCollection()->getLastItem();
					 
					if($history->getComment()!="")
					{
						if($this->magento_orders[$counter]->order_info["Comments"]=="")
						$this->magento_orders[$counter]->order_info["Comments"]=$history->getComment();
						else
						$this->magento_orders[$counter]->order_info["Comments"].="~".$history->getComment();
					}
				}
				
				// Get order products
				$actual_number_of_products=0;
				
				$order_items=$order->getAllItems();
				$product_stock_arr=array();
				
				foreach ($order_items as $item)
				{
					if($item->getParentItemId()=="")
					{
						if(count($product_stock_arr)>0)
						{
							if(array_key_exists($item->product_id,$product_stock_arr))
							{
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]=array();
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$item->getName().$this->GetProductOptions($item->getProductOptions());											
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getPrice();									
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$item->getSku().$this->GetProductOptions($item->getProductOptionByCode('simple_sku'));
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($product_stock_arr[$item->product_id],2,'.','');
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');	
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format(($this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');									
									$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]="";
									
									// Product Level Gift Message
									if(Magento_RetrieveProductGiftMessage==1)
									{
										$gift_message_id = $item->getGiftMessageId();
										
										if(!is_null($gift_message_id)) 
										{
												$message->load((int)$gift_message_id);
												$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]=$message->getData('message');
										}
									}
									$actual_number_of_products++;
							
							}
						}
						else
						{		
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]=array();
									
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$item->getName().$this->GetProductOptions($item->getProductOptions());											
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]=$item->getPrice();								
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$item->getSku().$this->GetProductOptions($item->getProductOptionByCode('simple_sku'));
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($item->getQtyOrdered(),2,'.','');
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');	
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format(($this->magento_orders[$counter]->order_product[$actual_number_of_products]["Price"]*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format(($item->getWeight()*$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]),2,'.','');								
								$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]="";
								
								// Product Level Gift Message
								if(Magento_RetrieveProductGiftMessage==1)
								{
									$gift_message_id = $item->getGiftMessageId();
									
									if(!is_null($gift_message_id)) 
									{
											$message->load((int)$gift_message_id);
											$this->magento_orders[$counter]->order_product[$actual_number_of_products]["Notes"]=$message->getData('message');
									}								
								}								
								$actual_number_of_products++;
							}					
					}
				}
				
				$this->magento_orders[$counter]->num_of_products=$actual_number_of_products;				
				
				$counter++;
			}				
		}
		############################################## Function RetrieveCatalogCount #################################
		// Get catalog count
		##############################################################################################################
		function RetrieveCatalogCount()
		{
			global $ship_app;
			
			$total_count=$ship_app->catalog_count();
			return  $total_count;
		}
		############################################## Function Fetch_DB_Catalog #################################
		// Fetch catalog
		##########################################################################################################
		function Fetch_DB_Catalog($limit,$offset)
		{
			global $ship_app;
			
			$catalog_data=$ship_app->get_catalog($limit,$offset);
			$counter=0;
			foreach ($catalog_data as $catalog) 
			{
				$this->magento_commodities[$counter]->catalog_commodity["Currency"]=$ship_app->get_store()->getStore()->getCurrentCurrencyCode();
				$this->magento_commodities[$counter]->catalog_commodity["Price"]=$catalog->getPrice();
				$this->magento_commodities[$counter]->catalog_commodity["CountryOfOrigin"]="";
				$this->magento_commodities[$counter]->catalog_commodity["UnitsOfMeasureLinear"]="";
				$this->magento_commodities[$counter]->catalog_commodity["UnitsOfMeasureWeight"]=strtoupper($ship_app->config_details()->getValue('general/locale/weight_unit',\Magento\Store\Model\ScopeInterface::SCOPE_STORE));
				$this->magento_commodities[$counter]->catalog_commodity["Weight"]=$catalog->getWeight();
				
				$this->magento_commodities[$counter]->catalog_commodity["Length"]="";	
				$this->magento_commodities[$counter]->catalog_commodity["Width"]="";
				$this->magento_commodities[$counter]->catalog_commodity["Height"]="";
				
				$this->magento_commodities[$counter]->catalog_commodity["Quantity"]=$ship_app->get_stock()->getStockItem($catalog->getId())->getQty();
				
				$this->magento_commodities[$counter]->catalog_commodity["Volume"]="";
				$this->magento_commodities[$counter]->catalog_commodity["LengthPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["WidthPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["HeightPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["WeightPackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["RowIndex"]="";
				$this->magento_commodities[$counter]->catalog_commodity["SKU"]=$catalog->getSKU();
				$this->magento_commodities[$counter]->catalog_commodity["Name"]=utf8_encode($catalog->getName());
				
				//get product type
				$this->magento_commodities[$counter]->catalog_commodity["ProductType"]="";
				$product_get_type = $ship_app->product_repository($catalog->getId());
				$product_type=$product_get_type->getTypeId();
				if($product_type!="") 
				$this->magento_commodities[$counter]->catalog_commodity["ProductType"]=$this->ConvertProductType($product_get_type->getTypeId());
				
				//check for configurable products
				$this->magento_commodities[$counter]->catalog_commodity["ParentPBCommodityId"]="";
				$this->magento_commodities[$counter]->catalog_commodity["VariationsNameValues"]="";
				$parent_id=$ship_app->check_if_child_of_configurable($catalog->getId());
				if($parent_id) //child product of configurable product
				{
					$product = $ship_app->product_repository($parent_id);
					if(!isset($option_data[$parent_id]))
					$option_data=$this->GetConfigurableOptions($product,$parent_id);
					
					$variants="";
					
					foreach($option_data[$parent_id] as $key=>$val)
					{
						if($variants!="") $variants.=",";
						$variants.=$key.":".$catalog->getResource()->getAttribute($key)->getFrontend()->getValue($catalog);
					}
										
					$this->magento_commodities[$counter]->catalog_commodity["ParentPBCommodityId"]=$parent_id;
					$this->magento_commodities[$counter]->catalog_commodity["VariationsNameValues"]=$variants;
				}
				
				
				$this->magento_commodities[$counter]->catalog_commodity["Description"]=utf8_encode($catalog->getDescription());
				$this->magento_commodities[$counter]->catalog_commodity["ExternalID"]=$catalog->getId();
				
				$this->magento_commodities[$counter]->catalog_commodity["URL"]=$catalog->getProductUrl();
				
				$this->magento_commodities[$counter]->catalog_commodity["UPC"]="";
				$this->magento_commodities[$counter]->catalog_commodity["VolumePackaged"]="";
				$this->magento_commodities[$counter]->catalog_commodity["Condition"]="";
				
				$this->magento_commodities[$counter]->catalog_commodity["Manufacturer"]="";
				if($catalog->getResource()->getAttribute('manufacturer')->getFrontend()->getValue($catalog)!="No")
				$this->magento_commodities[$counter]->catalog_commodity["Manufacturer"]=$catalog->getResource()->getAttribute('manufacturer')->getFrontend()->getValue($catalog);
				
				$this->magento_commodities[$counter]->catalog_commodity["ImageURL"]=$ship_app->get_store()->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_MEDIA) . 'catalog/product' . $catalog->getThumbnail();
				
				$counter++;
			}
			
		}
		 ############################################## Function UpdateCatalog #################################
		// Update catalog
		#######################################################################################################
		function UpdateCatalog($ExternalID ,$Quantity )
		{
			global $ship_app;
			
			$catalog_obj=$ship_app->catalog_product($ExternalID);
			
			// check if commodity id is valid
			if($catalog_obj->count()>0)
			{
				$catalog_data=$catalog_obj->load();
				foreach ($catalog_data as $catalog) 
				{
					$catalog->setStockData(['qty' => $Quantity, 'is_in_stock' => 1]);
					$catalog->setQuantityAndStockStatus(['qty' => $Quantity, 'is_in_stock' => 1]);
					$catalog->save();
					$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
				}			
			   
			}
			else
			{
				//display error message
				$this->display_msg=INVAID_COMMODITY_NUMBER_ERROR_MSG;
				$this->SetXmlError(1,$this->display_msg);
			
			}
		  
		}
		function GetGiftMessageText($message)
		{
			   $result = "";
			   if ($message->getData('sender')) $result = $result."From: ".$message->getData('sender')."\r\n";
			   if ($message->getData('recipient')) $result = $result."To: ".$message->getData('recipient')."\r\n\r\n";
			   $result = $result.$message->getData('message');
			   return $result;
		}
		function GetConfigurableOptions($product,$id)
		{
			$attribute_data=$product->getTypeInstance()->getConfigurableOptions($product);
			foreach($attribute_data as $attr){
			  foreach($attr as $p){
				$options[$id][$p['attribute_code']] = $p['option_title'];
			  }
			 	return $options;
			}
		}	
		
		################################### Function GetOrdersByDate($datefrom,$dateto) #######################
		// Get orders based on date range
		#######################################################################################################
		function GetOrdersByDate($datefrom,$dateto)
		{
				$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);				
	
				if (isset($this->magento_orders))
					return $this->magento_orders;
				else
				   return array();  				
		}
		  
		 #################################### Convert UTC time to Magento Format #####################################################
		 /* Magento stores all times in UTC but not in ISO 8601 format.Hence, change "YYYY-MM-DDThh:mm:ssZ" to "YYYY-MM-DD hh:mm:ss"*/
		 #############################################################################################################################
		  function GetServerTimeLocalMagento($server_date_iso) 
		  {				
				if(strpos($server_date_iso,"Z"))
				{
					$utc_fotmat_temp=str_replace("Z","",$server_date_iso);
					$server_date_utc=str_replace("T"," ",$utc_fotmat_temp); // "T" & "Z" removed from UTC format(in ISO 8601)
				}
				return $server_date_utc;
		  }	
		  
		  #################################### Convert Magento Format to UTC########################################################
		  /* Magento stores all times in UTC but not in ISO 8601 format.Hence, format date to ISO 8601 i.e "YYYY-MM-DDThh:mm:ssZ" */
		  ##########################################################################################################################
		  function ConvertServerTimeToUTCMagento($server_date_utc) 
		  {
			$utc_fotmat_temp=$server_date_utc."Z";
			$server_date_iso=str_replace(" ","T",$utc_fotmat_temp); // "T" & "Z" removed from UTC format(in ISO 8601)
			return $server_date_iso;
		  }		
		  ################################################## Function GetCatalog() #############################
		   // Get catalog based on paging
		  #######################################################################################################
		   function GetCatalog()
		   {
				$this->Fetch_DB_Catalog($this->Limit,$this->Offset);
				
				if (isset($this->magento_commodities))
					return $this->magento_commodities;
				else
					return array();  
			}
		############################################### Function PrepareOrderStatusString #######################
		//Prepare order status string based on settings
		#########################################################################################################
		function PrepareMagentoOrderStatusFilter()
		{				
				$order_status_filter=array();				
				
				if(MAGENTO_RETRIEVE_ORDER_STATUS_1_PENDING==1)
				{
					array_push($order_status_filter,'pending');
				}
				if(MAGENTO_RETRIEVE_ORDER_STATUS_2_PROCESSING==1)
				{
					array_push($order_status_filter,'processing');
				}
				if(MAGENTO_RETRIEVE_ORDER_STATUS_3_COMPLETE==1)
				{
					array_push($order_status_filter,'complete');
				}
				if(MAGENTO_RETRIEVE_ORDER_STATUS_4_CLOSED==1)
				{
					array_push($order_status_filter,'closed');
				}
				if(MAGENTO_RETRIEVE_ORDER_STATUS_4_CANCELLED==1)
				{
					array_push($order_status_filter,'canceled');
				}
				
				if($order_status_filter!="")
				$order_status_filter=$order_status_filter;						
				
				return $order_status_filter;				
		}		
		
	}

}
######################################### End of class ShippingZMagento ###################################################

// create object & perform tasks based on command
$obj_shipping_magento=new ShippingZMagento;
$obj_shipping_magento->ExecuteCommand();
?>
