<?php

define("SHIPPINGZMIJOSHOP_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// { $Revision$ }
// { $File$ }

//Function for checking Include Files
function Check_Include_File($filename, $mage_check=0)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		if($mage_check)
		{
			echo "\"$filename\" is not accessible.<br><br>";
			echo "Please, place all ShippingZ PHP files which are listed below at root folder of your Joomla website.<br>";
			echo "-ShippingZMijoShop.php<br>";
			echo "-ShippingZSettings.php<br>";
			echo "-ShippingZClasses.php<br>";
			echo "-ShippingZMessages.php<br>";
		}
		else
		{
			echo "\"$filename\" is not accessible.";
		}
		exit;
	}

}
//Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");

// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZMIJOSHOP_VERSION && SHIPPINGZMIJOSHOP_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZMijoShop.php [".SHIPPINGZMIJOSHOP_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

//Incude reqired Joomla files
define('_JEXEC', 1);
define( 'DS', DIRECTORY_SEPARATOR );
if (file_exists(dirname(__FILE__) . '/defines.php')) {
	include_once dirname(__FILE__) . '/defines.php';
}

if (!defined('_JDEFINES')) {
	define('JPATH_BASE', dirname(__FILE__));
	require_once JPATH_BASE.'/includes/defines.php';
}

require_once( JPATH_BASE . DS . 'libraries' . DS . 'import.php' ); // framework
require_once( JPATH_BASE . DS . 'configuration.php' ); // config file

require_once JPATH_BASE.'/includes/framework.php';

$db = JFactory::getDBO();
############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");
############################################## Class ShippingZMijoShop ##########################################
class ShippingZMijoShop extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	############################################## Function Check_DB_Access #################################
	//Check Database access
	#######################################################################################################
	function Check_DB_Access()
	{
		
		global $db;
		
		try //See if we can access joomla database
		{
			$query="Show columns FROM #__mijoshop_order ";
			$db->setQuery($query);
			$db->query();
			$num_rows = $db->getNumRows();
			if($num_rows>0)
			$this->display_msg=DB_SUCCESS_MSG;
		}
		catch(Exception $e)
		{
			$this->display_msg="Could not access Joomla database";
			$this->SetXmlError(1,$this->display_msg);
			exit;
				
		}
			
	}
	
	################################################ Function ConvertToPound() #######################
	//Converts weight values to pound
	#######################################################################################################
	function ConvertToPound($weight,$from_unit)
	{
		
		$from_unit=trim($from_unit);
		
		if($from_unit=='oz' || $from_unit=='ozs')
		{
			
			$converted_weight=$weight*0.0625;
		}
		else if($from_unit=='kg' || $from_unit=='kgs')
		{
		
			$converted_weight=$weight*2.20462;
		}
		else if($from_unit=='g' || $from_unit=='gm' || $from_unit=='gms')
		{
		
			$converted_weight=$weight*0.0022;
		}
		else 
		{
		
			$converted_weight=$weight;
		}
		return $converted_weight;
	}
	############################################## Function GetOrderCountByDate #################################
	//Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		global $db;
		
		$order_status_filter=$this->PrepareMijoShopOrderStatusFilter();
			
		$datefrom_timestamp=$this->GetServerTimeLocal(true,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(true,$dateto);
		
		$sql = "SELECT order_id FROM #__mijoshop_order";
		$sql .= " WHERE " . $order_status_filter . "";
		$sql .= " (( DATE_FORMAT(date_modified,\"%Y-%m-%d %T\") between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp).") OR  ( DATE_FORMAT(date_added,\"%Y-%m-%d %T\") between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp)." ))";
		
		$db->setQuery($sql);
		$db->query();
		$num_rows = $db->getNumRows();
			
		return $num_rows;
	
	}
	############################################## Function UpdateShippingInfo #################################
	//Update order status
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $db;
		
		
		$sql = "SELECT order_status_id FROM #__mijoshop_order WHERE order_id=".$db->quote($OrderNumber);
		
		$db->setQuery($sql);
		$db->query();
		$num_rows = $db->getNumRows();
		//check if order number is valid
		if($num_rows>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
			
			$tracking_url="";	
			if($Carrier!="")
			{
				if(defined(strtoupper($Carrier)."_URL"))
				{
					$temp_url=constant(strtoupper($Carrier)."_URL");
					$tracking_url=" <a href=\"".$temp_url."\" target=\"_blank\"> $TrackingNumber</a>";
					$tracking_url=str_replace("[TRACKING_NUMBER]",$TrackingNumber,$tracking_url);
				}
				$Carrier=" via ".$Carrier;
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			if($TrackingNumber!="")
			{
				if($tracking_url!="")
				{
					$TrackingNumberString=", Tracking number $tracking_url";
				}
				else
				{
					$TrackingNumberString=", Tracking number $TrackingNumber";
				}
			}
			$result = $db->loadObjectList();
			
			foreach ($result as $order_row)
			{
				$current_order_status=$order_row->order_status_id;
			}
			
			
								
			//prepare $comments & save it
			$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
			
			if(MIJOSHOP_SHIPPED_STATUS_SET_TO_STATUS_4_COMPLETED==1)
			{
				
				 $upate_order_history_sql="insert into #__mijoshop_order_history
						  (order_id, order_status_id,date_added, notify, comment)
						  values (".$db->quote($OrderNumber).", 5,".$db->quote(date('Y-m-d H:i:s')).",1, ".$db->quote($comments).")";
				 $db->setQuery($upate_order_history_sql);
				 $db->query();
				
						  
				//update order status
				$upate_order_sql=" update `#__mijoshop_order` set order_status_id=5 where order_id=".$db->quote($OrderNumber);
				$db->setQuery($upate_order_sql);
				$db->query();	  
			 } 
			 else
			 {
			 	
				if($current_order_status==1)
					$change_order_status=2;
				else if($current_order_status==2)
					$change_order_status=3;
				else if($current_order_status==3)
					$change_order_status=5;
				else
					$change_order_status=$current_order_status;
				
				 $upate_order_history_sql="insert into #__mijoshop_order_history
						  (order_id, order_status_id,date_added, notify, comment)
						  values (".$db->quote($OrderNumber).", ".$change_order_status.",".$db->quote(date('Y-m-d H:i:s')).",1, ".$db->quote($comments).")";
				 $db->setQuery($upate_order_history_sql);
				 $db->query();
				
						  
				if($change_order_status!=$current_order_status)
				{
					$upate_order_sql=" update `#__mijoshop_order` set order_status_id=$change_order_status where order_id=".$db->quote($OrderNumber);
				 	$db->setQuery($upate_order_sql);
					$db->query();	
				 }
			 
			 }
			
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			//display error message
			$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		}	
	}
	############################################## Function Fetch_DB_Orders #################################
	//Fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $db;
		
		$order_status_filter=$this->PrepareMijoShopOrderStatusFilter();
		
		$datefrom_timestamp=$this->GetServerTimeLocal(true,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(true,$dateto);
		
		
		$sql = "SELECT o.order_id,o.order_status_id,o.shipping_firstname,o.shipping_lastname,o.shipping_company,o.shipping_address_1,o.shipping_address_2,
		o.shipping_city,o.shipping_zone,o.shipping_postcode,o.shipping_country,o.telephone,o.email,o.payment_firstname,o.payment_lastname,o.payment_company,
		o.payment_address_1,o.payment_address_2,o.payment_city,o.payment_zone,o.payment_postcode,o.payment_country,o.telephone,o.email,
		o.date_added,o.payment_method,o.shipping_method,o.comment,o.total FROM `#__mijoshop_order` o";

		$sql .= " WHERE " . $order_status_filter . "";
			
		$sql .= " (( DATE_FORMAT(date_modified,\"%Y-%m-%d %T\") between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp).") OR  ( DATE_FORMAT(date_added,\"%Y-%m-%d %T\") between ".$db->quote($datefrom_timestamp )." and ".$db->quote($dateto_timestamp)." ))";
		
		$db->setQuery($sql);
		$order_data = $db->loadObjectList();
		
		$this->mijoshop_orders=array();
		$counter=0;
		
		foreach ($order_data as $mijoshop_orders_row)
		{
		
			//prepare order array
			$this->mijoshop_orders[$counter]=new stdClass();
			$this->mijoshop_orders[$counter]->orderid=$mijoshop_orders_row->order_id;
				
			//shipping details
			$this->mijoshop_orders[$counter]->order_shipping["FirstName"]=$mijoshop_orders_row->shipping_firstname;
			$this->mijoshop_orders[$counter]->order_shipping["LastName"]=$mijoshop_orders_row->shipping_lastname;
			$this->mijoshop_orders[$counter]->order_shipping["Company"]=$mijoshop_orders_row->shipping_company;
			$this->mijoshop_orders[$counter]->order_shipping["Address1"]=$mijoshop_orders_row->shipping_address_1;			
			$this->mijoshop_orders[$counter]->order_shipping["Address2"]=$mijoshop_orders_row->shipping_address_2;
			$this->mijoshop_orders[$counter]->order_shipping["City"]=$mijoshop_orders_row->shipping_city;		
			$this->mijoshop_orders[$counter]->order_shipping["State"]=$mijoshop_orders_row->shipping_zone;
			$this->mijoshop_orders[$counter]->order_shipping["PostalCode"]=$mijoshop_orders_row->shipping_postcode;			
			$this->mijoshop_orders[$counter]->order_shipping["Country"]=$mijoshop_orders_row->shipping_country;
			$this->mijoshop_orders[$counter]->order_shipping["Phone"]=$mijoshop_orders_row->telephone;
			$this->mijoshop_orders[$counter]->order_shipping["EMail"]=$mijoshop_orders_row->email;
			
			//billing details
			$this->mijoshop_orders[$counter]->order_billing["FirstName"]=$mijoshop_orders_row->payment_firstname;
			$this->mijoshop_orders[$counter]->order_billing["LastName"]=$mijoshop_orders_row->payment_lastname;
			$this->mijoshop_orders[$counter]->order_billing["Company"]=$mijoshop_orders_row->payment_company;
			$this->mijoshop_orders[$counter]->order_billing["Address1"]=$mijoshop_orders_row->payment_address_1;			
			$this->mijoshop_orders[$counter]->order_billing["Address2"]=$mijoshop_orders_row->payment_address_2;
			$this->mijoshop_orders[$counter]->order_billing["City"]=$mijoshop_orders_row->payment_city;
			$this->mijoshop_orders[$counter]->order_billing["State"]=$mijoshop_orders_row->payment_zone;
			$this->mijoshop_orders[$counter]->order_billing["PostalCode"]=$mijoshop_orders_row->payment_postcode;
			$this->mijoshop_orders[$counter]->order_billing["Country"]=$mijoshop_orders_row->payment_country;
			$this->mijoshop_orders[$counter]->order_billing["Phone"]=$mijoshop_orders_row->telephone;
			$this->mijoshop_orders[$counter]->order_billing["EMail"]=$mijoshop_orders_row->email;
			
			//order info
			if(!defined("LEAVE_TIME_IN_SERVER_ZONE"))
			define("LEAVE_TIME_IN_SERVER_ZONE", "0");
			
			if(LEAVE_TIME_IN_SERVER_ZONE)
			$this->mijoshop_orders[$counter]->order_info["OrderDate"]=$this->FormatOrderDate($mijoshop_orders_row->date_added);
			else
			$this->mijoshop_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTC(true,strtotime($mijoshop_orders_row->date_added));
			$this->mijoshop_orders[$counter]->order_info["OrderNumber"]=$mijoshop_orders_row->order_id;
			$this->mijoshop_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($mijoshop_orders_row->payment_method);
			
			
			//for older version of opencart, 'weight' tablle does not have 'unit' column, hence check for "unit" column	to identify the version
			$sql_unit="SHOW columns from #__mijoshop_weight_class where field='unit'";
			$db->setQuery($sql_unit);
						
			
			$check_col_flag=0;
			if( $db->getNumRows()>0)
			$check_col_flag=1;
			
			$shipping_charge="";
			$tax="";
			
			if(!$check_col_flag)
			{
				$sql_ot='SELECT code,value from #__mijoshop_order_total where order_id='.$db->quote($mijoshop_orders_row->order_id);
				$db->setQuery($sql_ot);
				$order_total_result = $db->loadObjectList();
				
				foreach ($order_total_result as $opencart_order_total)
				{
				
						if($opencart_order_total->code=="shipping")
						$shipping_charge=$opencart_order_total->value;
						
						if($opencart_order_total->code=="tax")
						$tax=$opencart_order_total->value;
				}
			}
			else
			{
				
				$sql ='SELECT title,value from #__mijoshop_order_total where order_id='.$db->quote($mijoshop_orders_row->order_id);
				$db->setQuery($sql);
				$order_total_result = $db->loadObjectList();
				
				foreach ($order_total_result as $opencart_order_total)
				{
				
						if(strstr(strtolower($opencart_order_total->title),"shipping"))
						$shipping_charge=$this->GetFieldNumber($opencart_order_total->value);
						
							if(strstr(strtolower($opencart_order_total->title),"tax"))
						$tax=$this->GetFieldNumber($opencart_order_total->value);
				}
			}
			
			//get shipping charges
			$this->mijoshop_orders[$counter]->order_info["ShippingChargesPaid"]=$this->FormatNumber($shipping_charge);
			$this->mijoshop_orders[$counter]->order_info["ShipMethod"]=$mijoshop_orders_row->shipping_method;
			
			
			//Extract tax amount
			$this->mijoshop_orders[$counter]->order_info["ItemsTax"]=$this->FormatNumber($tax);
			
			$unpaid_order_status_arr=explode(",",MIJOSHOP_UNPAID_ORDER_STATUSES);
			$shipped_order_status_arr=explode(",",MIJOSHOP_SHIPPED_ORDER_STATUSES);
			
			if(!in_array($mijoshop_orders_row->order_status_id,$unpaid_order_status_arr))
				$this->mijoshop_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->mijoshop_orders[$counter]->order_info["PaymentStatus"]=0;
			
			//Order status	
			if(in_array($mijoshop_orders_row->order_status_id,$shipped_order_status_arr))
				$this->mijoshop_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->mijoshop_orders[$counter]->order_info["IsShipped"]=0;
			
			//Get Customer Comments
		
			$this->mijoshop_orders[$counter]->order_info["Comments"]=$mijoshop_orders_row->comment;
			//Get order products
			$items_cost=0;
			
			
			$sql_product='SELECT op.order_product_id,op.name,op.model,op.price,op.quantity,p.weight,p.weight_class_id from #__mijoshop_order_product op, #__mijoshop_product p where op.order_id='.$db->quote($mijoshop_orders_row->order_id).' and op.product_id=p.product_id';
			
			
			$i=0;
			$db->setQuery($sql_product);
			$product_result_arr = $db->loadObjectList();
			$uom_weight="";
			$product_weight=0;
			
			foreach ($product_result_arr as $product_row) 
			{			
				$unit_price=$product_row->price;
				$this->mijoshop_orders[$counter]->order_product[$i]["Price"]=$this->FormatNumber($unit_price);
				$this->mijoshop_orders[$counter]->order_product[$i]["ExternalID"]=$product_row->model;
				$this->mijoshop_orders[$counter]->order_product[$i]["Quantity"]=$product_row->quantity;
				
				$this->mijoshop_orders[$counter]->order_product[$i]["Total"]=$this->FormatNumber($unit_price*$product_row->quantity);
				
				$items_cost=$items_cost+$this->mijoshop_orders[$counter]->order_product[$i]["Total"];
				
				if($product_row->weight_class_id>0)
				{
					//handle weight unit
					if(!$check_col_flag)
					$weight_sql ='SELECT unit from #__mijoshop_weight_class_description where weight_class_id='.$db->quote($product_row->weight_class_id);
					else
					$weight_sql ='SELECT unit from #__mijoshop_weight_class where weight_class_id='.$db->quote($product_row->weight_class_id);
					
					$db->setQuery($weight_sql);
				    $weight_result_arr = $db->loadObjectList();
					
					foreach ($weight_result_arr as $weight_unit_row) 
					{
						
						$product_weight=$this->ConvertToPound($product_row->weight,$weight_unit_row->unit);
						$uom_weight=$weight_unit_row->unit;	
					}
						
					
				}
				
				
				$this->mijoshop_orders[$counter]->order_product[$i]["Total_Product_Weight"]=$product_weight*$product_row->quantity;
				
				//product options
				$sql_product_opt ='SELECT name,value from #__mijoshop_order_option  where order_product_id='.$db->quote($product_row->order_product_id).' and order_id='.$db->quote($this->mijoshop_orders[$counter]->orderid);
				
				$db->setQuery($sql_product_opt);
				$db->query();		
				$attributes="";
				if($db->getNumRows()>0)
				{
					$product_option_arr = $db->loadObjectList();
					
					foreach ($product_option_arr as $option_arr_row) 
					{
						if($attributes!="")
						$attributes.=",";
						
						$attributes.=$option_arr_row->name.":".$option_arr_row->value;
					}
					
					$this->mijoshop_orders[$counter]->order_product[$i]["Name"]=$product_row->name." (".$attributes.")";
					
				}
				else
				{
					$this->mijoshop_orders[$counter]->order_product[$i]["Name"]=$product_row->name;
				}
				$i++;
			}
			
			$this->mijoshop_orders[$counter]->num_of_products=$i;
			
			$this->mijoshop_orders[$counter]->order_info["ItemsTotal"]=$this->FormatNumber($items_cost,2);
			
			$this->mijoshop_orders[$counter]->order_info["Total"]=$this->FormatNumber($mijoshop_orders_row->total);
			
			$this->mijoshop_orders[$counter]->order_info["UOMWeight"]=strtoupper($uom_weight);
			
			$this->mijoshop_orders[$counter]->order_product[$i]["IndividualProductWeight"]=$product_weight*$product_row->quantity;
						
			$counter++;
			
			
		}//end foreach
		
		
	}

	
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->mijoshop_orders))
				return $this->mijoshop_orders;
			else
               return array();  

			
	}
	  
	  

	#######################################################################################################
	############################################### Function PrepareOrderStatusString #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareMijoShopOrderStatusFilter()
	{
			
					$order_status_filter="";
					
					if(MIJOSHOP_RETRIEVE_ORDER_STATUS_1_PENDING==1)
					{
						$order_status_filter=" order_status_id='1' ";
					
					}
					if(MIJOSHOP_RETRIEVE_ORDER_STATUS_2_PROCESSING==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='2'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='2'  ";
						}
					
					}
					if(MIJOSHOP_RETRIEVE_ORDER_STATUS_5_PROCESSED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='15'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='15'  ";
						}
					
					}
					if(MIJOSHOP_RETRIEVE_ORDER_STATUS_3_SHIPPED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='3'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='3'  ";
						}
					
					}
					if(MIJOSHOP_RETRIEVE_ORDER_STATUS_4_COMPLETED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='5'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='5' ";
						}
					
					}
					if(MIJOSHOP_RETRIEVE_ORDER_STATUS_6_CANCELLED==1)
					{
						if($order_status_filter=="")
						{
							$order_status_filter.=" order_status_id='7'  ";
						}
						else
						{
							$order_status_filter.=" OR order_status_id='7'  ";
						}
					
					}
					
					if($order_status_filter!="")
					$order_status_filter="( ".$order_status_filter." ) and";
					
			
			return $order_status_filter;
			
	}
	
	
}
######################################### End of class ShippingZMijoShop ###################################################
	
	//create object & perform tasks based on command
	$obj_shipping_mijoshop=new ShippingZMijoShop;
	$obj_shipping_mijoshop->ExecuteCommand();	

?>
