<?php
define("SHIPPINGZOXID_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// Function for checking Include Files
function Check_Include_File($filename)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		echo "\"$filename\" is not accessible.";
		exit;
	}

}

// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");


// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZOXID_VERSION && SHIPPINGZOXID_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZOxid.php [".SHIPPINGZOXID_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}
################################################ Function convert_dim_unit #######################
//Converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	$converted_val_unit=strtoupper($from_unit);
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_val_unit=strtoupper($from_unit);
	}
	else if($from_unit=='m' )
	{
		$converted_val_unit="CM";
	}
	else 
	{
	
		$converted_val_unit="Unknown";
	}

	return $converted_val_unit;
}
################################################ Function convert_dim_value #######################
//Converts dim value to desired units
function convert_dim_value($val,$from_unit)
{
	$from_unit=trim($from_unit);
	$converted_val=$val;
	if($val>0)
	{	
		if($from_unit=='cm' || $from_unit=='in')
		{
			$converted_val=$val;
		}
		else if($from_unit=='m' )
		{
			$converted_val=$val*100;
		}
		else 
		{
			$converted_val=$val;
		}
	}
	return $converted_val;
}

############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");

class OxidVariables
{
	public function __construct()
    {
		// include oxid config file
		if(Check_Include_File("config.inc.php"))
		include("config.inc.php");
	}
}
$ObjOxidVariables=new OxidVariables;
$ox_version_four=0;
// Include lang file
if(file_exists("Application/views/admin/en/lang.php")) // version 6.x
include("Application/views/admin/en/lang.php");
else if(Check_Include_File("application/views/admin/en/lang.php")) // version 4.x
{
	include("application/views/admin/en/lang.php");
	$ox_version_four=1;
}
// Include theme.php
if(file_exists("Application/views/flow/theme.php")) // version 6.x
include("Application/views/flow/theme.php");
else if(Check_Include_File("application/views/flow/theme.php")) // version 4.x
include("application/views/flow/theme.php");
####################################################################################################################################
################################################## Get Folder Name of Product Image  ###############################################
function get_product_folder($path)
{
	global $aTheme;
	$folder_name_prefix="540_340";
	$selected_folder_name="540_340_75";
	$flag=1;
	// get folder name of image folder based on theme settings
	foreach($aTheme as $key=>$val)
	{
		if($key=="settings")
		{ 
			foreach($val as $key2=>$val2)
			{
				if(isset($val2['name']))
				{
					if($val2['name']=='aDetailImageSizes')
					{
						$arr=$val2['value'];
						$image_size=$arr['oxpic1'];
						$folder_name_prefix=str_replace("*", "_",$image_size);
						$flag=0;
						break;
					}
				}
			}
		}
		if(!$flag) break;
	  }
	  $dir = dir($path);
	  while (false !== ($sub_dir = $dir->read()))
	  {
	 	if(strstr($sub_dir,$folder_name_prefix))
	 	$selected_folder_name=$sub_dir;
	  } 
	 return $selected_folder_name;
}
################################################# Get Attributes ###########################################################
#############################################################################################################################
function get_attributes($variants,$OXVARNAME,$OXVARSELECT)
{
	
	if(strstr($OXVARNAME,"|"))
	{
		$temp_att_label=explode("|",$OXVARNAME);
		$temp_att_val=explode("|",$OXVARSELECT);
		for($k=0;$k<count($temp_att_label);$k++)
		{
		   if($variants!="")  $variants.=",";
		   $variants.=$temp_att_label[$k].":".$temp_att_val[$k];
		}
	}
	else
	$variants.=$OXVARNAME.":".$OXVARSELECT;
	
	return $variants;

}
#################################################### Get oxid config #####################################################
############################################################################################################################
require("bootstrap.php");
if($ox_version_four)
$oxConfig = oxRegistry::getConfig();
else
$oxConfig = \OxidEsales\Eshop\Core\Registry::getConfig();
##############################################################################################################################

if (extension_loaded('pdo') && extension_loaded('pdo_mysql') ) 
{
	
	try
	{
		$db_pdo=new PDO("mysql:host=".$ObjOxidVariables->dbHost.";dbname=".$ObjOxidVariables->dbName, $ObjOxidVariables->dbUser, $ObjOxidVariables->dbPwd);
	}
	catch( Exception $e )
	{
		echo $e->getMessage();
		exit;
	}
	
}
else
{
	echo "The PDO system appears disabled. Please check the php.ini setting and make sure following extensions are enabled.<br>
	extension=pdo.so;<br>
	extension=pdo_mysql.so;<br>
	PDO is required.";
	exit;

}
############################################## Class ShippingZOxid ##########################################################
class ShippingZOxid extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	############################################## Function Check_DB_Access #################################
	//Check Database access
	#######################################################################################################
	
	function Check_DB_Access()
	{
		global $db_pdo;
		//check if oxid database can be acessed or not
		$sql = "SHOW COLUMNS FROM oxorder";
		
		$result = $db_pdo->prepare($sql);
		$result->execute();
		if ($result->rowCount()) 
		{
			$this->display_msg=DB_SUCCESS_MSG;
			
		}
		else
		{
			$this->display_msg=DB_ERROR_MSG;
		}
		
	}
	
	############################################## Function GetOrderCountByDate #################################
	// Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		
		global $db_pdo;
		
		// Get order count based on data range
		$datefrom_timestamp=$this->GetServerTimeLocal(true,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(true,$dateto);
		
		$order_status_filter=$this->PrepareOxidOrderStatusFilter();
		
		$sql = "SELECT OXID FROM oxorder where 1 and ".$order_status_filter." (OXORDERDATE between :datefrom and :dateto )";
			
		$data=array(':datefrom' => $datefrom_timestamp, ':dateto' =>$dateto_timestamp);
		
		$result = $db_pdo->prepare($sql);
		$result->execute($data);
	
		return  $result->rowCount();
	
	}
	############################################## Function UpdateShippingInfo ################################################################
	// Update order status
	############################################################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $db_pdo;
		
		$sql = "SELECT * FROM oxorder WHERE OXORDERNR=:orderid";
		$data=array(':orderid' => $OrderNumber);
		
		$result = $db_pdo->prepare($sql);
		$result->execute($data);
		// check if order number is valid
		
		if($result->rowCount()>0)
		{
			foreach ($result as $row)
		   {
				
				if($ShipDate!="")
					$shipped_on=$ShipDate;
				else
					$shipped_on=date("m/d/Y");
				
				$Carrier_org="";					
				if($Carrier!="")
				{
					$Carrier_org=$Carrier;
					$Carrier=" via ".$Carrier;
				}
				$Service_org="";
				if($Service!="")
				{
					$Service_org=$Service;
					$Service=" [".$Service."]";
				}
				
				$TrackingNumberString="";
				$tracking_sql="";
				if($TrackingNumber!="")
				{
					$TrackingNumberString=", Tracking number $TrackingNumber";
					$tracking_sql=" ,OXTRACKCODE=:tracking";
				}
				
			    $current_order_status=$row['OXFOLDER'];
											
				// prepare $comments (appending existing notes)
				$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;	
				
				$oxuserid=$row['OXUSERID'];			
								
			}
			$ShippingCost_sql="";
			if($ShippingCost!="")
			$ShippingCost_sql=", OXDELCOST =:shippingcost ";
			// update order table
			if(OXID_SHIPPED_STATUS_SET_TO_STATUS_3_COMPLETED==1)
			{
				$change_order_status='ORDERFOLDER_FINISHED';
			}
			else
			{
				if($current_order_status=='ORDERFOLDER_NEW' )
					$change_order_status='ORDERFOLDER_FINISHED';
				else
					$change_order_status=$current_order_status;					
				
			}
			
			// Update order table
			$sql_upd="update oxorder set  OXFOLDER=:shipping_status_id ".$tracking_sql.$ShippingCost_sql.", OXSENDDATE=:send_date where OXORDERNR=:orderid";
									
			if($TrackingNumber!="")
			{
				if($ShippingCost=="")
				$data_upd=array(':orderid' => $OrderNumber,':tracking'=>$TrackingNumber, ':shipping_status_id' => $change_order_status,':send_date' => date("Y-m-d H:i:s"));
				else
				$data_upd=array(':orderid' => $OrderNumber,':tracking'=>$TrackingNumber, ':shippingcost'=>$ShippingCost,':shipping_status_id' => $change_order_status,':send_date' => date("Y-m-d H:i:s"));
			}
			else
			{
				if($ShippingCost=="")
				$data_upd=array( ':orderid' => $OrderNumber, ':shipping_status_id' => $change_order_status,':send_date' => date("Y-m-d H:i:s"));
				else
				$data_upd=array( ':orderid' => $OrderNumber, ':shipping_status_id' => $change_order_status,':shippingcost'=>$ShippingCost, ':send_date' => date("Y-m-d H:i:s"));
			}
				
			$result_upd = $db_pdo->prepare($sql_upd);
			$result_upd->execute($data_upd);	
			
			// Check if carrier matches
			$sql_carrier = "SELECT * FROM oxdeliveryset WHERE OXTITLE=:carrier || OXTITLE=:service || OXTITLE=:carrier_service";
			
			$data_carrier=array(':carrier' => $Carrier_org,':service' => $Service_org,':carrier_service' => $Carrier_org." ".$Service_org);
			$result_carrier = $db_pdo->prepare($sql_carrier);
			$result_carrier->execute($data_carrier);
			if($result_carrier->rowCount()>0)
			{
				foreach ($result_carrier as $row_carrier)
			   {
			   		$store_shipping_method_id=$row_carrier['OXID'];
					//Update Shipping Method
					$sql_upd_shipping_method="update oxorder set  OXDELTYPE=:store_shipping_method_id  where OXORDERNR=:orderid";
					$data_upd_shipping_method=array( ':store_shipping_method_id'=>$store_shipping_method_id,':orderid' => $OrderNumber);
					$result_upd_shipping_method = $db_pdo->prepare($sql_upd_shipping_method);
					$result_upd_shipping_method->execute($data_upd_shipping_method);
				}
			}
			
			
			// Update order history 
			$sql_upd_history="Insert into  oxremark set  OXID=:new_id, OXPARENTID=:oxuserid, OXTYPE=:type, OXHEADER=:send_date, OXTEXT=:comment, OXCREATE=:ox_create";
			$data_upd_history=array( ':new_id'=>md5(uniqid('', true) . '|' . microtime()), ':oxuserid' => $oxuserid, ':type' => 'r',':send_date' => date("Y-m-d H:i:s"), ':comment'=>$comments,':ox_create' => date("Y-m-d H:i:s"));
			 
			$result_upd_history = $db_pdo->prepare($sql_upd_history);
			$result_upd_history->execute($data_upd_history);	
			
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));			
		   
		}
		else
		{
			//display error message
			$this->display_msg=str_replace("ENTERED_ORDERED_NUMBER","#$OrderNumber",INVAID_ORDER_NUMBER_ERROR_MSG);
			$this->SetXmlError(1,$this->display_msg);
		
		}
	  
	}
	############################################## Function Fetch_DB_Orders #################################
	// Perform Database query & fetch orders based on date range
	#######################################################################################################
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $db_pdo,$aLang;
				
		$order_status_filter=$this->PrepareOxidOrderStatusFilter();
		
		$search=$order_status_filter." (OXORDERDATE between :datefrom and :dateto )";
		
		$orders_query_raw = "SELECT * FROM oxorder where 1 and".$search;
				
		$data=array(':datefrom' => $this->GetServerTimeLocal(true,$datefrom), ':dateto' =>$this->GetServerTimeLocal(true,$dateto));
		
		$oxid_orders_res = $db_pdo->prepare($orders_query_raw);
		$oxid_orders_res->execute($data);
		
		$counter=0;
		foreach ($oxid_orders_res as $oxid_orders_row) 
		{
			
			// prepare order array
			$this->oxid_orders[$counter]=new stdClass();
			$this->oxid_orders[$counter]->orderid=$this->GetFieldNumber($oxid_orders_row,"OXID");
			
			$this->oxid_orders[$counter]->order_info['PkgLength']="";
			$this->oxid_orders[$counter]->order_info['PkgWidth']="";
			$this->oxid_orders[$counter]->order_info['PkgHeight']="";
			
			// shipping details			
			$this->oxid_orders[$counter]->order_shipping["FirstName"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXDELFNAME"));
			$this->oxid_orders[$counter]->order_shipping["LastName"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXDELLNAME"));
			$this->oxid_orders[$counter]->order_shipping["Company"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXDELCOMPANY"));
			
			$this->oxid_orders[$counter]->order_shipping["Address1"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXDELSTREET"));
			if($this->GetFieldString($oxid_orders_row,"OXDELSTREETNR")!="")
			$this->oxid_orders[$counter]->order_shipping["Address1"]=$this->oxid_orders[$counter]->order_shipping["Address1"]." ".utf8_encode($this->GetFieldString($oxid_orders_row,"OXDELSTREETNR"));
			
			$this->oxid_orders[$counter]->order_shipping["Address2"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXDELADDINFO"));
			$this->oxid_orders[$counter]->order_shipping["City"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXDELCITY"));		
			$this->oxid_orders[$counter]->order_shipping["PostalCode"]=$this->GetFieldString($oxid_orders_row,"OXDELZIP");			
			$this->oxid_orders[$counter]->order_shipping["Phone"]=$this->GetFieldString($oxid_orders_row,"OXDELFON");
							
			$this->oxid_orders[$counter]->order_shipping["Country"]="";
			$s_country_query = "SELECT * FROM  oxcountry where OXID=:countryID ";
			
			$data=array(':countryID' => $this->GetFieldString($oxid_orders_row,"OXDELCOUNTRYID"));
			
			$s_country_res = $db_pdo->prepare($s_country_query);
			$s_country_res->execute($data);
			
			foreach ($s_country_res as $s_country_row) 
			$this->oxid_orders[$counter]->order_shipping["Country"]=$this->GetFieldString($s_country_row,"OXISOALPHA2");
			
			$this->oxid_orders[$counter]->order_shipping["State"]="";
			
			if($this->GetFieldString($oxid_orders_row,"OXDELSTATEID")!="")
			{
				$s_state_query = "SELECT * FROM  oxstates where OXID=:stateID ";
			
				$data=array(':stateID' => $this->GetFieldString($oxid_orders_row,"OXDELSTATEID"));
				
				$s_state_res = $db_pdo->prepare($s_state_query);
				$s_state_res->execute($data);
				
				foreach ($s_state_res as $s_state_row) 
				$this->oxid_orders[$counter]->order_shipping["State"]=utf8_encode($this->GetFieldString($s_state_row,"OXISOALPHA2"));
			
			}
				
					
			// billing details			
			$this->oxid_orders[$counter]->order_billing["FirstName"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLFNAME"));
			$this->oxid_orders[$counter]->order_billing["LastName"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLLNAME"));
			$this->oxid_orders[$counter]->order_billing["Company"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLCOMPANY"));
			$this->oxid_orders[$counter]->order_billing["Address1"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLSTREET"));	
			if($this->GetFieldString($oxid_orders_row,"OXBILLSTREETNR")!="")
			$this->oxid_orders[$counter]->order_billing["Address1"]=$this->oxid_orders[$counter]->order_billing["Address1"]." ".utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLSTREETNR"));
					
			$this->oxid_orders[$counter]->order_billing["Address2"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLADDINFO"));
			$this->oxid_orders[$counter]->order_billing["City"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLCITY"));		
			$this->oxid_orders[$counter]->order_billing["PostalCode"]=$this->GetFieldString($oxid_orders_row,"OXBILLZIP");			
			$this->oxid_orders[$counter]->order_billing["Phone"]=$this->GetFieldString($oxid_orders_row,"OXBILLFON");
							
			$this->oxid_orders[$counter]->order_billing["Country"]="";
			$s_country_query = "SELECT * FROM  oxcountry where OXID=:countryID ";
			
			$data=array(':countryID' => $this->GetFieldString($oxid_orders_row,"OXBILLCOUNTRYID"));
			
			$s_country_res = $db_pdo->prepare($s_country_query);
			$s_country_res->execute($data);
			
			foreach ($s_country_res as $s_country_row) 
			$this->oxid_orders[$counter]->order_billing["Country"]=$this->GetFieldString($s_country_row,"OXISOALPHA2");
			
			$this->oxid_orders[$counter]->order_billing["State"]="";
			
			if($this->GetFieldString($oxid_orders_row,"OXBILLSTATEID")!="")
			{
				$s_state_query = "SELECT * FROM  oxstates where OXID=:stateID ";
			
				$data=array(':stateID' => $this->GetFieldString($oxid_orders_row,"OXBILLSTATEID"));
				
				$s_state_res = $db_pdo->prepare($s_state_query);
				$s_state_res->execute($data);
				
				foreach ($s_state_res as $s_state_row) 
				$this->oxid_orders[$counter]->order_billing["State"]=utf8_encode($this->GetFieldString($s_state_row,"OXISOALPHA2"));
			
			}
				
					
			// get user details
			$this->oxid_orders[$counter]->order_shipping["EMail"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLEMAIL"));
			$this->oxid_orders[$counter]->order_billing["EMail"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXBILLEMAIL"));
			
			// order info
			$this->oxid_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTC(true,strtotime($this->GetFieldString($oxid_orders_row,"OXORDERDATE")));
			$this->oxid_orders[$counter]->order_info["OrderNumber"]=$this->GetFieldNumber($oxid_orders_row,"OXORDERNR");
			
			// get payment method
			$payment_query = "SELECT * FROM   oxpayments where OXID=:order_payment_id ";
				
			$data=array(':order_payment_id' => $this->GetFieldNumber($oxid_orders_row,"OXPAYMENTTYPE"));
			
			$payment_res = $db_pdo->prepare($payment_query);
			$payment_res->execute($data);
			foreach ($payment_res as $payment_row) 
			{	
				$this->oxid_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->GetFieldString($payment_row,"OXDESC"));
			}
			
			// get shipping details
			$this->oxid_orders[$counter]->order_info["ShipMethod"]="";
			$shipping_query = "SELECT * FROM   oxdeliveryset where OXID=:order_delivey_id ";
				
			$data=array(':order_delivey_id' => $this->GetFieldNumber($oxid_orders_row,"OXDELTYPE"));
			
			$shipping_res = $db_pdo->prepare($shipping_query);
			$shipping_res->execute($data);
			foreach ($shipping_res as $shipping_row) 
			{
				$this->oxid_orders[$counter]->order_info["ShipMethod"]=$this->GetFieldString($shipping_row,"OXTITLE");
			}
			$this->oxid_orders[$counter]->order_info["ShippingChargesPaid"]=$this->GetFieldNumber($oxid_orders_row,"OXDELCOST");
			
			
			// Extract tax amount
			$this->oxid_orders[$counter]->order_info["ItemsTax"]=$this->FormatNumber($this->GetFieldNumber($oxid_orders_row,"OXARTVATPRICE1"));
			
			if($this->GetFieldString($oxid_orders_row,"OXPAID")!="0000-00-00 00:00:00")
				$this->oxid_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->oxid_orders[$counter]->order_info["PaymentStatus"]=0;
			
			// Show Order status	
			if($this->GetFieldString($oxid_orders_row,"OXSENDDATE")!="0000-00-00 00:00:00")
				$this->oxid_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->oxid_orders[$counter]->order_info["IsShipped"]=0;
			
			$this->oxid_orders[$counter]->order_info["IsCancelled"]=0;
			if($this->GetFieldString($oxid_orders_row,"OXSTORNO")==1)
			$this->oxid_orders[$counter]->order_info["IsCancelled"]=1;
			
			// Pass Currency
			$this->oxid_orders[$counter]->order_info["Currency"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXCURRENCY"));
				
			// Get Customer Comments
			$this->oxid_orders[$counter]->order_info["Comments"]=utf8_encode($this->GetFieldString($oxid_orders_row,"OXREMARK"));
			
			// Get order products
			$items_cost=0;
				
			$order_details_query = "SELECT * FROM   oxorderarticles where OXORDERID=:order_db_id ";
				
			$data=array(':order_db_id' => $this->oxid_orders[$counter]->orderid);
			
			$order_details_res = $db_pdo->prepare($order_details_query);
			$order_details_res->execute($data);

			$i=0;
			$dim_unit="";
			
			foreach ($order_details_res as $product_row) 
			{
				$variant="";
				if($this->GetFieldString($product_row,"OXSELVARIANT")!="")
				$variant="(".utf8_encode($this->GetFieldString($product_row,"OXSELVARIANT")).")";
				
				$this->oxid_orders[$counter]->order_product[$i]["Name"]=utf8_encode($this->GetFieldString($product_row,"OXTITLE"))." ".$variant;
				$unit_price=$this->FormatNumber($this->GetFieldNumber($product_row,"OXNPRICE"));
				$this->oxid_orders[$counter]->order_product[$i]["Price"]=$unit_price;
				$this->oxid_orders[$counter]->order_product[$i]["ExternalID"]=$this->GetFieldString($product_row,"OXARTNUM");
				$this->oxid_orders[$counter]->order_product[$i]["Quantity"]=$this->GetFieldNumber($product_row,"OXAMOUNT");
				
				$this->oxid_orders[$counter]->order_product[$i]["Total"]=$this->FormatNumber($unit_price*$this->GetFieldNumber($product_row,"OXAMOUNT"));
				
				$items_cost=$items_cost+$this->oxid_orders[$counter]->order_product[$i]["Total"];
				
				
				$this->oxid_orders[$counter]->order_product[$i]["IndividualProductWeight"]=number_format($this->GetFieldNumber($product_row,"OXWEIGHT")*$this->GetFieldNumber($product_row,"OXAMOUNT"),2,'.','');
				
				$product_weight_unit=$aLang["ARTICLE_EXTEND_WEIGHT_UNIT"];
				$total_weight_with_unit=$this->ConvertToAcceptedUnitWeight(($this->GetFieldNumber($product_row,"OXWEIGHT")*$this->GetFieldNumber($product_row,"OXAMOUNT")),strtolower($product_weight_unit));
				$total_weight_with_unit=explode("~",$total_weight_with_unit);
									
				$this->oxid_orders[$counter]->order_product[$i]["Total_Product_Weight"]=0;
				if(is_numeric($total_weight_with_unit[0]))
				{
					$this->oxid_orders[$counter]->order_product[$i]["Total_Product_Weight"]=number_format($total_weight_with_unit[0],2,'.','');					
					$uom_weight=$total_weight_with_unit[1];
				}
				
				$width=$this->GetFieldNumber($product_row,"OXWIDTH");
				$height=$this->GetFieldNumber($product_row,"OXHEIGHT");
				$length=$this->GetFieldNumber($product_row,"OXLENGTH");
				
				$dim_unit=convert_dim_unit($aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]);			
				if($length>0)
				{
					if(isset($aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]))	
					$length=convert_dim_value($length,$aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]);
					
					$this->oxid_orders[$counter]->order_product[$i]['ItemLength']=number_format($length,2,'.','');
					if($this->oxid_orders[$counter]->order_info['PkgLength']=="")
					$this->oxid_orders[$counter]->order_info['PkgLength']=number_format($length,2,'.','');
				}
				if($width>0)
				{
					if(isset($aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]))	
					$width=convert_dim_value($width,$aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]);
		
					$this->oxid_orders[$counter]->order_product[$i]['ItemWidth']=number_format($width,2,'.','');						
					if($this->oxid_orders[$counter]->order_info['PkgWidth']=="")
					$this->oxid_orders[$counter]->order_info['PkgWidth']=number_format($width,2,'.','');	
				}
				if($height>0)
				{
					if(isset($aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]))	
					$height=convert_dim_value($height,$aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]);
					
					$this->oxid_orders[$counter]->order_product[$i]['ItemHeight']=number_format($height,2,'.','');
					if($this->oxid_orders[$counter]->order_info['PkgHeight']=="")
					$this->oxid_orders[$counter]->order_info['PkgHeight']=number_format($height,2,'.','');	
				}
				
				$this->oxid_orders[$counter]->order_product[$i]['WeightUOM']=$uom_weight;
				$i++;
			}
			
			$this->oxid_orders[$counter]->num_of_products=$i;
			
			$this->oxid_orders[$counter]->order_info["ExternalID"]=$this->oxid_orders[$counter]->orderid;
			
			$this->oxid_orders[$counter]->order_info["ItemsTotal"]=$this->FormatNumber($this->GetFieldNumber($oxid_orders_row,"OXTOTALNETSUM"));
			
			$this->oxid_orders[$counter]->order_info["Total"]=$this->FormatNumber($this->GetFieldNumber($oxid_orders_row,"OXTOTALORDERSUM"));
			
			$this->oxid_orders[$counter]->order_info["UnitsOfMeasureWeight"]=$uom_weight;
			
			if($dim_unit!="")
			$this->oxid_orders[$counter]->order_info["UnitsOfMeasureLinear"]=$dim_unit;
			
			$counter++;
		}	
		
		
	}
	############################################## Function RetrieveCatalogCount #################################
	// Get catalog count
	#######################################################################################################
	function RetrieveCatalogCount()
	{
		global $db_pdo;
		
		$sql = "SELECT * FROM `oxarticles` where 1";
			
		$result = $db_pdo->prepare($sql);
		$result->execute();
	
		return  $result->rowCount();
	}
	############################################## Function Fetch_DB_Catalog #################################
	// Fetch catalog
	##########################################################################################################
	function Fetch_DB_Catalog($limit,$offset)
	{
		global $db_pdo, $aLang, $aTheme, $oxConfig ;
	
		$page=($offset/$limit)+1;
		
		$sql = "SELECT * FROM `oxarticles` limit $offset,$limit";
		$catalog_data = $db_pdo->prepare($sql);
		$catalog_data->execute();
		
		//Extract Path 
		$folder_path=$_SERVER['SCRIPT_NAME'];
		$folder_path_temp=explode("/",$folder_path);
		$actual_file_name=$folder_path_temp[count($folder_path_temp)-1]; 
		
		$isHttps = false;
		if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
			$isHttps = true;
		}
		elseif (!empty($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https' || !empty($_SERVER['HTTP_X_FORWARDED_SSL']) && $_SERVER['HTTP_X_FORWARDED_SSL'] == 'on') {
			$isHttps = true;
		}
		$SITE_PROTOCOL = $isHttps ? 'https' : 'http';
		
		$folder_path=$SITE_PROTOCOL."://".$_SERVER['HTTP_HOST'].str_replace($actual_file_name,"",$folder_path);
		
		$store_currency=$oxConfig->getActShopCurrencyObject()->name;
		
		$counter=0; 
		foreach ($catalog_data as $catalog) 
		{
			$this->oxid_commodities[$counter]->catalog_commodity["Currency"]=$store_currency;
			$this->oxid_commodities[$counter]->catalog_commodity["Price"]=$this->FormatNumber($this->GetFieldNumber($catalog,"OXPRICE"));
			$this->oxid_commodities[$counter]->catalog_commodity["CountryOfOrigin"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["UnitsOfMeasureLinear"]=convert_dim_unit($aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"]);
			
			$product_weight_unit=$aLang["ARTICLE_EXTEND_WEIGHT_UNIT"];
			$product_weight_with_unit=$this->ConvertToAcceptedUnitWeight($this->GetFieldNumber($catalog,"OXWEIGHT"),strtolower($product_weight_unit));
			$product_weight_with_unit=explode("~",$product_weight_with_unit);
			
			$this->oxid_commodities[$counter]->catalog_commodity["Weight"]=0;
			$uom_weight="";
			if(is_numeric($product_weight_with_unit[0]))
			{
				$this->oxid_commodities[$counter]->catalog_commodity["Weight"]=number_format($product_weight_with_unit[0],2,'.','');					
				$uom_weight=$product_weight_with_unit[1];
			}
			$this->oxid_commodities[$counter]->catalog_commodity["UnitsOfMeasureWeight"]=$uom_weight;
			
			$this->oxid_commodities[$counter]->catalog_commodity["Quantity"]=0;
			$this->oxid_commodities[$counter]->catalog_commodity["ManagedByWebStore"]=0;
			if($this->GetFieldNumber($catalog,"OXVARCOUNT")==0) // not parent item
			{
				$this->oxid_commodities[$counter]->catalog_commodity["Quantity"]=$this->GetFieldNumber($catalog,"OXSTOCK");
				$this->oxid_commodities[$counter]->catalog_commodity["ManagedByWebStore"]=1;
			}
			$this->oxid_commodities[$counter]->catalog_commodity["Volume"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["LengthPackaged"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["WidthPackaged"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["HeightPackaged"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["WeightPackaged"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["RowIndex"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["SKU"]=utf8_encode($this->GetFieldString($catalog,"OXARTNUM"));
			$this->oxid_commodities[$counter]->catalog_commodity["MPN"]=utf8_encode($this->GetFieldString($catalog,"OXMPN"));
			$this->oxid_commodities[$counter]->catalog_commodity["Name"]=utf8_encode($this->GetFieldString($catalog,"OXTITLE"));
			$this->oxid_commodities[$counter]->catalog_commodity["Description"]=utf8_encode($this->GetFieldString($catalog,"OXSHORTDESC"));
			$this->oxid_commodities[$counter]->catalog_commodity["ExternalID"]=$this->GetFieldString($catalog,"OXID");
			
			$this->oxid_commodities[$counter]->catalog_commodity["URL"]="";
			$sql_seo = "SELECT * FROM `oxseo` where OXOBJECTID=:article_id";
			$data_seo=array(':article_id' => $this->GetFieldString($catalog,"OXID"));
			$result_seo = $db_pdo->prepare($sql_seo);
			$result_seo->execute($data_seo);
			
			foreach($result_seo as $result_seo_row)
			$this->oxid_commodities[$counter]->catalog_commodity["URL"]=$folder_path.utf8_encode($this->GetFieldString($result_seo_row,"OXSEOURL"));
			
			$this->oxid_commodities[$counter]->catalog_commodity["UPC"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["VolumePackaged"]="";
			$this->oxid_commodities[$counter]->catalog_commodity["Condition"]="";
			
			$manufacturer_id=$this->GetFieldString($catalog,"OXMANUFACTURERID");
			$this->oxid_commodities[$counter]->catalog_commodity["Manufacturer"]="";
			if($manufacturer_id!="")
			{
				$sql_manufacturer = "SELECT * FROM `oxmanufacturers` where OXID=:manufacturer_id";
				$data_manufacturer=array(':manufacturer_id' => $manufacturer_id);
				$result_manufacturer = $db_pdo->prepare($sql_manufacturer);
				$result_manufacturer->execute($data_manufacturer);
				
				foreach($result_manufacturer as $result_manufacturer_row)
				$this->oxid_commodities[$counter]->catalog_commodity["Manufacturer"]=utf8_encode($this->GetFieldString($result_manufacturer_row,"OXTITLE")); 
			
			
			}
			// Get folder name of product images
			$selected_folder_name=get_product_folder("out/pictures/generated/product/1/");

			$this->oxid_commodities[$counter]->catalog_commodity["ImageURL"]=$folder_path."out/pictures/generated/product/1/".$selected_folder_name."/".utf8_encode($this->GetFieldString($catalog,"OXPIC1")); 
			
			// Get Variation details
			$product_variation_query = "SELECT * FROM   oxobject2attribute oa, oxattribute o where oa.OXOBJECTID=:article_id and  oa.OXATTRID=o.OXID";
			
			$data=array(':article_id' => $this->GetFieldString($catalog,"OXID"));
			
			$product_variation_res = $db_pdo->prepare($product_variation_query);
			$product_variation_res->execute($data);

			$variants="";
			$parent_id=$this->GetFieldString($catalog,"OXPARENTID");
			$article_dim_unit=$aLang["ARTICLE_EXTEND_DIMENSIONS_UNIT"];
			if($parent_id=="")
			{
				$this->oxid_commodities[$counter]->catalog_commodity["Length"]=convert_dim_value($this->GetFieldNumber($catalog,"OXLENGTH"),$article_dim_unit);	
				$this->oxid_commodities[$counter]->catalog_commodity["Width"]=convert_dim_value($this->GetFieldNumber($catalog,"OXWIDTH"),$article_dim_unit);	
				$this->oxid_commodities[$counter]->catalog_commodity["Height"]=convert_dim_value($this->GetFieldNumber($catalog,"OXHEIGHT"),$article_dim_unit);
			}
			else
			{
				$product_att_query = "SELECT * FROM   oxarticles where OXID=:parent_id";
				$data=array(':parent_id' => $parent_id);
				
				$product_att_res = $db_pdo->prepare($product_att_query);
				$product_att_res->execute($data);
	
				foreach ($product_att_res as $product_att_row) 
				{
					$this->oxid_commodities[$counter]->catalog_commodity["Length"]=convert_dim_value($this->GetFieldNumber($product_att_row,"OXLENGTH"),$article_dim_unit);	
				    $this->oxid_commodities[$counter]->catalog_commodity["Width"]=convert_dim_value($this->GetFieldNumber($product_att_row,"OXWIDTH"),$article_dim_unit);	
				    $this->oxid_commodities[$counter]->catalog_commodity["Height"]=convert_dim_value($this->GetFieldNumber($product_att_row,"OXHEIGHT"),$article_dim_unit);
					
				}
				
				if($this->oxid_commodities[$counter]->catalog_commodity["Name"]=="")
				$this->oxid_commodities[$counter]->catalog_commodity["Name"]=utf8_encode($this->GetFieldString($product_att_row,"OXTITLE"));
				
				if($this->oxid_commodities[$counter]->catalog_commodity["URL"]=="") // Consider parent product url
				{
					$sql_att = "SELECT * FROM `oxseo` where OXOBJECTID=:parent_id";
					$data_att=array(':parent_id' => $parent_id);
					$result_att = $db_pdo->prepare($sql_att);
					$result_att->execute($data_att);
					
					foreach($result_att as $row_att)
					$this->oxid_commodities[$counter]->catalog_commodity["URL"]=$folder_path.utf8_encode($this->GetFieldString($row_att,"OXSEOURL"));
					
				}
					
			}
			
	
			foreach ($product_variation_res as $product_variation_row) 
			{
				if($variants!="") $variants.=",";
				
				$att_val="";
				$att_label="";
				if($this->GetFieldString($product_variation_row,"OXVALUE_1")!="")
				$att_val=utf8_encode($this->GetFieldString($product_variation_row,"OXVALUE_1"));
				else
				$att_val=utf8_encode($this->GetFieldString($product_variation_row,"OXVALUE"));
				
				if($this->GetFieldString($product_variation_row,"OXTITLE_1")!="")
				$att_label=utf8_encode($this->GetFieldString($product_variation_row,"OXTITLE_1"));
				else
				$att_label=utf8_encode($this->GetFieldString($product_variation_row,"OXTITLE"));
				
				if($att_label!="" && $att_val!="")
				$variants.=$att_label.":".$att_val;
			}
		
			if($parent_id!="" && $variants=="")
			{
				if($this->GetFieldString($product_att_row,"OXVARNAME_1")!="")
				$variants.=get_attributes($variants,utf8_encode($this->GetFieldString($product_att_row,"OXVARNAME_1")),utf8_encode($this->GetFieldString($catalog,"OXVARSELECT_1")));
				
				if($this->GetFieldString($product_att_row,"OXVARNAME_2")!="")
				$variants.=get_attributes($variants,utf8_encode($this->GetFieldString($product_att_row,"OXVARNAME_2")),utf8_encode($this->GetFieldString($catalog,"OXVARSELECT_2")));
				
				if($this->GetFieldString($product_att_row,"OXVARNAME_3")!="")
				$variants.=get_attributes($variants,utf8_encode($this->GetFieldString($product_att_row,"OXVARNAME_2")),utf8_encode($this->GetFieldString($catalog,"OXVARSELECT_3")));
				
			}
			
			$this->oxid_commodities[$counter]->catalog_commodity["ParentPBCommodityId"]=$parent_id;
			$this->oxid_commodities[$counter]->catalog_commodity["VariationsNameValues"]=$variants;
			
			$counter++;
			
		}
	}
	############################################### Function UpdateCatalog #################################
	// Update catalog
	#######################################################################################################
	function UpdateCatalog($ExternalID ,$Quantity )
	{
		global $db_pdo;
		
		$sql = "SELECT * FROM oxarticles WHERE OXID=:externalId";
		$data=array(':externalId' => $ExternalID);
		
		$result = $db_pdo->prepare($sql);
		$result->execute($data);
		// check if commodity id is valid
		
		if($result->rowCount()>0)
		{
			$sql_upd="update oxarticles set OXSTOCK=:quantity where OXID=:externalId";														
			$data_upd=array( ':quantity' => $Quantity,':externalId' => $ExternalID);
				
			$result_upd = $db_pdo->prepare($sql_upd);
			$result_upd->execute($data_upd);
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));			
		   
		}
		else
		{
			//display error message
			$this->display_msg=INVAID_COMMODITY_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		}
	  
	}
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	// Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->oxid_orders))
				return $this->oxid_orders;
			else
							return array();  
			
	}
	 ################################################## Function GetCatalog() #############################
	   // Get catalog based on paging
	  #######################################################################################################
	  function GetCatalog()
	  {
			$this->Fetch_DB_Catalog($this->Limit,$this->Offset);
			
			if (isset($this->oxid_commodities))
				return $this->oxid_commodities;
			else
				return array();  
	}
	################################################ Function PrepareOrderStatusString #######################
	// Prepare order status string based on settings
	#######################################################################################################
	function PrepareOxidOrderStatusFilter()
	{
			
			$order_status_filter="";
			
			if(OXID_RETRIEVE_ORDER_STATUS_1_NEW==1)//considers new orders
			{
				$order_status_filter="  OXFOLDER='ORDERFOLDER_NEW'";
			
			}
			if(OXID_RETRIEVE_ORDER_STATUS_2_FINISHED==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" OXFOLDER='ORDERFOLDER_FINISHED'";
				}
				else
				{
					$order_status_filter.=" OR OXFOLDER='ORDERFOLDER_FINISHED'";
				}
			
			}
			if(OXID_RETRIEVE_ORDER_STATUS_3_PROBLEMS==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" OXFOLDER='ORDERFOLDER_PROBLEMS'";
				}
				else
				{
					$order_status_filter.=" OR OXFOLDER='ORDERFOLDER_PROBLEMS'";
				}
			
			}
						
			if($order_status_filter!="")
			$order_status_filter="( ".$order_status_filter." ) and";
			
			
			return $order_status_filter;
			
	}
		
	
}


######################################### End of class ShippingZOxid ###################################################

	// create object & perform tasks based on command

	$obj_shipping_oxid=new ShippingZOxid;
	$obj_shipping_oxid->ExecuteCommand();

?>
