<?php

define("SHIPPINGZSHOPP_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// Last mod to this file: $Change$

// Function for checking Include Files
function Check_Include_File($filename)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		echo "\"$filename\" is not accessible.";
		exit;
	}

}

// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");
// Check Request method, script ONLY executes if the desired http verbs are used
if($_SERVER['REQUEST_METHOD']!="GET" && $_SERVER['REQUEST_METHOD']!="POST")
exit;


// TEST that all the files are same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZSHOPP_VERSION && SHIPPINGZSHOPP_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZShopp.php [".SHIPPINGZSHOPP_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");

// include required wp file
if(Check_Include_File("wp-load.php"))
include("wp-load.php");

// Check Permalink structure
$port_number="";
$updated_host="";
if(strpos(DB_HOST, ':') !== false) {
  $split_host=explode(":",DB_HOST);
  $updated_host=$split_host[0];
  $port_number=$split_host[1];
} 

if($port_number!="")
$db_pdo=new PDO("mysql:host=".$updated_host.";port=".$port_number.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);
else
$db_pdo=new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);

global $wpdb;
											
################################################ Function convert_dim_unit #######################
// converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_unit=strtoupper($from_unit);
	}
	else 
	{
	
		$converted_unit="Unknown";
	}
	
	return $converted_unit;
}


############################################## Class ShippingZShopp ######################################
class ShippingZShopp extends ShippingZGenericShoppingCart
{
			
		// cart specific functions goes here
		############################################## Function Check_DB_Access #################################
		// Check Database access
		#######################################################################################################
		function Check_DB_Access()
		{
			global $db_pdo,$wpdb;
			
			include_once( ABSPATH . 'wp-admin/includes/plugin.php' );

			// check for plugin using plugin name
			if ( is_plugin_active( 'shopp/Shopp.php' ) ) 
			{
						  			
				$sql= "Select ID from ".$wpdb->prefix."posts where post_type='shopp_product' order by ID limit 0,1";	
							
				$order_status = $db_pdo->prepare($sql);										
				$order_status->execute();
				
				if ($order_status->rowCount()) 
				{
					$this->display_msg=DB_SUCCESS_MSG;
					
				}
				else
				{
					$this->display_msg=$this->display_msg='Error occurred:'.implode(":",$order_status->errorInfo());
				}
			
			 
			} 
			else
			$this->display_msg="Shopp plugin is not activated";					
						
			
		}
		
		############################################## Function GetOrderCountByDate #################################
		//Get order count
		#######################################################################################################
		function GetOrderCountByDate($datefrom,$dateto)
		{
			
			global $db_pdo,$wpdb;
					
			// Get order count based on data range
			$order_status_filter=$this->PrepareShoppOrderStatusFilter();
			$sql = "SELECT DISTINCT " . $wpdb->prefix . "shopp_purchase.id AS orders FROM " . $wpdb->prefix . "shopp_purchase where  " . $order_status_filter."  DATE_FORMAT(" . $wpdb->prefix . "shopp_purchase.modified, '%Y-%m-%d %T') >= :datefrom  AND DATE_FORMAT(" . $wpdb->prefix . "shopp_purchase.modified, '%Y-%m-%d %T') <= :dateto";
							
			$orders = $db_pdo->prepare($sql);
			
			$data=array(':datefrom' => $this->ConvertDateToDbFormat($datefrom) , ':dateto' => $this->ConvertDateToDbFormat($dateto));
			
			$orders->execute($data);
			
			return $orders->rowCount();
		
		}
		############################################## Function UpdateShippingInfo #################################
		// Update order status 
		#######################################################################################################
		function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
		{
			global $db_pdo,$wpdb;
				
			$sql = "SELECT  " . $wpdb->prefix . "shopp_purchase.txnstatus AS order_status FROM " . $wpdb->prefix . "shopp_purchase where  ".$wpdb->prefix . "shopp_purchase.id=:order_id";			
			
			$result = $db_pdo->prepare($sql);
			$result->execute(array(':order_id' => $OrderNumber));
			
			// check if order number is valid
			if($result->rowCount()>0)
			{
			
				if($ShipDate!="")
					$shipped_on=$ShipDate;
				else
					$shipped_on=date("m/d/Y");
					
				if($Carrier!="")
				{
					$original_carrier=$Carrier;
					$Carrier=" via ".$Carrier;
				}
				
				if($Service!="")
				$Service=" [".$Service."]";
				
				$TrackingNumberString="";
				if($TrackingNumber!="")
				$TrackingNumberString=", Tracking number $TrackingNumber";
				
					
				foreach( $result as $order )
				{
					$current_order_status=$order['order_status'];
				}
				
				// prepare $comments & save it
				$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
				
				if(SHOPP_SHIPPED_STATUS_SET_TO_STATUS_6_SHIPPED==1)
				{
								
					$change_order_status="shipped";
				}
				else
				{
					 if(strtolower($current_order_status)=="review")
						$change_order_status="purchase";
					else if(strtolower($current_order_status)=="purchase")
						$change_order_status="invoiced";
					else if(strtolower($current_order_status)=="invoiced")
						$change_order_status="authed";
					else if(strtolower($current_order_status)=="authed")
						$change_order_status="shipped";
					else
					$change_order_status=$current_order_status;
										
				}
				
								
				$obj_upd=new ShoppAdminService();
				$obj_upd->addnote (1, $comments, true);
				
				// update order status				
				$sql = "update  " . $wpdb->prefix . "shopp_purchase set " . $wpdb->prefix . "shopp_purchase.txnstatus='".$change_order_status."'," . $wpdb->prefix . "shopp_purchase.status='1'  where  ".$wpdb->prefix . "shopp_purchase.id=:order_id";			
			
			    $result = $db_pdo->prepare($sql);
			    $result->execute(array(':order_id' => $OrderNumber));				
				
				$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
			}
			else
			{
				// display error message
				$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
				$this->SetXmlError(1,$this->display_msg);
			
			} 	
			
		}
		############################################## Function Fetch_DB_Orders #################################
		//Perform Database query & fetch orders based on date range
		#######################################################################################################
		
		function Fetch_DB_Orders($datefrom,$dateto)
		{
			
			global $db_pdo,$wpdb;				
							
			// Get orders based on data range
			$order_status_filter=$this->PrepareShoppOrderStatusFilter();
			
			$sql = "SELECT " . $wpdb->prefix . "shopp_purchase.* FROM " . $wpdb->prefix . "shopp_purchase where  " . $order_status_filter."  DATE_FORMAT(" . $wpdb->prefix . "shopp_purchase.modified, '%Y-%m-%d %T') >= :datefrom  AND DATE_FORMAT(" . $wpdb->prefix . "shopp_purchase.modified, '%Y-%m-%d %T') <= :dateto";
			
			$orders_result = $db_pdo->prepare($sql);
			
			$data=array(':datefrom' => $this->ConvertDateToDbFormat($datefrom) , ':dateto' => $this->ConvertDateToDbFormat($dateto));

			
			$orders_result->execute($data);
			
			$counter=0;
			$product_weight_unit="";
			$uom_weight="";
			$dim_unit="";
			
			// get weight unit
			$sql_weight_unit = "SELECT " . $wpdb->prefix . "shopp_meta.* FROM " . $wpdb->prefix . "shopp_meta where  " . $wpdb->prefix . "shopp_meta.name=:weight_unit and type='setting' and context='shopp'";
			$shopp_order_weight_unit_temp = $db_pdo->prepare($sql_weight_unit);					
			$data=array(':weight_unit' => "weight_unit");					
			$shopp_order_weight_unit_temp->execute($data);
			foreach($shopp_order_weight_unit_temp as $order_weight_unit)
			{
				$product_weight_unit=$order_weight_unit['value'];
			}
			
			foreach( $orders_result as $shopp_order_data )
			{					
					$order_id=$shopp_order_data['id'];
										
					$sql_prod = "SELECT " . $wpdb->prefix . "shopp_purchased.* FROM " . $wpdb->prefix . "shopp_purchased where  " . $wpdb->prefix . "shopp_purchased.purchase=:order_id";							
					$shopp_order_products_temp = $db_pdo->prepare($sql_prod);					
					$data=array(':order_id' => $order_id);					
					$shopp_order_products_temp->execute($data);
																			
					if($shopp_order_products_temp->rowCount()==0)
					continue;					
						
					// prepare order array
					$this->shopp_orders[$counter]=new stdClass();
					$this->shopp_orders[$counter]->orderid=$order_id;
																	
					// billing details
					$this->shopp_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($shopp_order_data,'first_name');
					$this->shopp_orders[$counter]->order_billing["LastName"]=$this->Check_Field($shopp_order_data,'last_name');
					$this->shopp_orders[$counter]->order_billing["Company"]=$this->Check_Field($shopp_order_data,'company');
					$this->shopp_orders[$counter]->order_billing["Address1"]=$this->Check_Field($shopp_order_data,'address');
					$this->shopp_orders[$counter]->order_billing["Address2"]=$this->Check_Field($shopp_order_data,'xaddress');
					$this->shopp_orders[$counter]->order_billing["City"]=$this->Check_Field($shopp_order_data,'city');
					$this->shopp_orders[$counter]->order_billing["State"]=$this->Check_Field($shopp_order_data,'state');
					$this->shopp_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($shopp_order_data,'postcode');
					$this->shopp_orders[$counter]->order_billing["Country"]=$this->Check_Field($shopp_order_data,'country');
					$this->shopp_orders[$counter]->order_billing["Phone"]=$this->Check_Field($shopp_order_data,'phone');
					
					// shipping details
					$this->shopp_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field($shopp_order_data,'shipname');
					$this->shopp_orders[$counter]->order_shipping["LastName"]="";
					$this->shopp_orders[$counter]->order_shipping["Company"]="";
					$this->shopp_orders[$counter]->order_shipping["Address1"]=$this->Check_Field($shopp_order_data,'shipaddress');
					$this->shopp_orders[$counter]->order_shipping["Address2"]=$this->Check_Field($shopp_order_data,'shipxaddress');
					$this->shopp_orders[$counter]->order_shipping["City"]=$this->Check_Field($shopp_order_data,'shipcity');
					$this->shopp_orders[$counter]->order_shipping["State"]=$this->Check_Field($shopp_order_data,'shipstate');
					$this->shopp_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field($shopp_order_data,'shippostcode');
					$this->shopp_orders[$counter]->order_shipping["Country"]=	$this->Check_Field($shopp_order_data,'shipcountry');
					$this->shopp_orders[$counter]->order_shipping["Phone"]=$this->Check_Field($shopp_order_data,'phone');
					$this->shopp_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($shopp_order_data,'email');
						
											
					// order info
					$order_date_actual = new DateTime($this->Check_Field($shopp_order_data,'created'));
					$this->shopp_orders[$counter]->order_info["OrderDate"]= $order_date_actual->format('Y-m-d\TH:i:00\Z');
													
					$this->shopp_orders[$counter]->order_info["Total"]=number_format($this->Check_Field($shopp_order_data,'total'),2,'.','');
					$this->shopp_orders[$counter]->order_info["ItemsTax"]=number_format($this->Check_Field($shopp_order_data,'tax'),2,'.','');
					
					
					$this->shopp_orders[$counter]->order_info["OrderNumber"]=$order_id;
					$this->shopp_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->Check_Field($shopp_order_data,'paymethod'));
					
					$this->shopp_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($this->Check_Field($shopp_order_data,'freight'),2,'.','');
					$this->shopp_orders[$counter]->order_info["ShipMethod"]=$this->Check_Field($shopp_order_data,'shipmethod');
					
					
					$this->shopp_orders[$counter]->order_info["Comments"]="";	
					
					$this->shopp_orders[$counter]->order_info["ExternalID"]=$this->shopp_orders[$counter]->order_info["OrderNumber"] . '-' . $this->shopp_orders[$counter]->order_info["OrderDate"];		
		
					$order_status=$this->Check_Field($shopp_order_data,'txnstatus');
					
					if($order_status!="review" && $order_status!="purchase" && $order_status!="invoiced" && $order_status!="voided" && $order_status!="auth-failed")
						$this->shopp_orders[$counter]->order_info["PaymentStatus"]=2;
					else
						$this->shopp_orders[$counter]->order_info["PaymentStatus"]=0;
					
					// show Order status
					if( $order_status=="shipped" || $order_status=="closed")
						$this->shopp_orders[$counter]->order_info["IsShipped"]=1;
					else
						$this->shopp_orders[$counter]->order_info["IsShipped"]=0;
						
					// show if cancelled
					if($order_status=="voided")
						$this->shopp_orders[$counter]->order_info["IsCancelled"]=1;
					else
						$this->shopp_orders[$counter]->order_info["IsCancelled"]=0;
						
							
					$actual_number_of_products=0;
					
					$this->shopp_orders[$counter]->order_info["ItemsTotal"]=0;		
							
					foreach($shopp_order_products_temp as $shopp_order_products)
					{
					  					
						if($shopp_order_products['name']!="")
						{					
							$addon_string="";
							if($shopp_order_products['addons']=="yes")
							{
								$sql_addon = "SELECT " . $wpdb->prefix . "shopp_meta.* FROM " . $wpdb->prefix . "shopp_meta where  " . $wpdb->prefix ."shopp_meta.type='addon' and " . $wpdb->prefix . "shopp_meta.parent=:parent_id";							
								$shopp_order_addons_temp = $db_pdo->prepare($sql_addon);					
								$data=array(':parent_id' => $shopp_order_products['id']);					
								$shopp_order_addons_temp->execute($data);
								foreach($shopp_order_addons_temp as $order_addons)
								{
									if($addon_string!="")
									$addon_string.=",";
									
									$addon_string.=$order_addons['name'];
								}
								$addon_string=" (".$addon_string.")";
							}	
												
							if($shopp_order_products['optionlabel']!="")
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$shopp_order_products['name']."~".$shopp_order_products['optionlabel'].$addon_string;
							else
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$shopp_order_products['name'].$addon_string;
							
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Price"]=number_format((float)$shopp_order_products['unitprice'],2,'.','');							
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$shopp_order_products['sku'];
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($shopp_order_products['quantity'],2,'.','');
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format((float)$shopp_order_products['total'],2,'.','');							
							$this->shopp_orders[$counter]->order_info["ItemsTotal"]+=$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Total"];
							
							$sql_setting_param = "SELECT " . $wpdb->prefix . "shopp_meta.* FROM " . $wpdb->prefix . "shopp_meta where  " . $wpdb->prefix ."shopp_meta.name='settings' and " . $wpdb->prefix ."shopp_meta.type='meta' and " . $wpdb->prefix ."shopp_meta.context='price' and parent=:product_id";
							
							
							$shopp_product_setting_param_temp = $db_pdo->prepare($sql_setting_param);					
							$data=array(':product_id' => $shopp_order_products['product']);					
							$shopp_product_setting_param_temp->execute($data);
							$product_weight="";
							foreach($shopp_product_setting_param_temp as $product_setting_param)
							{
								$prod_setting_param=unserialize($product_setting_param['value']);
								$product_weight=$prod_setting_param['dimensions']['weight'];
							}
							
							
							$total_weight_with_unit=$this->ConvertToAcceptedUnitWeight(($product_weight*$shopp_order_products['quantity']),strtolower($product_weight_unit));
							$total_weight_with_unit=explode("~",$total_weight_with_unit);
							if($product_weight!="")
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format($product_weight,2,'.','');
							
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=0;
							if(is_numeric($total_weight_with_unit[0]))
							{
								$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format($total_weight_with_unit[0],2,'.','');
								$uom_weight=$total_weight_with_unit[1];
							}
							
							
							
							$this->shopp_orders[$counter]->order_product[$actual_number_of_products]["Notes"]="";
							
							$actual_number_of_products++;						
						}
				  }
				  
									  
				$this->shopp_orders[$counter]->num_of_products=$actual_number_of_products;
				$this->shopp_orders[$counter]->order_info["UnitsOfMeasureWeight"]=$uom_weight;
				$counter++;
			}
		}
		
		################################### Function GetOrdersByDate($datefrom,$dateto) ######################
		//Get orders based on date range
		#######################################################################################################
		function GetOrdersByDate($datefrom,$dateto)
		{
				
				$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
				
	
				if (isset($this->shopp_orders))
					return $this->shopp_orders;
				else
								return array();  
				
		}
		
		############################################## Function Check_Field #################################
		//Check & Return field value if available
		#######################################################################################################
		function Check_Field($arr,$field)
		{
			if(isset($arr[$field]))
			{
				
				return $arr[$field];
							
			}
			else
			{
				return "";
			}
			
		}
		############################################## Function ConvertDateToDbFormat #################################

		//"T" & "Z" remove from UTC format(in ISO 8601) 
		#######################################################################################################
		function ConvertDateToDbFormat($server_date_utc)  
		{
			if(strpos($server_date_utc,"Z"))
			{
				$utc_fotmat_temp=str_replace("Z","",$server_date_utc);
				$server_date_utc=str_replace("T"," ",$utc_fotmat_temp);
			   
			}  
			return $server_date_utc;
		}
		
		################################################ Function PrepareShoppOrderStatusFilter #######################
		//Prepare order status string based on settings
		#######################################################################################################
		function PrepareShoppOrderStatusFilter()
		{
				global $wpdb;
				
				$order_status_filter="";
				
				
				if(SHOPP_RETRIEVE_ORDER_STATUS_1_REVIEW==1)
				{
					$order_status_filter=$wpdb->prefix . "shopp_purchase.txnstatus = 'review'";
				
				}
				if(SHOPP_RETRIEVE_ORDER_STATUS_2_PURCHASE_ORDER==1)
				{
					if($order_status_filter=="")
					{
						$order_status_filter.=$wpdb->prefix ."shopp_purchase.txnstatus = 'purchase'";
					}
					else
					{
						$order_status_filter.=" OR ".$wpdb->prefix ."shopp_purchase.txnstatus = 'purchase'";
					}
				
				}
				if(SHOPP_RETRIEVE_ORDER_STATUS_3_INVOICED==1)
				{
					if($order_status_filter=="")
					{
						$order_status_filter.=$wpdb->prefix . "shopp_purchase.txnstatus = 'invoiced'";
					}
					else
					{
						$order_status_filter.=" OR ".$wpdb->prefix . "shopp_purchase.txnstatus = 'invoiced'";
					}
				
				}
				if(SHOPP_RETRIEVE_ORDER_STATUS_4_AUTHORIZED==1)
				{
					if($order_status_filter=="")
					{
						$order_status_filter.=$wpdb->prefix . "shopp_purchase.txnstatus = 'authed'";
					}
					else
					{
						$order_status_filter.=" OR ".$wpdb->prefix . "shopp_purchase.txnstatus = 'authed'";
					}
				
				}
				if(SHOPP_RETRIEVE_ORDER_STATUS_5_PAID==1)
				{
					if($order_status_filter=="")
					{
						$order_status_filter.=$wpdb->prefix . "shopp_purchase.txnstatus = 'captured'";
					}
					else
					{
						$order_status_filter.=" OR ".$wpdb->prefix . "shopp_purchase.txnstatus = 'captured'";
					}
				
				}
				
				
				if(SHOPP_RETRIEVE_ORDER_STATUS_6_SHIPPED==1 )
				{
					if($order_status_filter=="")
					{
						$order_status_filter.=$wpdb->prefix . "shopp_purchase.txnstatus = 'shipped'";
					}
					else
					{
						$order_status_filter.=" OR ".$wpdb->prefix . "shopp_purchase.txnstatus = 'shipped'";
					}
				}
				if(SHOPP_RETRIEVE_ORDER_STATUS_7_VOIDED==1)
				{
				
					if($order_status_filter=="")
					{
						$order_status_filter.=$wpdb->prefix . "shopp_purchase.txnstatus = 'voided'";
					}
					else
					{
						$order_status_filter.=" OR ".$wpdb->prefix . "shopp_purchase.txnstatus = 'voided'";
					}
				
				}

								
				if($order_status_filter!="")
				$order_status_filter="( ".$order_status_filter." ) and";
				return $order_status_filter;
				
		}
					
			
}
######################################### End of class ShippingZShopp ###################################################

	// create object & perform tasks based on command

	$obj_shipping_shopp=new ShippingZShopp;
	$obj_shipping_shopp->ExecuteCommand();

?>
