<?php
define("SHIPPINGZSHOPWARE_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// Function for checking Include Files
function Check_Include_File($filename)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		echo "\"$filename\" is not accessible.";
		exit;
	}

}

// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");


// TEST all the files are all the same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZSHOPWARE_VERSION && SHIPPINGZSHOPWARE_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZShopware.php [".SHIPPINGZSHOPWARE_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}
################################################ Function convert_dim_unit #######################
//Converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	if($from_unit=="inches")
	$from_unit="in";
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_unit=strtoupper($from_unit);
	}
	else 
	{
	
		$converted_unit="Unknown";
	}
	
	return $converted_unit;
}
#######################################################################################################
############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");

// Check for shopware include files
if(Check_Include_File("config.php"))
$db_params=include("config.php");


if (extension_loaded('pdo') && extension_loaded('pdo_mysql') ) 
{
	
	try
	{
		$db_pdo=new PDO("mysql:host=".$db_params['db']['host'].";dbname=".$db_params['db']['dbname'], $db_params['db']['username'], $db_params['db']['password']);
	}
	catch( Exception $e )
	{
		echo $e->getMessage();
		exit;
	}
	
}
else
{
	echo "The PDO system appears disabled. Please check the php.ini setting and make sure following extensions are enabled.<br>
	extension=pdo.so;<br>
	extension=pdo_mysql.so;<br>
	PDO is required.";
	exit;

}

function check_if_field_exists()
{
	global $db_pdo;
	
	$s_check_query = "SHOW COLUMNS FROM `s_order` LIKE :fieldname";				
	$data=array(':fieldname' => "change");
	
	$s_check_res = $db_pdo->prepare($s_check_query);
	$s_check_res->execute($data);
	
	return $s_check_res->rowCount();
}
############################################## Class ShippingZShopware ##########################################################
class ShippingZShopware extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	############################################## Function Check_DB_Access #################################
	//Check Database access
	#######################################################################################################
	
	function Check_DB_Access()
	{
		global $db_pdo;
		//check if shopware database can be acessed or not
		$sql = "SHOW COLUMNS FROM s_order";
		
		$result = $db_pdo->prepare($sql);
		$result->execute();
		if ($result->rowCount()) 
		{
			$this->display_msg=DB_SUCCESS_MSG;
			
		}
		else
		{
			$this->display_msg=DB_ERROR_MSG;
		}
		
	}
	
	############################################## Function GetOrderCountByDate #################################
	// Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		
		global $db_pdo;
		
		// Get order count based on data range
		$datefrom_timestamp=$this->GetServerTimeLocal(true,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(true,$dateto);
		
		$order_status_filter=$this->PrepareShopwareOrderStatusFilter();
		
		$change_search_str ="";
		if(check_if_field_exists())
		$change_search_str.=" || changed between :datefrom and :dateto";
		
		$sql = "SELECT id FROM s_order where 1 and ".$order_status_filter." (ordertime between :datefrom and :dateto $change_search_str )";
		
		$data=array(':datefrom' => $datefrom_timestamp, ':dateto' =>$dateto_timestamp);
		
		$result = $db_pdo->prepare($sql);
		$result->execute($data);
	
		return  $result->rowCount();
	
	}
	############################################## Function UpdateShippingInfo #################################
	// Update order status
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $db_pdo;
		
		$sql = "SELECT * FROM s_order WHERE ordernumber=:orderid";
		$data=array(':orderid' => $OrderNumber);
		
		$result = $db_pdo->prepare($sql);
		$result->execute($data);
		// check if order number is valid
		
		if($result->rowCount()>0)
		{
			foreach ($result as $row)
		   {
				
				if($ShipDate!="")
					$shipped_on=$ShipDate;
				else
					$shipped_on=date("m/d/Y");
									
				if($Carrier!="")
				{
					$Carrier=" via ".$Carrier;
				}
				
				if($Service!="")
				{
					$Service=" [".$Service."]";
				}
				
				$TrackingNumberString="";
				$tracking_sql="";
				if($TrackingNumber!="")
				{
					$TrackingNumberString=", Tracking number $TrackingNumber";
					$tracking_sql=" ,trackingcode=:tracking";
				}
				
			    $current_order_status=$row['status'];
											
				// prepare $comments (appending existing notes)
				$comments=$row['comment']."---Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;				
								
			}
			
			// update order table
			if(SHOPWARE_SHIPPED_STATUS_SET_TO_STATUS_4_COMPLETED==1)
			{
				$change_order_status='2';
			}
			else
			{
				if($current_order_status=='0' )
					$change_order_status='1';
				else if($current_order_status=='1')
					$change_order_status='2';
				else if($current_order_status=='5')
					$change_order_status='2';
				else
					$change_order_status=$current_order_status;					
				
			}
			
			$sql_upd="update s_order set comment=:comments ".$tracking_sql.",status=:shipping_status_id  where ordernumber=:orderid";
														
			if($TrackingNumber!="")
			{
				
				$data_upd=array(':comments' => $comments, ':orderid' => $OrderNumber,':tracking'=>$TrackingNumber, ':shipping_status_id' => $change_order_status);
			}
			else
			{
				$data_upd=array(':comments' => $comments, ':orderid' => $OrderNumber, ':shipping_status_id' => $change_order_status);
			}
				
			$result_upd = $db_pdo->prepare($sql_upd);
			$result_upd->execute($data_upd);		 
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));			
		   
		}
		else
		{
			//display error message
			$this->display_msg=str_replace("ENTERED_ORDERED_NUMBER","#$OrderNumber",INVAID_ORDER_NUMBER_ERROR_MSG);
			$this->SetXmlError(1,$this->display_msg);
		
		}
	  
	}
	############################################## Function Fetch_DB_Orders #################################
	// Perform Database query & fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		global $db_pdo;
				
		$order_status_filter=$this->PrepareShopwareOrderStatusFilter();
		
		$change_search_str="";
		if(check_if_field_exists()) 
		$change_search_str.=" || changed between :datefrom and :dateto";
		
		$search=$order_status_filter." (ordertime between :datefrom and :dateto $change_search_str)";
		

		$orders_query_raw = "SELECT * FROM s_order where 1 and".$search;
				
		$data=array(':datefrom' => $this->GetServerTimeLocal(true,$datefrom), ':dateto' =>$this->GetServerTimeLocal(true,$dateto));
		
		$shopware_orders_res = $db_pdo->prepare($orders_query_raw);
		$shopware_orders_res->execute($data);
		
		$counter=0;
		foreach ($shopware_orders_res as $shopware_orders_row) 
		{
			
			// prepare order array
			$this->shopware_orders[$counter]=new stdClass();
			$this->shopware_orders[$counter]->orderid=$this->GetFieldNumber($shopware_orders_row,"id");
			
			$this->shopware_orders[$counter]->order_info['PkgLength']="";
			$this->shopware_orders[$counter]->order_info['PkgWidth']="";
			$this->shopware_orders[$counter]->order_info['PkgHeight']="";
			
			// shipping details
			$shipping_address_query = "SELECT * FROM  s_order_shippingaddress where orderID=:order_db_id ";
				
			$data=array(':order_db_id' => $this->shopware_orders[$counter]->orderid);
			
			$shipping_address_res = $db_pdo->prepare($shipping_address_query);
			$shipping_address_res->execute($data);
			
			foreach ($shipping_address_res as $shipping_address_row) 
			{
				$this->shopware_orders[$counter]->order_shipping["FirstName"]=$this->GetFieldString($shipping_address_row,"firstname");
				$this->shopware_orders[$counter]->order_shipping["LastName"]=$this->GetFieldString($shipping_address_row,"lastname");
				$this->shopware_orders[$counter]->order_shipping["Company"]=$this->GetFieldString($shipping_address_row,"company");
				$this->shopware_orders[$counter]->order_shipping["Address1"]=utf8_encode($this->GetFieldString($shipping_address_row,"street"));	
				if($this->GetFieldString($shipping_address_row,"streetnumber")!="")
				{
					$this->shopware_orders[$counter]->order_shipping["Address1"].=", ".utf8_encode($this->GetFieldString($shipping_address_row,"streetnumber"));
				}		
				$this->shopware_orders[$counter]->order_shipping["Address2"]=utf8_encode($this->GetFieldString($shipping_address_row,"additional_address_line1"))." ".utf8_encode($this->GetFieldString($shipping_address_row,"additional_address_line2"));
				$this->shopware_orders[$counter]->order_shipping["City"]=$this->GetFieldString($shipping_address_row,"city");		
				$this->shopware_orders[$counter]->order_shipping["PostalCode"]=$this->GetFieldString($shipping_address_row,"zipcode");			
				$this->shopware_orders[$counter]->order_shipping["Phone"]=$this->GetFieldString($shipping_address_row,"phone");
								
				$this->shopware_orders[$counter]->order_shipping["Country"]="";
				$s_country_query = "SELECT * FROM  s_core_countries where id=:countryID ";
				
				$data=array(':countryID' => $this->GetFieldString($shipping_address_row,"countryID"));
				
				$s_country_res = $db_pdo->prepare($s_country_query);
				$s_country_res->execute($data);
				
				foreach ($s_country_res as $s_country_row) 
				$this->shopware_orders[$counter]->order_shipping["Country"]=$this->GetFieldString($s_country_row,"countryiso");
				
				$this->shopware_orders[$counter]->order_shipping["State"]="";
				
				if($this->GetFieldString($shipping_address_row,"stateID")!="" && $this->GetFieldString($shipping_address_row,"stateID")!="0")
				{
					$s_state_query = "SELECT * FROM  s_core_countries_states where id=:stateID ";
				
					$data=array(':stateID' => $this->GetFieldString($shipping_address_row,"stateID"));
					
					$s_state_res = $db_pdo->prepare($s_state_query);
					$s_state_res->execute($data);
					
					foreach ($s_state_res as $s_state_row) 
					$this->shopware_orders[$counter]->order_shipping["State"]=$this->GetFieldString($s_state_row,"shortcode");
				
				}
				
					
			}
			// billing details
			$billing_address_query = "SELECT * FROM  s_order_billingaddress where orderID=:order_db_id ";
				
			$data=array(':order_db_id' => $this->shopware_orders[$counter]->orderid);
			
			$billing_address_res = $db_pdo->prepare($billing_address_query);
			$billing_address_res->execute($data);
			
			foreach ($billing_address_res as $billing_address_row) 
			{
				$this->shopware_orders[$counter]->order_billing["FirstName"]=$this->GetFieldString($billing_address_row,"firstname");
				$this->shopware_orders[$counter]->order_billing["LastName"]=$this->GetFieldString($billing_address_row,"lastname");
				$this->shopware_orders[$counter]->order_billing["Company"]=$this->GetFieldString($billing_address_row,"company");
				$this->shopware_orders[$counter]->order_billing["Address1"]=utf8_encode($this->GetFieldString($billing_address_row,"street"));		
				if($this->GetFieldString($billing_address_row,"streetnumber")!="")
				{
					$this->shopware_orders[$counter]->order_billing["Address1"].=", ".utf8_encode($this->GetFieldString($billing_address_row,"streetnumber"));
				}
				$this->shopware_orders[$counter]->order_billing["Address2"]=utf8_encode($this->GetFieldString($billing_address_row,"additional_address_line1"))." ".utf8_encode($this->GetFieldString($billing_address_row,"additional_address_line2"));
				$this->shopware_orders[$counter]->order_billing["City"]=$this->GetFieldString($billing_address_row,"city");		
				$this->shopware_orders[$counter]->order_billing["PostalCode"]=$this->GetFieldString($billing_address_row,"zipcode");			
				$this->shopware_orders[$counter]->order_billing["Phone"]=$this->GetFieldString($billing_address_row,"phone");
								
				$this->shopware_orders[$counter]->order_billing["Country"]="";
				$s_country_query = "SELECT * FROM  s_core_countries where id=:countryID ";
				
				$data=array(':countryID' => $this->GetFieldString($billing_address_row,"countryID"));
				
				$s_country_res = $db_pdo->prepare($s_country_query);
				$s_country_res->execute($data);
				
				foreach ($s_country_res as $s_country_row) 
				$this->shopware_orders[$counter]->order_billing["Country"]=$this->GetFieldString($s_country_row,"countryiso");
				
				$this->shopware_orders[$counter]->order_billing["State"]="";
				
				if($this->GetFieldString($billing_address_row,"stateID")!="" && $this->GetFieldString($billing_address_row,"stateID")!="0")
				{
					$s_state_query = "SELECT * FROM  s_core_countries_states where id=:stateID ";
				
					$data=array(':stateID' => $this->GetFieldString($billing_address_row,"stateID"));
					
					$s_state_res = $db_pdo->prepare($s_state_query);
					$s_state_res->execute($data);
					
					foreach ($s_state_res as $s_state_row) 
					$this->shopware_orders[$counter]->order_billing["State"]=$this->GetFieldString($s_state_row,"shortcode");
				
				}
				
					
			}
			// get user details
			$order_user_id=$this->GetFieldNumber($shopware_orders_row,"userID");
			$user_query = "SELECT * FROM   s_user where id=:order_user_id ";
				
			$data=array(':order_user_id' => $order_user_id);
			
			$user_res = $db_pdo->prepare($user_query);
			$user_res->execute($data);
			
			$this->shopware_orders[$counter]->order_shipping["EMail"]="";
			$this->shopware_orders[$counter]->order_billing["EMail"]="";
			foreach ($user_res as $user_row) 
			{
				$this->shopware_orders[$counter]->order_shipping["EMail"]=$this->GetFieldString($user_row,"email");
				$this->shopware_orders[$counter]->order_billing["EMail"]=$this->GetFieldString($user_row,"email");
			}
			
			// order info
			$this->shopware_orders[$counter]->order_info["OrderDate"]=$this->ConvertServerTimeToUTC(true,strtotime($this->GetFieldString($shopware_orders_row,"ordertime")));
			$this->shopware_orders[$counter]->order_info["OrderNumber"]=$this->GetFieldNumber($shopware_orders_row,"ordernumber");
			$this->shopware_orders[$counter]->order_info["ExternalID"]=$this->GetFieldNumber($shopware_orders_row,"ordernumber")."-".$this->GetFieldNumber($shopware_orders_row,"id");
			
			// get payment method
			$payment_query = "SELECT * FROM   s_core_paymentmeans where id=:order_payment_id ";
				
			$data=array(':order_payment_id' => $this->GetFieldNumber($shopware_orders_row,"paymentID"));
			
			$payment_res = $db_pdo->prepare($payment_query);
			$payment_res->execute($data);
			foreach ($payment_res as $payment_row) 
			{	
				$this->shopware_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->GetFieldString($payment_row,"name"));
			}
			
			// get shipping details
			$this->shopware_orders[$counter]->order_info["ShipMethod"]="";
			$shipping_query = "SELECT * FROM   s_premium_dispatch where id=:order_dispatch_id ";
				
			$data=array(':order_dispatch_id' => $this->GetFieldNumber($shopware_orders_row,"dispatch_id"));
			
			$shipping_res = $db_pdo->prepare($shipping_query);
			$shipping_res->execute($data);
			foreach ($shipping_res as $shipping_row) 
			{
				$this->shopware_orders[$counter]->order_info["ShipMethod"]=$this->GetFieldString($shipping_row,"name");
			}
			$this->shopware_orders[$counter]->order_info["ShippingChargesPaid"]=$this->GetFieldNumber($shopware_orders_row,"invoice_shipping");
					
			// Extract tax amount
			$this->shopware_orders[$counter]->order_info["ItemsTax"]=$this->FormatNumber(($this->GetFieldNumber($shopware_orders_row,"invoice_amount")-$this->GetFieldNumber($shopware_orders_row,"invoice_amount_net")),2);
			
			if($this->GetFieldString($shopware_orders_row,"status")!="-1" && $this->GetFieldString($shopware_orders_row,"status")!="0")
				$this->shopware_orders[$counter]->order_info["PaymentStatus"]=2;
			else
				$this->shopware_orders[$counter]->order_info["PaymentStatus"]=0;
			
			// Show Order status	
			if($this->GetFieldString($shopware_orders_row,"status")=="2")
				$this->shopware_orders[$counter]->order_info["IsShipped"]=1;
			else
				$this->shopware_orders[$counter]->order_info["IsShipped"]=0;
			
			
			if($this->GetFieldString($shopware_orders_row,"status")=="4")
				$this->shopware_orders[$counter]->order_info["IsCancelled"]=1;
			else
				$this->shopware_orders[$counter]->order_info["IsCancelled"]=0;
				
			// Get Customer Comments
			$this->shopware_orders[$counter]->order_info["Comments"]=$this->GetFieldString($shopware_orders_row,"comment");
			
			// Get order products
			$items_cost=0;
				
			$order_details_query = "SELECT * FROM   s_order_details where orderID=:order_db_id ";
				
			$data=array(':order_db_id' => $this->shopware_orders[$counter]->orderid);
			
			$order_details_res = $db_pdo->prepare($order_details_query);
			$order_details_res->execute($data);

			$i=0;
			
			foreach ($order_details_res as $product_row) 
			{
				
				$this->shopware_orders[$counter]->order_product[$i]["Name"]=$this->GetFieldString($product_row,"name");
				$unit_price=$this->GetFieldNumber($product_row,"price");
				$this->shopware_orders[$counter]->order_product[$i]["Price"]=$unit_price;
				$this->shopware_orders[$counter]->order_product[$i]["ExternalID"]=$this->GetFieldString($product_row,"articleordernumber");
				$this->shopware_orders[$counter]->order_product[$i]["Quantity"]=$this->GetFieldNumber($product_row,"quantity");
				
				$this->shopware_orders[$counter]->order_product[$i]["Total"]=$this->FormatNumber($unit_price*$this->GetFieldNumber($product_row,"quantity"));
				
				$items_cost=$items_cost+$this->shopware_orders[$counter]->order_product[$i]["Total"];
				
				$additional_details_query = "SELECT * FROM   s_articles_details where articleID=:articleID ";
				
				$data=array(':articleID' => $this->GetFieldNumber($product_row,"articleID"));
				
				$additional_details_res = $db_pdo->prepare($additional_details_query);
				$additional_details_res->execute($data);	
				$uom_weight="";
				foreach ($additional_details_res as $additional_details_row) 
				{  
					$this->shopware_orders[$counter]->order_product[$i]["IndividualProductWeight"]=0;
					
					if($this->GetFieldNumber($additional_details_row,"weight")!="")
					$this->shopware_orders[$counter]->order_product[$i]["IndividualProductWeight"]=number_format($this->GetFieldNumber($additional_details_row,"weight")*$this->GetFieldNumber($product_row,"quantity"),2,'.','');
					
					$product_weight_unit="kg";
					$total_weight_with_unit=$this->ConvertToAcceptedUnitWeight(($this->GetFieldNumber($additional_details_row,"weight")*$this->GetFieldNumber($product_row,"quantity")),strtolower($product_weight_unit));
					$total_weight_with_unit=explode("~",$total_weight_with_unit);
										
					$this->shopware_orders[$counter]->order_product[$i]["Total_Product_Weight"]=0;
					if(is_numeric($total_weight_with_unit[0]))
					{
						$this->shopware_orders[$counter]->order_product[$i]["Total_Product_Weight"]=number_format($total_weight_with_unit[0],2,'.','');					
						$uom_weight=$total_weight_with_unit[1];
					}
					
					$width=$this->GetFieldNumber($additional_details_row,"width");
					$height=$this->GetFieldNumber($additional_details_row,"height");
					$length=$this->GetFieldNumber($additional_details_row,"length");
					
									
					if($length>0)
					{
												  
						$this->shopware_orders[$counter]->order_product[$i]['ItemLength']=number_format($length,2,'.','');
						if($this->shopware_orders[$counter]->order_info['PkgLength']=="")
						$this->shopware_orders[$counter]->order_info['PkgLength']=number_format($length,2,'.','');
					}
					if($width>0)
					{
						$this->shopware_orders[$counter]->order_product[$i]['ItemWidth']=number_format($width,2,'.','');						
						if($this->shopware_orders[$counter]->order_info['PkgWidth']=="")
						$this->shopware_orders[$counter]->order_info['PkgWidth']=number_format($width,2,'.','');	
					}
					if($height>0)
					{
						$this->shopware_orders[$counter]->order_product[$i]['ItemHeight']=number_format($height,2,'.','');
						if($this->shopware_orders[$counter]->order_info['PkgHeight']=="")
						$this->shopware_orders[$counter]->order_info['PkgHeight']=number_format($height,2,'.','');	
					}
				}
								
				$i++;
			}
			
			$this->shopware_orders[$counter]->num_of_products=$i;
			
			$this->shopware_orders[$counter]->order_info["ItemsTotal"]=$this->FormatNumber($items_cost,2);
			
			$this->shopware_orders[$counter]->order_info["Total"]=$this->FormatNumber($this->GetFieldNumber($shopware_orders_row,"invoice_amount"));
			
			$this->shopware_orders[$counter]->order_info["UnitsOfMeasureWeight"]=$uom_weight;
			
			
			$counter++;
		}	
		
		
	}
	############################################## Function Fetch_DB_Catalog #################################
	// Perform Database query & fetch catalog
	#######################################################################################################
	
	function Fetch_DB_Catalog($limit,$offset)
	{
		global $db_pdo;
		
		$catalog_query = "SELECT *, sd.id as detail_id,a.id as article_id FROM s_articles_details sd, s_articles a where sd.articleID=a.id order by sd.articleID asc limit $offset,$limit";		
		$shopware_catalog_res = $db_pdo->prepare($catalog_query);
		$shopware_catalog_res->execute();			
		$counter=0; 
		
		//Extract Path 
		$folder_path=$_SERVER['SCRIPT_NAME'];
		$folder_path_temp=explode("/",$folder_path);
		$actual_file_name=$folder_path_temp[count($folder_path_temp)-1]; 
		
		$isHttps = false;
		if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
			$isHttps = true;
		}
		elseif (!empty($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https' || !empty($_SERVER['HTTP_X_FORWARDED_SSL']) && $_SERVER['HTTP_X_FORWARDED_SSL'] == 'on') {
			$isHttps = true;
		}
		$SITE_PROTOCOL = $isHttps ? 'https' : 'http';
		
		$folder_path=$SITE_PROTOCOL."://".$_SERVER['HTTP_HOST'].str_replace($actual_file_name,"",$folder_path);
		$existing_ParentPBCommodityId="";
					
		foreach ($shopware_catalog_res as $shopware_catalog_row) 
		{
			// prepare catalog array
			$this->shopware_commodities[$counter]=new stdClass();
			
			$additional_options_query = "SELECT sg.name as atrribute_name, so.name as option_value FROM    s_article_configurator_option_relations sor,  s_article_configurator_groups sg,  s_article_configurator_options so where sor.article_id=:detail_id and sor.option_id=so.id and so.group_id=sg.id";
								
			$data=array(':detail_id' => $this->GetFieldNumber($shopware_catalog_row,"detail_id"));
			
			
			$additional_options_res = $db_pdo->prepare($additional_options_query);
			$additional_options_res->execute($data);
			$variants="";
			foreach ($additional_options_res as $additional_options_row) 
			{ 
				if($variants!="")
				$variants.=","; 
				 
				$variants.=$this->GetFieldString($additional_options_row,"atrribute_name").":".$this->GetFieldString($additional_options_row,"option_value");
			}
					
			$additional_details_query = "SELECT * FROM   s_articles_details sad, s_articles_prices sap where sad.id=:detail_id  and sad.id=sap.articledetailsID";
			
			$data=array(':detail_id' => $this->GetFieldNumber($shopware_catalog_row,"detail_id"));
							
			$additional_details_res = $db_pdo->prepare($additional_details_query);
			$additional_details_res->execute($data);
			 
			if($variants!="" && $this->GetFieldNumber($shopware_catalog_row,"configurator_set_id")!=NULL)
			{
				if($existing_ParentPBCommodityId!=$this->GetFieldNumber($shopware_catalog_row,"article_id"))
				{
					$existing_ParentPBCommodityId=$this->GetFieldNumber($shopware_catalog_row,"article_id");
					$master_record=1;
					
					$this->GeneratePBCommodity($shopware_catalog_row,$variants,$additional_details_res,$counter,$folder_path,$master_record);
					$additional_details_query = "SELECT * FROM   s_articles_details sad, s_articles_prices sap where sad.id=:detail_id  and sad.id=sap.articledetailsID";
			
					$data=array(':detail_id' => $this->GetFieldNumber($shopware_catalog_row,"detail_id"));
									
					$additional_details_res = $db_pdo->prepare($additional_details_query);
					$additional_details_res->execute($data);
					$counter++;
				}
			}
			
			$this->GeneratePBCommodity($shopware_catalog_row,$variants,$additional_details_res,$counter,$folder_path);
			
			$counter++;
			
				
	      }
		  
		 
	 }
	 function GeneratePBCommodity($shopware_catalog_row,$variants,$additional_details_res,$counter,$folder_path,$master_record=0)
	 {
	 		global $db_pdo;
			$currency_details_query = "select cc.currency from s_core_currencies cc,  s_core_shops cs where cc.id=cs.currency_id";					
			$currency_details_res = $db_pdo->prepare($currency_details_query);
			$currency_details_res->execute();
			
			$this->shopware_commodities[$counter]->catalog_commodity["Currency"]="";
			foreach($currency_details_res as $currency_details_row) 
			$this->shopware_commodities[$counter]->catalog_commodity["Currency"]=$this->GetFieldString($currency_details_row,"currency");
						
			$this->shopware_commodities[$counter]->catalog_commodity["CountryOfOrigin"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["UnitsOfMeasureLinear"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["UnitsOfMeasureWeight"]="KGS";
			
			
				
				$this->shopware_commodities[$counter]->catalog_commodity["Length"]="";	
				$this->shopware_commodities[$counter]->catalog_commodity["Width"]="";
				$this->shopware_commodities[$counter]->catalog_commodity["Height"]="";
				 
				foreach ($additional_details_res as $additional_details_row) 
				{ 
				
					$this->shopware_commodities[$counter]->catalog_commodity["Weight"]=$this->GetFieldNumber($additional_details_row,"weight");
					$this->shopware_commodities[$counter]->catalog_commodity["Price"]=$this->FormatNumber($this->GetFieldNumber($additional_details_row,"price"));
										
					$width=$this->GetFieldNumber($additional_details_row,"width");
					$height=$this->GetFieldNumber($additional_details_row,"height");
					$length=$this->GetFieldNumber($additional_details_row,"length");
					
									
					if($length>0)
				     $this->shopware_commodities[$counter]->catalog_commodity["Length"]=number_format($length,2,'.','');
					
					if($width>0)
					$this->shopware_commodities[$counter]->catalog_commodity["Width"]=number_format($width,2,'.','');	
					
					if($height>0)
					$this->shopware_commodities[$counter]->catalog_commodity["Height"]=number_format($height,2,'.','');	
					
					$this->shopware_commodities[$counter]->catalog_commodity["Quantity"]="";
					if(!$master_record)			
					$this->shopware_commodities[$counter]->catalog_commodity["Quantity"]=$this->FormatNumber($this->GetFieldNumber($additional_details_row,"instock"));
			}
			
			
			$this->shopware_commodities[$counter]->catalog_commodity["Volume"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["LengthPackaged"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["WidthPackaged"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["HeightPackaged"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["WeightPackaged"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["RowIndex"]="";
			if(!$master_record)	
			$this->shopware_commodities[$counter]->catalog_commodity["SKU"]=$this->GetFieldNumber($additional_details_row,"ordernumber");
			else
			{	
					$master_sku_query = "select ordernumber from  s_articles_details where articleID='".$this->GetFieldNumber($shopware_catalog_row,"article_id")."' order by id limit 0,1";					
					$master_sku_res = $db_pdo->prepare($master_sku_query);
					$master_sku_res->execute();
					
					foreach($master_sku_res as $master_sku_row) 
					$this->shopware_commodities[$counter]->catalog_commodity["SKU"]=$this->GetFieldNumber($master_sku_row,"ordernumber")."_VariationMaster";
			}

			$this->shopware_commodities[$counter]->catalog_commodity["Name"]=utf8_encode($this->GetFieldString($shopware_catalog_row,"name"));
			
			
			$this->shopware_commodities[$counter]->catalog_commodity["ParentPBCommodityId"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["VariationsNameValues"]="";
			if($variants!="" && $this->GetFieldNumber($shopware_catalog_row,"configurator_set_id")!=NULL)
			{
				if(!$master_record)
				{
					$this->shopware_commodities[$counter]->catalog_commodity["ParentPBCommodityId"]=utf8_encode($this->GetFieldNumber($shopware_catalog_row,"article_id"));
					$this->shopware_commodities[$counter]->catalog_commodity["VariationsNameValues"]=$variants;
				}
			}
			
			$this->shopware_commodities[$counter]->catalog_commodity["Description"]=utf8_encode($this->GetFieldString($shopware_catalog_row,"description_long"));
			
			if(!$master_record)
			$this->shopware_commodities[$counter]->catalog_commodity["ExternalID"]=$this->GetFieldNumber($shopware_catalog_row,"detail_id");
			else
			$this->shopware_commodities[$counter]->catalog_commodity["ExternalID"]=$this->GetFieldNumber($shopware_catalog_row,"id");
			// Get Commodity URL
			$org_path="sViewport=detail&sArticle=".$this->GetFieldNumber($shopware_catalog_row,"id");
						
			$url_details_query = "SELECT * FROM  s_core_rewrite_urls where org_path=:org_path";					
			$data=array(':org_path' => $org_path);			
			$url_details_res = $db_pdo->prepare($url_details_query);
			$url_details_res->execute($data);
			
			$this->shopware_commodities[$counter]->catalog_commodity["URL"]="";
			foreach($url_details_res as $url_details_row) 
			$this->shopware_commodities[$counter]->catalog_commodity["URL"]=$folder_path.$this->GetFieldString($url_details_row,"path");
			
			$this->shopware_commodities[$counter]->catalog_commodity["UPC"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["VolumePackaged"]="";
			$this->shopware_commodities[$counter]->catalog_commodity["Condition"]="";
						
			// Get Commodity Manufacturer
			$supplier_details_query = "SELECT * FROM  s_articles_supplier where id=:supplier";					
			$data=array(':supplier' => $this->GetFieldNumber($shopware_catalog_row,"supplierID"));	
			$supplier_details_res = $db_pdo->prepare($supplier_details_query);
			$supplier_details_res->execute($data);
			
			$this->shopware_commodities[$counter]->catalog_commodity["Manufacturer"]="";
			foreach($supplier_details_res as $supplier_details_row)
			$this->shopware_commodities[$counter]->catalog_commodity["Manufacturer"]=$this->GetFieldString($supplier_details_row,"name");
			
			$this->shopware_commodities[$counter]->catalog_commodity["ImageURL"]="";
			$img_details_parent_query = "select parent_id from s_articles_img where article_detail_id=:detail_id";					
			$data=array(':detail_id' => $this->GetFieldNumber($shopware_catalog_row,"detail_id"));			
			$img_details_parent_res = $db_pdo->prepare($img_details_parent_query);
			$img_details_parent_res->execute($data);
			
			foreach($img_details_parent_res as $img_details_parent_row) 
			$parent_id=$this->GetFieldNumber($img_details_parent_row,"parent_id");
			
			if($variants!="" && isset($parent_id))
			{
			
				$img_details_query = "select sm.path from s_articles_img sai, s_media sm where sai.id=:parent_id and  sai.img=sm.name limit 0,1";					
				$data=array(':parent_id' => $parent_id);			
				$img_details_res = $db_pdo->prepare($img_details_query);
				$img_details_res->execute($data);
				
				foreach($img_details_res as $img_details_row) 
				$this->shopware_commodities[$counter]->catalog_commodity["ImageURL"]=$folder_path.$this->GetFieldString($img_details_row,"path");
				
							
			}
			else
			{
			
				$img_details_query = "select sm.path from s_articles_img sai, s_media sm where sai.articleID=:articleID and  sai.media_id=sm.id limit 0,1";					
				$data=array(':articleID' => $this->GetFieldNumber($shopware_catalog_row,"article_id"));			
				$img_details_res = $db_pdo->prepare($img_details_query);
				$img_details_res->execute($data);
				
				foreach($img_details_res as $img_details_row) 
				$this->shopware_commodities[$counter]->catalog_commodity["ImageURL"]=$folder_path.$this->GetFieldString($img_details_row,"path");
			}
			
	 }
	 ############################################## Function UpdateCatalog #################################
	// Update catalog
	#######################################################################################################
	function UpdateCatalog($ExternalID ,$Quantity )
	{
		global $db_pdo;
		
		$sql = "SELECT * FROM s_articles_details WHERE id=:externalId";
		$data=array(':externalId' => $ExternalID);
		
		$result = $db_pdo->prepare($sql);
		$result->execute($data);
		// check if commodity id is valid
		
		if($result->rowCount()>0)
		{
			$sql_upd="update s_articles_details set instock=:quantity where id=:externalId";														
			$data_upd=array( ':quantity' => $Quantity,':externalId' => $ExternalID);
				
			$result_upd = $db_pdo->prepare($sql_upd);
			$result_upd->execute($data_upd);
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));			
		   
		}
		else
		{
			//display error message
			$this->display_msg=INVAID_COMMODITY_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		}
	  
	}
	 ############################################## Function RetrieveCatalogCount #################################
	// Get catalog count
	#######################################################################################################
	function RetrieveCatalogCount()
	{
		
		global $db_pdo;
		
		$sql = "SELECT id FROM s_articles_details where 1 ";				
		$result = $db_pdo->prepare($sql);
		$result->execute();
		$catalog_count=$result->rowCount();
		
		$catalog_query = "SELECT *, sd.id as detail_id,a.id as article_id FROM s_articles_details sd, s_articles a where sd.articleID=a.id ";		
		$shopware_catalog_res = $db_pdo->prepare($catalog_query);
		$shopware_catalog_res->execute();			
		
		$existing_ParentPBCommodityId="";
		$master_record_count=0;			
		foreach ($shopware_catalog_res as $shopware_catalog_row) 
		{
						
			$additional_options_query = "SELECT sg.name as atrribute_name, so.name as option_value FROM s_article_configurator_option_relations sor,  s_article_configurator_groups sg,  s_article_configurator_options so where sor.article_id=:detail_id and sor.option_id=so.id and so.group_id=sg.id";
								
			$data=array(':detail_id' => $this->GetFieldNumber($shopware_catalog_row,"detail_id"));
			
			$additional_options_res = $db_pdo->prepare($additional_options_query);
			$additional_options_res->execute($data);
			$variants="";
			foreach ($additional_options_res as $additional_options_row) 
			{ 
				if($variants!="")
				$variants.=","; 
				 
				$variants.=$this->GetFieldString($additional_options_row,"atrribute_name").":".$this->GetFieldString($additional_options_row,"option_value");
			}
					
			if($variants!="" && $this->GetFieldNumber($shopware_catalog_row,"configurator_set_id")!=NULL)
			{
				if($existing_ParentPBCommodityId!=$this->GetFieldNumber($shopware_catalog_row,"article_id"))
				{
					$existing_ParentPBCommodityId=$this->GetFieldNumber($shopware_catalog_row,"article_id");
					$master_record_count++;
					
				}
			}
		}	
		
		$catalog_count=$catalog_count+$master_record_count;
		return  $catalog_count;
	
	}
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	// Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->shopware_orders))
				return $this->shopware_orders;
			else
							return array();  
			
	}
	################################################## Function GetCatalog() #############################
	// Get catalog based on paging
	#######################################################################################################
	function GetCatalog()
	{
			
			$this->Fetch_DB_Catalog($this->Limit,$this->Offset);
			

			if (isset($this->shopware_commodities))
				return $this->shopware_commodities;
			else
							return array();  
			
	}
	################################################ Function PrepareOrderStatusString #######################
	// Prepare order status string based on settings
	#######################################################################################################
	function PrepareShopwareOrderStatusFilter()
	{
			
			$order_status_filter="";
			
			if(SHOPWARE_RETRIEVE_ORDER_STATUS_1_OPEN==1)//considers new orders
			{
				$order_status_filter="  status='0'";
			
			}
			if(SHOPWARE_RETRIEVE_ORDER_STATUS_2_PROCESSING==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" status='1'";
				}
				else
				{
					$order_status_filter.=" OR status='1'";
				}
			
			}
			if(SHOPWARE_RETRIEVE_ORDER_STATUS_3_READY_FOR_DELIVERY==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" status='5'";
				}
				else
				{
					$order_status_filter.=" OR status='5'";
				}
			
			}
			if(SHOPWARE_RETRIEVE_ORDER_STATUS_4_COMPLETED==1) //consider shipped or delivered orders
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" status='2' ";
				}
				else
				{
					$order_status_filter.=" OR status='2'";
				}
			
			}
			
			if(SHOPWARE_RETRIEVE_ORDER_STATUS_5_CANCELLED==1) //consider shipped or delivered orders
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=" status='4' ";
				}
				else
				{
					$order_status_filter.=" OR status='4'";
				}
			
			}
			
			if($order_status_filter!="")
			$order_status_filter="( ".$order_status_filter." ) and";
			
			
			return $order_status_filter;
			
	}
		
	
}


######################################### End of class ShippingZShopware ###################################################

	// create object & perform tasks based on command

	$obj_shipping_shopware=new ShippingZShopware;
	$obj_shipping_shopware->ExecuteCommand();

?>
