<?php
###################################### Functions ############################################################################
class ShippingZPluginTest
{
	var $cart_file_name="";
	var $message="";
	var $error_msg="";
	var $output="";
	var $overall_output="";
	var $xml_vals="";
	var $xml_keys="";
	var $error_flag=0;
	
	
	function GetParams($field_name)
	{
		if(preg_match("/$field_name=/i",$_SERVER['QUERY_STRING'],$matches))
		{
			$case_insensitive_field_name=str_replace("=","",$matches[0]);
			return $_GET[$case_insensitive_field_name];
		}
	}
	function SetCartFileName($cart_type)
	{
		switch($cart_type)
		{
			case 'magento':
			$this->cart_file_name="ShippingZMagento.php";
			break;
			
			case 'zencart':
			$this->cart_file_name="ShippingZZencart.php";
			break;
			
			case 'xcart':
			$this->cart_file_name="ShippingZXcart.php";
			break;
			
			case 'oscommerce':
			$this->cart_file_name="ShippingZOscommerce.php";
			break;
			
			case 'creloaded':
			$this->cart_file_name="ShippingZCreloaded.php";
			break;
			
			default:
			$this->cart_file_name="";
			break;
		
		}
	
	
	}
	function GetMicrotime ()
	{
		list ($msec, $sec) = explode(' ', microtime());
		$microtime = (float)$msec + (float)$sec;
		return $microtime;
	}
	function xml_to_array()
	{
		$p = xml_parser_create();
		xml_parse_into_struct($p, $this->output, $this->xml_vals, $this->xml_keys);
	
	}

	function UrlCall($url)
	{
		//check if the url is proper & we can access wsdl
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$fp = curl_exec($ch); 
		
		return $fp;
	}
	
	function ExecuteCartCommands($cart_type,$url,$shipping_access_token)
	{
	
		$this->SetCartFileName(strtolower($cart_type));
		if($this->cart_file_name=="" || $url=="" || $shipping_access_token=="")
		{
			if($this->cart_file_name=="")
				$this->message="Invalid Cart Type.Supported carts are magento,zen,xcart,oscommerce and cre.";
			else if($url=="")
				$this->message="Url not set.";
			else
				$this->message="Access Token not set.";
				
			$this->error_flag=1;
			$this->error_msg=$this->message;
		}
		else
		{
			/*################################### Perform commands on by one ###########################*/
			
			/*========================================= Call ping command ==============================*/
			
			
			$formatted_url=$url."/".$this->cart_file_name."?SHIPPING_ACCESS_TOKEN=".$shipping_access_token."&cmd=ping";
			
			$start = $this->GetMicrotime(); //track time
			$this->output=$this->UrlCall($formatted_url);//execute command
			$end = $this->GetMicrotime(); //track time
			
			$this->overall_output=$this->output;
			
			if(strstr($this->output,'Success'))
			{
				$this->message.="Ping command executed successfully.";
				$execute_next_cmds=1;
				
			}
			else
			{
				$this->message.="Ping command Failed.Invalid shipping_access_token specified.";
				$execute_next_cmds=0;
				$this->error_flag=1;
				$this->error_msg.="Ping command Failed.Invalid shipping_access_token specified.";;
				
			}
			$this->message.="<br>";
			$this->message.="Time Taken:".round($end - $start, 3) . " seconds."; 
			
			if($execute_next_cmds)
			{
					/*============== Call getordercountbydate command  for date range: January 1990  ======================*/
					$this->overall_output.="\n\n";
					
					
					$formatted_url=$url."/".$this->cart_file_name."?SHIPPING_ACCESS_TOKEN=".$shipping_access_token."&cmd=getordercountbydate&datefrom=1990-01-01T01:01:01Z&dateto=1990-01-31T01:01:01Z";
					
					$start = $this->GetMicrotime(); //track time
					$this->output=$this->UrlCall($formatted_url);//execute command
					$end = $this->GetMicrotime(); //track time
					
					$this->overall_output.=$this->output;
					
					$this->message.="<br>----------------------------<br>";
					$this->xml_to_array();
					
							
					if(strstr($this->output,'Ordercount'))
					{
						$order_count_returned=$this->xml_vals[1]['value'];
						if($order_count_returned==0) //check if ordercount is 0.
						{
							$this->message.="Getordercountbydate command(for date range: January 1990) executed successfully.";
							$this->message.="No order found.";
						}
						else
						{
							$this->message.="Error Occurded.Getordercountbydate command(for date range: January 1990) returned $order_count_returned order(s).";
							$this->error_msg.="Error Occurded.Getordercountbydate command(for date range: January 1990) returned $order_count_returned order(s).";
							$this->error_flag=1;
						}
					}
					else
					{
						$this->message.="Getordercountbydate(for date range: January 1990) command Failed.";
						$this->error_flag=1;
						$this->error_msg.="Getordercountbydate(for date range: January 1990) command Failed.";
						
					}
					$this->message.="<br>";
					$this->message.="Time Taken:".round($end - $start, 3) . " seconds"; 
					
					/*============ Call getordercountbydate command  for date range: now() and (now()-1 year)====================*/
					$this->overall_output.="\n\n";
					
					$dateto=date("Y-m-d");
					$datefrom=date("Y-m-d",strtotime("-1 years"));
					
					$formatted_url=$url."/".$this->cart_file_name."?SHIPPING_ACCESS_TOKEN=".$shipping_access_token."&cmd=getordercountbydate&datefrom=".$datefrom."T01:01:01Z&dateto=".$dateto."T01:01:01Z";
					
						
					$start = $this->GetMicrotime(); //track time
					$this->output=$this->UrlCall($formatted_url);//execute command
					$end = $this->GetMicrotime(); //track time
					
					$this->overall_output.=$this->output;
					
					$this->message.="<br>----------------------------<br>";
					$this->xml_to_array();
					
							
					if(strstr($this->output,'Ordercount'))
					{
						$order_count_returned=$this->xml_vals[1]['value'];
						if($order_count_returned>=2) //check if ordercount is 2 or more than 2.
						{
							$this->message.="Getordercountbydate command(for date range: now() and (now()-1 year)) executed successfully.";
							$this->message.="<br>$order_count_returned orders found.";
						}
						else
						{
							$this->message.="Error Occurded.Getordercountbydate command(for date range: now() and (now()-1 year)) returned $order_count_returned order(s).";
							$this->error_msg.="Error Occurded.Getordercountbydate command(for date range: now() and (now()-1 year)) returned $order_count_returned order(s).";
							$this->error_flag=1;
							
						}
						
					}
					else
					{
						$this->message.="Getordercountbydate(for date range: now() and (now()-1 year)) command Failed.";
						$this->error_flag=1;
						$this->error_msg.="Getordercountbydate(for date range: now() and (now()-1 year)) command Failed.";
					}
					$this->message.="<br>";
					$this->message.="Time Taken:".round($end - $start, 3) . " seconds."; 
					
					
					  /*============== Call GetOrdersByDate command  for date range: January 1990  ======================*/
					$this->overall_output.="\n\n";
					
					
					$formatted_url=$url."/".$this->cart_file_name."?SHIPPING_ACCESS_TOKEN=".$shipping_access_token."&cmd=getordersbydate&datefrom=1990-01-01T01:01:01Z&dateto=1990-01-31T01:01:01Z";
					
					$start = $this->GetMicrotime(); //track time
					$this->output=$this->UrlCall($formatted_url);//execute command
					$end = $this->GetMicrotime(); //track time
					
					$this->overall_output.=$this->output;
					
					$this->message.="<br>----------------------------<br>";
					$this->xml_to_array();
					/*print_r($this->output);
					exit;	*/	
					if(!strstr($this->output,'ShipmentOrder>'))
					{
						
							$this->message.="GetOrdersByDate command(for date range: January 1990) executed successfully.";
							$this->message.="No order found.";
					}
					else
					{	
							$order_count_returned=(substr_count($this->output,'ShipmentOrder>'))/2;					
							$this->message.="Error Occurded.GetOrdersByDate command(for date range: January 1990) returned $order_count_returned order(s).";
							$this->error_flag=1;
							$this->error_msg.="Error Occurded.GetOrdersByDate command(for date range: January 1990) returned $order_count_returned order(s).";
						
					}
					
					$this->message.="<br>";
					$this->message.="Time Taken:".round($end - $start, 3) . " seconds."; 
										
					/*============ Call GetOrdersByDate command  for date range: now() and (now()-1 year)====================*/
					$this->overall_output.="\n\n";
					
					$dateto=date("Y-m-d");
					$datefrom=date("Y-m-d",strtotime("-1 years"));
					
					$formatted_url=$url."/".$this->cart_file_name."?SHIPPING_ACCESS_TOKEN=".$shipping_access_token."&cmd=getordersbydate&datefrom=".$datefrom."T01:01:01Z&dateto=".$dateto."T01:01:01Z";
					
						
					$start = $this->GetMicrotime(); //track time
					$this->output=$this->UrlCall($formatted_url);//execute command
					$end = $this->GetMicrotime(); //track time
					
					$this->overall_output.=$this->output;
					
					$this->message.="<br>----------------------------<br>";
					$this->xml_to_array();
					$order_count_returned=(substr_count($this->output,'ShipmentOrder>'))/2;	
							
					if($order_count_returned>=2)
					{
						
							if(strstr(strtolower($this->output), '120 lakeside ave'))
							{
								$this->message.="GetOrdersByDate command(for date range: now() and (now()-1 year)) executed successfully.";
								$this->message.="$order_count_returned order(s) found.";
							
							}
							else
							{
										
								$this->message.="Error Occured.<br>";
								$this->message.="$order_count_returned order(s) found.";
								$this->message.="But required address (as shown below) not found.<br>";
								$this->message.="Address:120 lakeside ave";
								$this->error_flag=1;
								
								$this->error_msg.="Error Occured.<br>";
								$this->error_msg.="$order_count_returned order(s) found.";
								$this->error_msg.="But required address (as shown below) not found.<br>";
								$this->error_msg.="Address:120 lakeside ave";
							}
					}
					else
					{	
											
							$this->message.="Error Occurded.GetOrdersByDate command(for date range: now() and (now()-1 year)) returned $order_count_returned order(s).But expected at least 2 orders.";
							$this->error_flag=1;
							$this->error_msg.="Error Occurded.GetOrdersByDate command(for date range: now() and (now()-1 year)) returned $order_count_returned order(s).But expected at least 2 orders.";
						
					}
					$this->message.="<br>";
					$this->message.="<br>Time Taken:".round($end - $start, 3) . " seconds."; 
						
			  }

					
			
		}
	
	}
}//end of class
##################################### End of functions #####################################################################
$obj_plugin_test=new ShippingZPluginTest;


$cart_type=$obj_plugin_test->GetParams('cart');
$url=$obj_plugin_test->GetParams('url');
$shipping_access_token=$obj_plugin_test->GetParams('shipping_access_token');

$obj_plugin_test->ExecuteCartCommands($cart_type,$url,$shipping_access_token);

if($obj_plugin_test->error_flag==1 && $obj_plugin_test->GetParams('raise_http_error'))
{

	header('HTTP/1.1 500 Internal Server Error');
	header('Content-Type: text/html');
	header('Content-Length: '.strlen($obj_plugin_test->error_msg));
	
	if($obj_plugin_test->error_msg!="") 
	echo $obj_plugin_test->error_msg;

}
else
{
	?>
	<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
	<title>High Level Test</title>
	<style>
	body{
	font-family:Arial, Helvetica, sans-serif; font-size:12px;
	}
	</style>
	</head>
	
	<body>
	<table width="100%" border="0" cellspacing="3" cellpadding="3" style="border:#000000 1px solid;">
	  <tr>
		<td width="56%"><strong>OUTPUT</strong></td>
		<td width="44%"><strong>RAW OUTPUT</strong></td>
	  </tr>
	   <tr>
		<td valign="top"><?php if($obj_plugin_test->message!="") echo $obj_plugin_test->message; ?></td>
		<td valign="top"><textarea name="log" rows="26" cols="56"><?php if($obj_plugin_test->overall_output!="") echo $obj_plugin_test->overall_output; ?></textarea></td>
	  </tr>
	</table>
	
	</body>
	</html>
	<?php
}
?>
