<?php

define("SHIPPINGZWPECOMMERCE_VERSION","4.0.15.9085");

# ################################################################################ # 	 #  (c) 2010-2014 Z-Firm LLC, ALL RIGHTS RESERVED. # #  This file is protected by U.S. and international copyright laws. Technologies and techniques herein are #  the proprietary methods of Z-Firm LLC.  #          #         IMPORTANT #         ========= #         THIS FILE IS RESTRICTED FOR USE IN CONNECTION WITH SHIPRUSH, MY.SHIPRUSH AND OTHER SOFTWARE  #         PRODUCTS OWNED BY Z-FIRM LLC.  UNLESS EXPRESSLY PERMITTED BY Z-FIRM, ANY USE IS STRICTLY PROHIBITED. # #         THIS FILE, AND ALL PARTS OF SHIPRUSH_SHOPPINGCART_INTEGRATION_KIT__SEE_README_FILE.ZIP AND  #         THE MY.SHIPRUSH KIT, ARE GOVERNED BY THE MY.SHIPRUSH TERMS OF SERVICE & END USER LICENSE AGREEMENT. #          #         The ShipRush License Agreement can be read here: http://www.zfirm.com/SHIPRUSH-EULA #          #         If you do not agree with these terms, this file and related files must be deleted immediately. # #         Thank you for using ShipRush! # 	 ################################################################################

// Last mod to this file: $Change$

// Function for checking Include Files
function Check_Include_File($filename)
{
	if(file_exists($filename))
	{
		return true;
	}
	else
	{
		echo "\"$filename\" is not accessible.";
		exit;
	}

}

// Check for ShippingZ integration files
if(Check_Include_File("ShippingZSettings.php"))
include("ShippingZSettings.php");
if(Check_Include_File("ShippingZClasses.php"))
include("ShippingZClasses.php");
if(Check_Include_File("ShippingZMessages.php"))
include("ShippingZMessages.php");


// TEST that all the files are same version
if(!(SHIPPINGZCLASSES_VERSION==SHIPPINGZWPECOMMERCE_VERSION && SHIPPINGZWPECOMMERCE_VERSION==SHIPPINGZMESSAGES_VERSION))
{
	echo "Connection to ShipRush plugin successful!<br><br>
	Issue identified: File version mismatch.<br><br>";
	echo "ShippingZClasses.php [".SHIPPINGZCLASSES_VERSION."]<br>";
	echo "ShippingZWPecommerce.php [".SHIPPINGZWPECOMMERCE_VERSION."]<br>";
	echo "ShippingZMessages.php [".SHIPPINGZMESSAGES_VERSION."]<br><br>";
	echo "Please update the kit on this server so the file versions are all the same.<br><br>Thank you!";
	exit;
}

############################################## Always Enable Exception Handler ###############################################
error_reporting(E_ALL);
ini_set('display_errors', '1');
set_error_handler("ShippingZ_Exception_Error_Handler");

//include required wp file
if(Check_Include_File("wp-load.php"))
include("wp-load.php");

if(Check_Include_File(WPSC_FILE_PATH . '/wpsc-includes/purchaselogs.class.php'))
include(WPSC_FILE_PATH . '/wpsc-includes/purchaselogs.class.php');

//Check Permalink structure
$port_number="";
$updated_host="";
if(strpos(DB_HOST, ':') !== false) {
  $split_host=explode(":",DB_HOST);
  $updated_host=$split_host[0];
  $port_number=$split_host[1];
} 

if($port_number!="")
$db_pdo=new PDO("mysql:host=".$updated_host.";port=".$port_number.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);
else
$db_pdo=new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);

global $wpdb;
											

################################################ Function convert_dim_unit #######################
//converts dim unit to desired units
function convert_dim_unit($from_unit)
{
	
	$from_unit=trim($from_unit);
	
	if($from_unit=='cm' || $from_unit=='in')
	{
		
		$converted_unit=strtoupper($from_unit);
	}
	else 
	{
	
		$converted_unit="Unknown";
	}
	
	return $converted_unit;
}
########################################### Function get_actual_order_id ##############################
function get_actual_order_id($OrderNumber)
{
	global $wpdb;
	//Check if sequencial order number plugin is installed
	$args = array(
		'meta_key' => '_order_number',
		'meta_value' => $OrderNumber,
		'post_type' => 'shop_order'
	);
	$order_posts = get_posts($args);
	if(is_array($order_posts) && count($order_posts)>0)
	{
		$OrderNumber=$order_posts[0]->ID; //Find out actual order id
	}
	return $OrderNumber;
}
#######################################################################
		
//Use DB integration				
if($port_number!="")
$db_pdo=new PDO("mysql:host=".$updated_host.";port=".$port_number.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);
else
$db_pdo=new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME, DB_USER, DB_PASSWORD);

############################################## Class SHIPPINGZWPECOMMERCE ######################################
class SHIPPINGZWPECOMMERCE extends ShippingZGenericShoppingCart
{
	
	//cart specific functions goes here
	var $wpecommerce_orders=array();
	############################################## Function Check_DB_Access #################################
	//Check Database access
	#######################################################################################################
	function Check_DB_Access()
	{
		global $db_pdo,$wpdb;
				
		$sql= "SHOW COLUMNS FROM ".$wpdb->prefix."wpsc_purchase_logs ";	
					
		$order_status = $db_pdo->prepare($sql);										
		$order_status->execute();
		
		if ($order_status->rowCount()) 
		{
			$this->display_msg=DB_SUCCESS_MSG;
			
		}
		else
		{
			$this->display_msg=$this->display_msg='Error occurred:'.implode(":",$order_status->errorInfo());
		}
		
	}
	
	############################################## Function GetOrderCountByDate #################################
	//Get order count
	#######################################################################################################
	function GetOrderCountByDate($datefrom,$dateto)
	{
		
		global $db_pdo,$wpdb;
				
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);
		
		//Get order count based on date range
		$order_status_filter=$this->PrepareWPecommerceOrderStatusFilter();
		$sql = "SELECT  " . $wpdb->prefix . "wpsc_purchase_logs.id AS orders FROM " . $wpdb->prefix . "wpsc_purchase_logs  where ".$order_status_filter." " . $wpdb->prefix . "wpsc_purchase_logs.date  >= :datefrom  AND " . $wpdb->prefix . "wpsc_purchase_logs.date <= :dateto ";
		
		$orders = $db_pdo->prepare($sql);
		
		$data=array(':datefrom' => $datefrom_timestamp , ':dateto' => $dateto_timestamp);
		
		$orders->execute($data);
		
		return $orders->rowCount();
	
	}
	############################################## Function UpdateShippingInfo #################################
	//Update order status 
	#######################################################################################################
	function UpdateShippingInfo($OrderNumber,$TrackingNumber='',$ShipDate='',$ShipmentType='',$Notes='',$Carrier='',$Service='',$ShippingCost='')
	{
		global $db_pdo,$wpdb;
			
		$OrderNumber=get_actual_order_id($OrderNumber);
		$sql = "SELECT * FROM " . $wpdb->prefix . "wpsc_purchase_logs  where id=:order_id";		
		$result = $db_pdo->prepare($sql);
		$result->execute(array(':order_id' => $OrderNumber));
		
		//check if order number is valid
		if($result->rowCount()>0)
		{
		
			if($ShipDate!="")
				$shipped_on=$ShipDate;
			else
				$shipped_on=date("m/d/Y");
				
			if($Carrier!="")
			{
				$original_carrier=$Carrier;
				$Carrier=" via ".$Carrier;
			}
			
			if($Service!="")
			$Service=" [".$Service."]";
			
			$TrackingNumberString="";
			if($TrackingNumber!="")
			$TrackingNumberString=", Tracking number $TrackingNumber";
			
				
			foreach( $result as $order )
			{
				$current_order_status=$order['processed'];
			}
			
			//prepare $comments & save it
			$comments="Shipped on $shipped_on".$Carrier.$Service.$TrackingNumberString;
			
					
			if(WPECOMMERCE_SHIPPED_STATUS_SET_TO_STATUS_4_COMPLETE==1)
			{
							
				$change_order_status="5";
			}
			else
			{
				 if(strtolower($current_order_status)=="2")
					$change_order_status="3";
				 else if(strtolower($current_order_status)=="3")
					$change_order_status="4";	
				else if(strtolower($current_order_status)=="4")
					$change_order_status="5";
				else
				$change_order_status=$current_order_status;
									
			}
			
			
			// Update tracking information
			if(WPECOMMERCE_TRACKING_NOTES_UPDATE_ONLY)
			{
				$sql_update = "Update " . $wpdb->prefix . "wpsc_purchase_logs set notes=:notes  where id=:order_id";		
				$result_update = $db_pdo->prepare($sql_update);
				$result_update->execute(array(':notes' => $comments,':order_id' => $OrderNumber));
			}
			else
			{
				$sql_update = "Update " . $wpdb->prefix . "wpsc_purchase_logs set notes=:notes, track_id=:tracking_number, processed=:change_order_status  where id=:order_id";		
				$result_update = $db_pdo->prepare($sql_update);
				$result_update->execute(array(':notes' => $comments,':tracking_number' => $TrackingNumber,':change_order_status' => $change_order_status,':order_id' => $OrderNumber));
			}
			
					
			$this->SetXmlMessageResponse($this->wrap_to_xml('UpdateMessage',"Success"));
		}
		else
		{
			//display error message
			$this->display_msg=INVAID_ORDER_NUMBER_ERROR_MSG;
			$this->SetXmlError(1,$this->display_msg);
		
		} 	
		
	}
	############################################## Function Fetch_DB_Orders #################################
	//Perform Database query & fetch orders based on date range
	#######################################################################################################
	
	function Fetch_DB_Orders($datefrom,$dateto)
	{
		//Get orders based on date range
		global $db_pdo,$wpdb,$product_weight_unit;
				
		$order_status_filter=$this->PrepareWPecommerceOrderStatusFilter();
		
		$datefrom_timestamp=$this->GetServerTimeLocal(false,$datefrom);
		$dateto_timestamp=$this->GetServerTimeLocal(false,$dateto);
		
		$order_status_filter=$this->PrepareWPecommerceOrderStatusFilter();
		$sql = "SELECT  " . $wpdb->prefix . "wpsc_purchase_logs.id AS orders FROM " . $wpdb->prefix . "wpsc_purchase_logs  where ".$order_status_filter." " . $wpdb->prefix . "wpsc_purchase_logs.date  >= :datefrom  AND " . $wpdb->prefix . "wpsc_purchase_logs.date <= :dateto ";
	
		
		$orders_result = $db_pdo->prepare($sql);
		
		$data=array(':datefrom' => $datefrom_timestamp , ':dateto' => $dateto_timestamp);

		
		$orders_result->execute($data);
		
		$counter=0;
		$uom_weight="";
		$dim_unit="";
		foreach( $orders_result as $order )
		{
				$order_id=$order['orders'];
				$wpecommerce_order_data = new wpsc_purchaselogs_items($order_id);
							
				$order_tax=0;
				if(isset($wpecommerce_order_data->extrainfo->wpec_taxes_total))
				$order_tax=$wpecommerce_order_data->extrainfo->wpec_taxes_total;
				
				$wpecommerce_order_products_temp=$wpecommerce_order_data->allcartcontent;
				
				if(count($wpecommerce_order_products_temp)==0)
				continue;
											
				//prepare order array
				$this->wpecommerce_orders[$counter]=new stdClass();
				$this->wpecommerce_orders[$counter]->orderid=$order_id;
															
				//billing details
				$this->wpecommerce_orders[$counter]->order_billing["FirstName"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingfirstname'],'value');
				$this->wpecommerce_orders[$counter]->order_billing["LastName"]=$this->Check_Field($wpecommerce_order_data->userinfo['billinglastname'],'value');
				$this->wpecommerce_orders[$counter]->order_billing["Company"]="";
				$whole_address=$this->Check_Field($wpecommerce_order_data->userinfo['billingaddress'],'value');
				$whole_address_split=explode("\n",$whole_address);
				
				$this->wpecommerce_orders[$counter]->order_billing["Address1"]=$whole_address_split[0]; 
				$this->wpecommerce_orders[$counter]->order_billing["Address2"]="";
				if(isset($whole_address_split[1]))
				$this->wpecommerce_orders[$counter]->order_billing["Address2"]=$whole_address_split[1];
				$this->wpecommerce_orders[$counter]->order_billing["City"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingcity'],'value');
				$this->wpecommerce_orders[$counter]->order_billing["State"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingstate'],'value');
				$this->wpecommerce_orders[$counter]->order_billing["PostalCode"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingpostcode'],'value');
				$this->wpecommerce_orders[$counter]->order_billing["Country"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingcountry'],'value');
				$this->wpecommerce_orders[$counter]->order_billing["Phone"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingphone'],'value');
				
				//shipping details
				$this->wpecommerce_orders[$counter]->order_shipping["FirstName"]=$this->Check_Field($wpecommerce_order_data->shippinginfo['shippingfirstname'],'value');
				$this->wpecommerce_orders[$counter]->order_shipping["LastName"]=$this->Check_Field($wpecommerce_order_data->shippinginfo['shippinglastname'],'value');
				$this->wpecommerce_orders[$counter]->order_shipping["Company"]="";
				$whole_address_shipping=$this->Check_Field($wpecommerce_order_data->shippinginfo['shippingaddress'],'value');
				$whole_address_shipping_split=explode("\n",$whole_address_shipping);
				
				$this->wpecommerce_orders[$counter]->order_shipping["Address1"]=$whole_address_shipping_split[0];
				$this->wpecommerce_orders[$counter]->order_shipping["Address2"]="";
				if(isset($whole_address_shipping_split[1]))
				$this->wpecommerce_orders[$counter]->order_shipping["Address2"]=$whole_address_shipping_split[1];
				
				$this->wpecommerce_orders[$counter]->order_shipping["City"]=$this->Check_Field($wpecommerce_order_data->shippinginfo['shippingcity'],'value');
				$this->wpecommerce_orders[$counter]->order_shipping["State"]=$this->Check_Field($wpecommerce_order_data->shippinginfo['shippingstate'],'value');
				$this->wpecommerce_orders[$counter]->order_shipping["PostalCode"]=$this->Check_Field($wpecommerce_order_data->shippinginfo['shippingpostcode'],'value');
				$this->wpecommerce_orders[$counter]->order_shipping["Country"]=	$this->Check_Field($wpecommerce_order_data->shippinginfo['shippingcountry'],'value');
				$this->wpecommerce_orders[$counter]->order_shipping["Phone"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingphone'],'value');
				$this->wpecommerce_orders[$counter]->order_shipping["EMail"]=$this->Check_Field($wpecommerce_order_data->userinfo['billingemail'],'value');
														
				//order info
				$order_date_actual = new DateTime('@'.$this->Check_Field($wpecommerce_order_data->extrainfo,'date'));
				$this->wpecommerce_orders[$counter]->order_info["OrderDate"]= $order_date_actual->format('Y-m-d\TH:i:00\Z');
				
				$this->wpecommerce_orders[$counter]->order_info["Total"]=number_format($this->Check_Field($wpecommerce_order_data->extrainfo,'totalprice'),2,'.',''); 
				$this->wpecommerce_orders[$counter]->order_info["ItemsTax"]=number_format($order_tax,2,'.','');
				$this->wpecommerce_orders[$counter]->order_info["OrderNumber"]=$order_id;
				$this->wpecommerce_orders[$counter]->order_info["PaymentType"]=$this->ConvertPaymentType($this->Check_Field($wpecommerce_order_data->extrainfo,'gateway'));
				$this->wpecommerce_orders[$counter]->order_info["ShippingChargesPaid"]=number_format($this->Check_Field($wpecommerce_order_data->extrainfo,'base_shipping'),2,'.','');
				$this->wpecommerce_orders[$counter]->order_info["ShipMethod"]=$this->Check_Field($wpecommerce_order_data->extrainfo,'shipping_option');
				$this->wpecommerce_orders[$counter]->order_info["Comments"]=$this->Check_Field($wpecommerce_order_data->extrainfo,'notes');	
				$this->wpecommerce_orders[$counter]->order_info["ExternalID"]=$this->wpecommerce_orders[$counter]->order_info["OrderNumber"] . '-' . $this->wpecommerce_orders[$counter]->order_info["OrderDate"];		
	
				$order_status=$this->Check_Field($wpecommerce_order_data->extrainfo,'processed');
				
				if($order_status!="2" && $order_status!="6" )
					$this->wpecommerce_orders[$counter]->order_info["PaymentStatus"]=2;
				else
					$this->wpecommerce_orders[$counter]->order_info["PaymentStatus"]=0;
				
				//Show Order status
				if($order_status=="5")
					$this->wpecommerce_orders[$counter]->order_info["IsShipped"]=1;
				else
					$this->wpecommerce_orders[$counter]->order_info["IsShipped"]=0;
					
									
				$actual_number_of_products=0;
				
				$this->wpecommerce_orders[$counter]->order_info["ItemsTotal"]=0;				
				foreach($wpecommerce_order_products_temp as $key=>$wpecommerce_order_products)
				{
										
					if($wpecommerce_order_products->name!="")
					{				
						$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["Name"]=$wpecommerce_order_products->name;
						$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["Price"]=number_format($wpecommerce_order_products->price,2,'.','');
						
						$sql_product_sku = "SELECT  *  FROM " . $wpdb->prefix . "postmeta  where meta_key='_wpsc_sku' and post_id= :product_id ";		
						$product_sku_result = $db_pdo->prepare($sql_product_sku);		
						$product_sku_data=array(':product_id' => $wpecommerce_order_products->prodid );
						$product_sku_result->execute($product_sku_data);
						$product_sku_val="";
						foreach( $product_sku_result as $product_sku )
						{
							$$product_sku_val=$product_sku['meta_value'];
						}
						if($$product_sku_val=="")
						$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$wpecommerce_order_products->prodid;
						else
						$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["ExternalID"]=$$product_sku_val;
						
						$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["Quantity"]=number_format($wpecommerce_order_products->quantity,2,'.','');
						$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["Total"]=number_format(($wpecommerce_order_products->price*$wpecommerce_order_products->quantity),2,'.','');
						$this->wpecommerce_orders[$counter]->order_info["ItemsTotal"]+=$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["Total"];
						
						$sql_product_meta = "SELECT  *  FROM " . $wpdb->prefix . "postmeta  where meta_key='_wpsc_product_metadata' and post_id= :product_id ";		
						$product_meta_result = $db_pdo->prepare($sql_product_meta);		
						$product_data=array(':product_id' => $wpecommerce_order_products->prodid );
						
						$product_meta_result->execute($product_data);
						$product_meta_arr=array();
						foreach( $product_meta_result as $product_meta )
						{
							$product_meta_arr=unserialize($product_meta['meta_value']); 
							if(isset($product_meta_arr['dimensions']))
							{
								if($product_meta_arr['dimensions']['length']>0)
								$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]['ItemLength']=number_format($product_meta_arr['dimensions']['length'],2,'.','');
								if($product_meta_arr['dimensions']['width']>0)
								$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]['ItemWidth']=number_format($product_meta_arr['dimensions']['width'],2,'.','');
								if($product_meta_arr['dimensions']['height']>0)
								$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]['ItemHeight']=number_format($product_meta_arr['dimensions']['height'],2,'.','');
								
								$dim_unit=convert_dim_unit($product_meta_arr['dimension_unit']);
							}
							$product_weight_unit=$product_meta_arr['weight_unit'];
							$product_weight=$product_meta_arr['weight'];
							if($product_weight!="")
							$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["IndividualProductWeight"]=number_format($product_weight*$wpecommerce_order_products->quantity,2,'.','');
							
							$total_weight_with_unit=$this->ConvertToAcceptedUnitWeight(($product_weight*$wpecommerce_order_products->quantity),strtolower($product_weight_unit));
							$total_weight_with_unit=explode("~",$total_weight_with_unit);
							$this->wpecommerce_orders[$counter]->order_product[$actual_number_of_products]["Total_Product_Weight"]=number_format($total_weight_with_unit[0],2,'.','');
							$uom_weight=$total_weight_with_unit[1];
						}
						
						$actual_number_of_products++;						
				 }
			}
			$this->wpecommerce_orders[$counter]->num_of_products=$actual_number_of_products;
			$this->wpecommerce_orders[$counter]->order_info["UnitsOfMeasureWeight"]=$uom_weight;
			if($dim_unit!="")
			$this->wpecommerce_orders[$counter]->order_info["UnitsOfMeasureLinear"]=$dim_unit;	
			$counter++;
		}
		
	}
	
	################################### Function GetOrdersByDate($datefrom,$dateto) ######################
	//Get orders based on date range
	#######################################################################################################
	function GetOrdersByDate($datefrom,$dateto)
	{
			
			$this->Fetch_DB_Orders($this->DateFrom,$this->DateTo);
			

			if (isset($this->wpecommerce_orders))
				return $this->wpecommerce_orders;
			else
							return array();  
			
	}
	############################################## Function Check_Field #################################
	//Check & Return field value if available
	#######################################################################################################
	function Check_Field($obj,$field)
	{
		if(is_object($obj))
		{
			
			if(null !==($obj->{$field}))
			{
						
				return $obj->{$field};
			}
			else
		   {
				return "";
			}
						
		}
		else if(is_array($obj))
		{
			
			if(null !==($obj[$field]))
			{
						
				return $obj[$field];
			}
			else
		   {
				return "";
			}
						
		}
		else
		{
			return "";
		}
		
	}
	
	################################################ Function PrepareWPecommerceOrderStatusFilter #######################
	//Prepare order status string based on settings
	#######################################################################################################
	function PrepareWPecommerceOrderStatusFilter()
	{
			global $wpdb;
			
			$order_status_filter="";
			
			
			if(WPECOMMERCE_RETRIEVE_ORDER_STATUS_1_ORDER_RECEIVED==1)
			{
				$order_status_filter=$wpdb->prefix . "wpsc_purchase_logs.processed = '2'";
			
			}
			if(WPECOMMERCE_RETRIEVE_ORDER_STATUS_2_ACCEPTED_PAYMENT==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "wpsc_purchase_logs.processed = '3'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "wpsc_purchase_logs.processed = '3'";
				}
			
			}
			if(WPECOMMERCE_RETRIEVE_ORDER_STATUS_3_JOB_DISPATCHED==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "wpsc_purchase_logs.processed = '4'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "wpsc_purchase_logs.processed = '4'";
				}
			
			}
			if(WPECOMMERCE_RETRIEVE_ORDER_STATUS_4_CLOSED_ORDER==1)
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "wpsc_purchase_logs.processed = '5'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "wpsc_purchase_logs.processed = '5'";
				}
			
			}
			
			if(WPECOMMERCE_RETRIEVE_ORDER_STATUS_5_PAYMENT_DECLINED==1 )
			{
				if($order_status_filter=="")
				{
					$order_status_filter.=$wpdb->prefix . "wpsc_purchase_logs.processed = '6'";
				}
				else
				{
					$order_status_filter.=" OR ".$wpdb->prefix . "wpsc_purchase_logs.processed= '6'";
				}
			}
			

			
			if($order_status_filter!="")
			$order_status_filter="( ".$order_status_filter." ) and";
			return $order_status_filter;
			
	}
			
	
}
######################################### End of class SHIPPINGZWPECOMMERCE ###################################################

	// create object & perform tasks based on command

	$obj_shipping_wpecommerce=new SHIPPINGZWPECOMMERCE;
	$obj_shipping_wpecommerce->ExecuteCommand();

?>
